define(['marionette'], function(Marionette) {
  var onClick;
  return Marionette.Controller.extend({
    initialize: function(arg) {
      this.app = arg.app;
    },
    init: function(callback) {
      this.app.menuRegion.reset();
      this.app.userEvents.startNodeConnect(this.app);
      this.hs = null;
      return require(['views/menu', 'views/components/horizontal-swipe'], (function(_this) {
        return function(MenuView, HorizontalSwipe) {
          _this.view = new MenuView({
            app: _this.app,
            id: 'menu',
            type: 'menu'
          });
          _this.app.menuRegion.show(_this.view);
          _this.app.userEvents.nodeConnect(_this.app);
          if (app.getDeviceOs() !== 'unknown') {
            if (_this.hs != null) {
              _this.hs.undelegate();
            }
            _this.hs = new HorizontalSwipe(document.body, {
              onSwipeLeft: function() {
                return _this.close();
              },
              onSwipeRight: function() {
                return _this.open();
              }
            });
          }
          if (callback != null) {
            return callback();
          }
        };
      })(this));
    },
    close: onClick = function(event) {
      if (event != null) {
        event.stopPropagation();
      }
      document.body.classList.remove('menu-opened');
      app.resetLayoutSizes();
      return app.canvasElement.removeEventListener('click', onClick, true);
    },
    open: function() {
      document.body.classList.add('menu-opened');
      return setTimeout(((function(_this) {
        return function() {
          app.resetLayoutSizes();
          return app.canvasElement.addEventListener('click', _this.close, true);
        };
      })(this)), 0);
    },
    openGroup: function(group) {
      return this.view.openGroup(group);
    },
    closeGroup: function(group) {
      return this.view.closeGroup(group);
    },
    reload: function() {
      require.undef('views/menu');
      require.undef('text!templates/menu.tmpl');
      return this.init((function(_this) {
        return function() {
          if (_this.app.config.debug) {
            return console.log("reload menu");
          }
        };
      })(this));
    }
  });
});
