var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['marionette', 'jquery', 'moment'], function(Marionette, $, moment) {
  var PushNotificationsController;
  PushNotificationsController = (function(superClass) {
    extend(PushNotificationsController, superClass);

    function PushNotificationsController() {
      this.wpErrorHandler = bind(this.wpErrorHandler, this);
      this.wpChannelUpdate = bind(this.wpChannelUpdate, this);
      this.wpNotification = bind(this.wpNotification, this);
      this.channelHandler = bind(this.channelHandler, this);
      this.onNotificationGCM = bind(this.onNotificationGCM, this);
      this.gcmRegistrationHandler = bind(this.gcmRegistrationHandler, this);
      this.tokenHandler = bind(this.tokenHandler, this);
      return PushNotificationsController.__super__.constructor.apply(this, arguments);
    }

    PushNotificationsController.prototype.googleSenderId = '1082604119881';

    PushNotificationsController.prototype.initialize = function(arg) {
      this.app = arg.app;
    };

    PushNotificationsController.prototype.init = function() {
      if (app.config.debug) {
        console.log("PushNotifications init: " + (typeof device !== "undefined" && device !== null ? device.platform : void 0));
      }
      return document.addEventListener('deviceready', (function(_this) {
        return function() {
          var err, pushNotification, txt;
          pushNotification = window.PushNotification;
          try {
            if (device.platform === 'android' || device.platform === 'Android' || device.platform === 'amazon-fireos') {
              _this.devicePlatform = device.platform;
              _this.push = pushNotification.init({
                android: {
                  senderID: _this.googleSenderId
                }
              });
              _this.push.on('registration', window.app.pushNotifications.gcmRegistrationHandler);
              _this.push.on('notification', window.app.pushNotifications.onNotificationGCM);
              _this.push.on('error', window.app.pushNotifications.errorHandler);
              if (app.config.debug) {
                console.log("senderId", _this.googleSenderId);
                return console.log(_this.googleSenderId);
              }
            } else if (device.platform === "windows") {
              _this.push = pushNotification.init({
                windows: {
                  channelName: "VircitiesMain"
                }
              });
              _this.push.on('registration', window.app.pushNotifications.channelHandler);
              _this.push.on('notification', window.app.pushNotifications.wpNotification);
              return _this.push.on('error', window.app.pushNotifications.errorHandler);
            } else {
              _this.push = pushNotification.init({
                ios: {
                  badge: 'true',
                  sound: 'true',
                  alert: 'true'
                }
              });
              _this.push.on('registration', window.app.pushNotifications.tokenHandler);
              _this.push.on('notification', window.app.pushNotifications.onNotificationAPN);
              return _this.push.on('error', window.app.pushNotifications.errorHandler);
            }
          } catch (_error) {
            err = _error;
            txt = 'There was an error on this page.\n\n';
            return txt += 'Error description: ' + err.message + '\n\n';
          }
        };
      })(this));
    };

    PushNotificationsController.prototype.tokenHandler = function(result) {
      if (app.config.debug) {
        console.log("tokenHandler: ", result);
      }
      if (result.registrationId.length > 0) {
        return this.saveToken(result.registrationId);
      }
    };

    PushNotificationsController.prototype.gcmRegistrationHandler = function(result) {
      if (result.registrationId.length > 0) {
        return this.saveToken(result.registrationId);
      }
    };

    PushNotificationsController.prototype.errorHandler = function(error) {
      if (app.config.debug) {
        console.log("Error on sending pushNotification");
        return console.log(error);
      }
    };

    PushNotificationsController.prototype.onNotificationAPN = function(e) {
      if (app.config.debug) {
        return console.log("onNotificationAPN");
      }
    };

    PushNotificationsController.prototype.onNotificationGCM = function(e) {
      if (app.config.debug) {
        return console.log('onNotification GCM');
      }
    };

    PushNotificationsController.prototype.channelHandler = function(result) {
      if (app.config.debug) {
        console.log(result);
        console.log('registered###' + result.uri);
      }
      return this.saveToken(result.uri);
    };

    PushNotificationsController.prototype.wpNotification = function(e) {
      if (app.config.debug) {
        console.log('onNotification GCM');
        return console.log(e.event);
      }
    };

    PushNotificationsController.prototype.wpChannelUpdate = function(result) {
      if (app.config.debug) {
        console.log('wpChannelUpdate');
        console.log(result);
      }
      return this.saveToken(result.uri);
    };

    PushNotificationsController.prototype.wpErrorHandler = function(e) {
      if (app.config.debug) {
        return console.log('wpErrorHandler');
      }
    };

    PushNotificationsController.prototype.saveToken = function(token) {
      this.app.server.user.startPushNotifications({
        device_platform: device.platform,
        device_token: token,
        success: (function(_this) {
          return function(data) {
            if (app.config.debug) {
              return console.log("Set up push notifications on server");
            }
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            if (app.config.debug) {
              return console.log("Error on setting up push notifications on server");
            }
          };
        })(this)
      });
      return this.app.server.user.saveUtcOffset({
        utcOffset: moment().utcOffset(),
        success: (function(_this) {
          return function(data) {
            if (app.config.debug) {
              return console.log("Set up user time zone");
            }
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            if (app.config.debug) {
              return console.log("Error on setting up user time zone");
            }
          };
        })(this)
      });
    };

    return PushNotificationsController;

  })(Marionette.Controller);
  return PushNotificationsController;
});
