var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['marionette', 'jquery'], function(Marionette, $) {
  var TutorialController;
  TutorialController = (function(superClass) {
    extend(TutorialController, superClass);

    function TutorialController() {
      this._onLockedReauth = bind(this._onLockedReauth, this);
      this.onConnectionErrorClose = bind(this.onConnectionErrorClose, this);
      this._checkAndSetVisibility = bind(this._checkAndSetVisibility, this);
      this._showTutorModal = bind(this._showTutorModal, this);
      this._hideTutorModal = bind(this._hideTutorModal, this);
      this._onLevelUpPopup = bind(this._onLevelUpPopup, this);
      this._onItemEaten = bind(this._onItemEaten, this);
      this._onFishingCompleted = bind(this._onFishingCompleted, this);
      this._onFight = bind(this._onFight, this);
      this._onItemPutOn = bind(this._onItemPutOn, this);
      this._onItemPurchased = bind(this._onItemPurchased, this);
      this._onCategorySelected = bind(this._onCategorySelected, this);
      this._onFullHealed = bind(this._onFullHealed, this);
      this._onTraumaHealed = bind(this._onTraumaHealed, this);
      this._onTrained = bind(this._onTrained, this);
      this._onQuestCompleted = bind(this._onQuestCompleted, this);
      this._onJobWorkedError = bind(this._onJobWorkedError, this);
      this._onJobWorked = bind(this._onJobWorked, this);
      this._onJobFired = bind(this._onJobFired, this);
      this._onJobHired = bind(this._onJobHired, this);
      this._onQuestTaken = bind(this._onQuestTaken, this);
      this._startInventoryEatTutorial = bind(this._startInventoryEatTutorial, this);
      this._startFishingTutorial = bind(this._startFishingTutorial, this);
      this._startTreatmentTutorial = bind(this._startTreatmentTutorial, this);
      this._startUseRandom = bind(this._startUseRandom, this);
      this._startGangFightTutorial = bind(this._startGangFightTutorial, this);
      this._startQuestFightTutorial = bind(this._startQuestFightTutorial, this);
      this._startNewsTutorial = bind(this._startNewsTutorial, this);
      this._startTraumaTutorial = bind(this._startTraumaTutorial, this);
      this._startQuestTraumaTutorial = bind(this._startQuestTraumaTutorial, this);
      this._startFinalTutorial = bind(this._startFinalTutorial, this);
      this._startTrainingTutorial = bind(this._startTrainingTutorial, this);
      this._startTradeCenterTutorial = bind(this._startTradeCenterTutorial, this);
      this._startQuestTradeCenterTutorial = bind(this._startQuestTradeCenterTutorial, this);
      this._startJobTutorial = bind(this._startJobTutorial, this);
      this._startQuestTutorial = bind(this._startQuestTutorial, this);
      this._startInitialTutorial = bind(this._startInitialTutorial, this);
      this.finish = bind(this.finish, this);
      this.start = bind(this.start, this);
      return TutorialController.__super__.constructor.apply(this, arguments);
    }

    TutorialController.prototype.TUTORIAL_INITIAL = 'initial';

    TutorialController.prototype.TUTORIAL_QUEST = 'quest';

    TutorialController.prototype.TUTORIAL_JOB = 'tutorial_job';

    TutorialController.prototype.TUTORIAL_TRAINING = 'tutorial_training';

    TutorialController.prototype.TUTORIAL_QUEST_TRAUMA = 'tutorial_trauma';

    TutorialController.prototype.TUTORIAL_TRAUMA = 'trauma';

    TutorialController.prototype.TUTORIAL_QUEST_TRADECENTER = 'tutorial_tradecenter';

    TutorialController.prototype.TUTORIAL_TRADECENTER = 'tradecenter';

    TutorialController.prototype.TUTORIAL_QUEST_GANGFIGHT = 'tutorial_gangfight';

    TutorialController.prototype.TUTORIAL_GANGFIGHT = 'gangfight';

    TutorialController.prototype.TUTORIAL_USE_RANDOM = 'useRandom';

    TutorialController.prototype.TUTORIAL_TREATMENT = 'treatment';

    TutorialController.prototype.TUTORIAL_FISHING = 'fishing';

    TutorialController.prototype.TUTORIAL_INVENTORY_EAT = 'inventory_eat';

    TutorialController.prototype.TUTORIAL_FINAL = 'final';

    TutorialController.prototype.TUTORIAL_NEWS = 'news';

    TutorialController.prototype._completedTutorials = [];

    TutorialController.prototype._canSkipTutorial = false;

    TutorialController.prototype._isTutorialActive = false;

    TutorialController.prototype._isTutorialVisible = true;

    TutorialController.prototype.initialize = function(arg) {
      var i, len, openMainScreen, ref, tutorial;
      this.app = arg.app;
      this._tutorials = [this.TUTORIAL_INITIAL, this.TUTORIAL_QUEST, this.TUTORIAL_JOB, this.TUTORIAL_QUEST_TRADECENTER, this.TUTORIAL_TRADECENTER, this.TUTORIAL_QUEST_GANGFIGHT, this.TUTORIAL_GANGFIGHT, this.TUTORIAL_USE_RANDOM, this.TUTORIAL_QUEST_TRAUMA, this.TUTORIAL_TRAUMA, this.TUTORIAL_TRAINING, this.TUTORIAL_NEWS, this.TUTORIAL_FINAL];
      this._startedTutorials = [];
      this._completedTutorials = [];
      this._tutorialCallbacks = {};
      this._tutorialCallbacks[this.TUTORIAL_INITIAL] = this._startInitialTutorial;
      this._tutorialCallbacks[this.TUTORIAL_QUEST] = this._startQuestTutorial;
      this._tutorialCallbacks[this.TUTORIAL_JOB] = this._startJobTutorial;
      this._tutorialCallbacks[this.TUTORIAL_QUEST_TRADECENTER] = this._startQuestTradeCenterTutorial;
      this._tutorialCallbacks[this.TUTORIAL_TRADECENTER] = this._startTradeCenterTutorial;
      this._tutorialCallbacks[this.TUTORIAL_QUEST_GANGFIGHT] = this._startQuestFightTutorial;
      this._tutorialCallbacks[this.TUTORIAL_GANGFIGHT] = this._startGangFightTutorial;
      this._tutorialCallbacks[this.TUTORIAL_USE_RANDOM] = this._startUseRandom;
      this._tutorialCallbacks[this.TUTORIAL_QUEST_TRAUMA] = this._startQuestTraumaTutorial;
      this._tutorialCallbacks[this.TUTORIAL_TRAUMA] = this._startTraumaTutorial;
      this._tutorialCallbacks[this.TUTORIAL_TREATMENT] = this._startTreatmentTutorial;
      this._tutorialCallbacks[this.TUTORIAL_TRAINING] = this._startTrainingTutorial;
      this._tutorialCallbacks[this.TUTORIAL_NEWS] = this._startNewsTutorial;
      this._tutorialCallbacks[this.TUTORIAL_FINAL] = this._startFinalTutorial;
      this._totalTutorialsCount = Object.keys(this._tutorialCallbacks).length;
      this._tutorialSteps = {};
      ref = this._tutorials;
      for (i = 0, len = ref.length; i < len; i++) {
        tutorial = ref[i];
        this._tutorialSteps[tutorial] = {};
      }
      openMainScreen = function(screen, tutorScreen, canSkip) {
        if (canSkip == null) {
          canSkip = null;
        }
        return function() {
          if (canSkip !== null) {
            app.tutorial.setSkipTutorial(canSkip);
          }
          app.tutorial.listenToOnce(app.screens, "view:ready:" + screen, function() {
            app.screens.closeCurrentModals();
            return app.modalDialog.screen(tutorScreen);
          });
          return app.screens.main(screen);
        };
      };
      this._tutorialSteps[this.TUTORIAL_INITIAL][1] = openMainScreen('quests', 'tutor/entrance/entrance-2');
      this._tutorialSteps[this.TUTORIAL_INITIAL][2] = openMainScreen('quests', 'tutor/entrance/entrance-3');
      this._tutorialSteps[this.TUTORIAL_INITIAL][3] = openMainScreen('quests', 'tutor/entrance/entrance-4');
      this._tutorialSteps[this.TUTORIAL_INITIAL][4] = openMainScreen('quests', 'tutor/entrance/entrance-5');
      this._tutorialSteps[this.TUTORIAL_INITIAL][5] = openMainScreen('quests', 'tutor/entrance/entrance-6');
      this._tutorialSteps[this.TUTORIAL_INITIAL][6] = openMainScreen('quests', 'tutor/entrance/entrance-7');
      this._tutorialSteps[this.TUTORIAL_QUEST][1] = openMainScreen('quests', 'tutor/quests/quests-1');
      this._tutorialSteps[this.TUTORIAL_QUEST][2] = function() {
        return app.tutorial.startNextTutorial();
      };
      this._tutorialSteps[this.TUTORIAL_JOB][1] = openMainScreen('quests', 'tutor/job-tutor/job-1');
      this._tutorialSteps[this.TUTORIAL_JOB][2] = openMainScreen('quests', 'tutor/job-tutor/job-2');
      this._tutorialSteps[this.TUTORIAL_JOB][3] = openMainScreen('quests', 'tutor/job-tutor/job-3');
      this._tutorialSteps[this.TUTORIAL_JOB][4] = openMainScreen('job/job-center', 'tutor/job-tutor/job-4');
      this._tutorialSteps[this.TUTORIAL_JOB][5] = openMainScreen('job', 'tutor/job-tutor/job-6');
      this._tutorialSteps[this.TUTORIAL_JOB][6] = openMainScreen('job', 'tutor/job-tutor/job-6');
      this._tutorialSteps[this.TUTORIAL_JOB][8] = openMainScreen('job', 'tutor/job-tutor/job-9');
      this._tutorialSteps[this.TUTORIAL_JOB][9] = openMainScreen('job', 'tutor/job-tutor/job-10');
      this._tutorialSteps[this.TUTORIAL_JOB][10] = openMainScreen('job', 'tutor/job-tutor/job-10');
      this._tutorialSteps[this.TUTORIAL_JOB][11] = function() {
        return app.tutorial.startNextTutorial();
      };
      this._tutorialSteps[this.TUTORIAL_JOB][20] = openMainScreen('job', 'tutor/job-tutor/job-resign-2');
      this._tutorialSteps[this.TUTORIAL_JOB][21] = openMainScreen('job', 'tutor/job-tutor/job-resign-2');
      this._tutorialSteps[this.TUTORIAL_JOB][22] = openMainScreen('job/job-center', 'tutor/job-tutor/job-resign-5');
      this._tutorialSteps[this.TUTORIAL_JOB][23] = openMainScreen('job/job-center', 'tutor/job-tutor/job-resign-5');
      this._tutorialSteps[this.TUTORIAL_JOB][24] = openMainScreen('job', 'tutor/job-tutor/job-6');
      this._tutorialSteps[this.TUTORIAL_QUEST_TRADECENTER][1] = openMainScreen('quests', 'tutor/quests/quests-3');
      this._tutorialSteps[this.TUTORIAL_QUEST_TRADECENTER][2] = openMainScreen('quests', 'tutor/quests/quests-3');
      this._tutorialSteps[this.TUTORIAL_TRADECENTER][1] = openMainScreen('quests', 'tutor/trade/trade-center-1');
      this._tutorialSteps[this.TUTORIAL_TRADECENTER][2] = openMainScreen('quests', 'tutor/trade/trade-center-1');
      this._tutorialSteps[this.TUTORIAL_TRADECENTER][3] = openMainScreen('trade-center', 'tutor/trade/trade-center-4');
      this._tutorialSteps[this.TUTORIAL_TRADECENTER][4] = openMainScreen('trade-center', 'tutor/trade/trade-center-4');
      this._tutorialSteps[this.TUTORIAL_TRADECENTER][5] = openMainScreen('trade-center', 'tutor/trade/trade-center-4');
      this._tutorialSteps[this.TUTORIAL_TRADECENTER][6] = openMainScreen('trade-center', 'tutor/trade/trade-center-4');
      this._tutorialSteps[this.TUTORIAL_TRADECENTER][7] = openMainScreen('trade-center', 'tutor/trade/trade-center-8');
      this._tutorialSteps[this.TUTORIAL_TRADECENTER][8] = openMainScreen('trade-center', 'tutor/trade/trade-center-9');
      this._tutorialSteps[this.TUTORIAL_TRADECENTER][9] = openMainScreen('profile', 'tutor/trade/trade-center-10');
      this._tutorialSteps[this.TUTORIAL_TRADECENTER][10] = openMainScreen('profile', 'tutor/trade/trade-center-11');
      this._tutorialSteps[this.TUTORIAL_TRADECENTER][11] = openMainScreen('profile', 'tutor/trade/trade-center-11');
      this._tutorialSteps[this.TUTORIAL_TRADECENTER][12] = openMainScreen('profile', 'tutor/trade/trade-center-13');
      this._tutorialSteps[this.TUTORIAL_TRADECENTER][13] = openMainScreen('profile', 'tutor/trade/get-award-go');
      this._tutorialSteps[this.TUTORIAL_TRADECENTER][14] = openMainScreen('profile', 'tutor/trade/get-award-go');
      this._tutorialSteps[this.TUTORIAL_TRADECENTER][15] = function() {
        return app.tutorial.startNextTutorial();
      };
      this._tutorialSteps[this.TUTORIAL_TRAINING][1] = openMainScreen('quests', 'tutor/sport-tutor/sport-1');
      this._tutorialSteps[this.TUTORIAL_TRAINING][2] = openMainScreen('quests', 'tutor/sport-tutor/sport-4');
      this._tutorialSteps[this.TUTORIAL_TRAINING][3] = openMainScreen('quests', 'tutor/sport-tutor/sport-4');
      this._tutorialSteps[this.TUTORIAL_TRAINING][4] = openMainScreen('stadium', 'tutor/sport-tutor/sport-5');
      this._tutorialSteps[this.TUTORIAL_TRAINING][5] = openMainScreen('stadium', 'tutor/sport-tutor/sport-7');
      this._tutorialSteps[this.TUTORIAL_TRAINING][6] = openMainScreen('stadium', 'tutor/sport-tutor/sport-7');
      this._tutorialSteps[this.TUTORIAL_TRAINING][7] = openMainScreen('stadium', 'tutor/sport-tutor/sport-8');
      this._tutorialSteps[this.TUTORIAL_TRAINING][8] = openMainScreen('stadium', 'tutor/sport-tutor/sport-9');
      this._tutorialSteps[this.TUTORIAL_TRAINING][9] = openMainScreen('quests', 'tutor/sport-tutor/sport-10');
      this._tutorialSteps[this.TUTORIAL_TRAINING][10] = openMainScreen('quests', 'tutor/sport-tutor/sport-10');
      this._tutorialSteps[this.TUTORIAL_TRAINING][11] = function() {
        return app.tutorial.startNextTutorial();
      };
      this._tutorialSteps[this.TUTORIAL_NEWS][1] = openMainScreen('quests', 'tutor/news/news-1');
      this._tutorialSteps[this.TUTORIAL_NEWS][2] = function() {
        return app.tutorial.startNextTutorial();
      };
      this._tutorialSteps[this.TUTORIAL_FINAL][1] = openMainScreen('news/latest', 'tutor/final-tutor/final-1', false);
      this._tutorialSteps[this.TUTORIAL_FINAL][2] = openMainScreen('news/latest', 'tutor/final-tutor/final-1', false);
      this._tutorialSteps[this.TUTORIAL_FINAL][3] = openMainScreen('news/latest', 'tutor/final-tutor/final-1', false);
      this._tutorialSteps[this.TUTORIAL_QUEST_TRAUMA][1] = openMainScreen('quests', 'tutor/quests/quests-5');
      this._tutorialSteps[this.TUTORIAL_QUEST_TRAUMA][2] = openMainScreen('quests', 'tutor/quests/quests-5');
      this._tutorialSteps[this.TUTORIAL_TRAUMA][1] = openMainScreen('quests', 'tutor/injury-5');
      this._tutorialSteps[this.TUTORIAL_TRAUMA][2] = openMainScreen('hospital', 'tutor/injury-6');
      this._tutorialSteps[this.TUTORIAL_TRAUMA][3] = openMainScreen('hospital', 'tutor/injury-7');
      this._tutorialSteps[this.TUTORIAL_TRAUMA][4] = openMainScreen('hospital', 'tutor/injury-8');
      this._tutorialSteps[this.TUTORIAL_TRAUMA][5] = openMainScreen('quests', 'tutor/injury-9');
      this._tutorialSteps[this.TUTORIAL_TRAUMA][6] = openMainScreen('quests', 'tutor/injury-10');
      this._tutorialSteps[this.TUTORIAL_TRAUMA][7] = function() {
        return app.tutorial.startNextTutorial();
      };
      this._tutorialSteps[this.TUTORIAL_QUEST_GANGFIGHT][1] = openMainScreen('quests', 'tutor/fight-tutor/quests-fight');
      this._tutorialSteps[this.TUTORIAL_GANGFIGHT][1] = openMainScreen('quests', 'tutor/fight-tutor/fight-2');
      this._tutorialSteps[this.TUTORIAL_GANGFIGHT][2] = openMainScreen('military-base/gangs', 'tutor/fight-tutor/fight-4');
      this._tutorialSteps[this.TUTORIAL_GANGFIGHT][3] = openMainScreen('military-base/gangs', 'tutor/fight-tutor/fight-4');
      this._tutorialSteps[this.TUTORIAL_GANGFIGHT][4] = openMainScreen('military-base/gangs', 'tutor/fight-tutor/fight-5');
      this._tutorialSteps[this.TUTORIAL_GANGFIGHT][5] = openMainScreen('military-base/gangs', 'tutor/fight-tutor/fight-5');
      this._tutorialSteps[this.TUTORIAL_GANGFIGHT][6] = openMainScreen('military-base/gangs', 'tutor/fight-tutor/fight-5');
      this._tutorialSteps[this.TUTORIAL_GANGFIGHT][7] = openMainScreen('military-base/gangs', 'tutor/fight-tutor/fight-completed');
      this._tutorialSteps[this.TUTORIAL_GANGFIGHT][8] = openMainScreen('military-base/gangs', 'tutor/fight-tutor/fight-completed');
      this._tutorialSteps[this.TUTORIAL_GANGFIGHT][9] = openMainScreen('military-base/gangs', 'tutor/fight-tutor/fight-completed');
      this._tutorialSteps[this.TUTORIAL_GANGFIGHT][10] = openMainScreen('military-base/gangs', 'tutor/fight-tutor/fight-completed');
      this._tutorialSteps[this.TUTORIAL_GANGFIGHT][11] = openMainScreen('military-base/gangs', 'tutor/fight-tutor/fight-completed');
      this._tutorialSteps[this.TUTORIAL_GANGFIGHT][12] = openMainScreen('military-base/gangs', 'tutor/fight-tutor/quest-fight-move');
      this._tutorialSteps[this.TUTORIAL_GANGFIGHT][13] = openMainScreen('quests', 'tutor/fight-tutor/quest-fight-complete');
      this._tutorialSteps[this.TUTORIAL_GANGFIGHT][14] = function() {
        return app.tutorial.startNextTutorial();
      };
      this._tutorialSteps[this.TUTORIAL_USE_RANDOM][1] = openMainScreen('quests', 'tutor/fight-tutor/fight-go-to-inventory');
      this._tutorialSteps[this.TUTORIAL_USE_RANDOM][2] = openMainScreen('profile', 'tutor/fight-tutor/fight-in-inventory');
      this._tutorialSteps[this.TUTORIAL_USE_RANDOM][3] = openMainScreen('profile', 'tutor/fight-tutor/fight-in-inventory');
      this._tutorialSteps[this.TUTORIAL_USE_RANDOM][4] = function() {
        return app.tutorial.startNextTutorial();
      };
      this._tradeCenterItemTypes = ['armorBody', 'armorHead', 'armorLegs', 'armorBoots', 'closeRangeWeapon', 'weapon', 'ammunition', 'jewelry', 'clothes'];
      this._userFightsCount = 0;
      return this._fightsToCompleteTutorial = 3;
    };

    TutorialController.prototype.start = function() {
      var activeTutorial, step, tUserId;
      activeTutorial = localStorage.getItem('tutorial_active_tutorial');
      tUserId = Number(localStorage.getItem('tutorial_user_id'));
      step = Number(localStorage.getItem('tutorial_step'));
      this._reset();
      this._unbindEvents();
      if (activeTutorial && tUserId === app.userId) {
        this._isTutorialActive = true;
        this._bindEvents();
        return this.startFromStep(activeTutorial, step);
      } else {
        this._clearStep();
        return this.app.server.user.take_tutorial({
          success: (function(_this) {
            return function() {
              _this._isTutorialActive = true;
              _this._bindEvents();
              return _this.startNextTutorial();
            };
          })(this),
          error: (function(_this) {
            return function() {
              return _this.finish();
            };
          })(this)
        });
      }
    };

    TutorialController.prototype.doIt = function() {
      var tutorContainer;
      tutorContainer = document.querySelector('#js-modal-container');
      return setInterval(function() {
        var el;
        el = document.querySelector('.js-next-screen');
        if (el && el.clientHeight > 0) {
          return el.click();
        } else if (tutorContainer && !tutorContainer.classList.contains('is-hidden')) {
          el = tutorContainer.querySelector('.o-click-area');
          if (el) {
            return el.click();
          }
        }
      }, 1000);
    };

    TutorialController.prototype._reset = function() {
      this._startedTutorials = [];
      this._completedTutorials = [];
      this._userFightsCount = 0;
      this._fightsToCompleteTutorial = 3;
      this._isTutorialActive = false;
      return this._canSkipTutorial = false;
    };

    TutorialController.prototype.hasUnfinishedSteps = function() {
      var activeTutorial, tUserId;
      activeTutorial = localStorage.getItem('tutorial_active_tutorial');
      tUserId = Number(localStorage.getItem('tutorial_user_id'));
      return !!activeTutorial && tUserId === app.userId;
    };

    TutorialController.prototype.saveStep = function(tutor, step) {
      localStorage.setItem('tutorial_active_tutorial', tutor);
      localStorage.setItem('tutorial_user_id', app.userId);
      localStorage.setItem('tutorial_step', step);
      return true;
    };

    TutorialController.prototype._clearStep = function() {
      localStorage.removeItem('tutorial_active_tutorial');
      localStorage.removeItem('tutorial_user_id');
      return localStorage.removeItem('tutorial_step');
    };

    TutorialController.prototype.startFromStep = function(tutor, step) {
      var i, len, ref, tutorial;
      ref = this._tutorials;
      for (i = 0, len = ref.length; i < len; i++) {
        tutorial = ref[i];
        if (tutorial === this.TUTORIAL_QUEST_TRADECENTER) {
          this.setSkipTutorial(true);
        }
        if (tutorial === this.TUTORIAL_FINAL) {
          this.setSkipTutorial(false);
        }
        this._startedTutorials.push(tutorial);
        if (tutorial === tutor) {
          break;
        }
        this._completedTutorials.push(tutorial);
      }
      if (this._tutorialSteps[tutor] && this._tutorialSteps[tutor][step]) {
        return this._tutorialSteps[tutor][step]();
      } else {
        return this.startNextTutorial();
      }
    };

    TutorialController.prototype.finish = function() {
      this._isTutorialActive = false;
      this._clearStep();
      this._reset();
      this._unbindEvents();
      app.modalDialog.close();
      return app.screens._cache = {};
    };

    TutorialController.prototype.setSkipTutorial = function(skip) {
      return this._canSkipTutorial = skip;
    };

    TutorialController.prototype.canSkipTutorial = function() {
      return this._canSkipTutorial;
    };

    TutorialController.prototype.skipTutorial = function() {
      this.finish();
      localStorage.setItem('tutorial_skipped', 1);
      return app.menu.reload();
    };

    TutorialController.prototype.isActive = function() {
      return !!this._isTutorialActive;
    };

    TutorialController.prototype.completeTutorial = function(tutorial) {
      if (this._completedTutorials.indexOf(tutorial) === -1) {
        this._completedTutorials.push(tutorial);
      }
      if (this._completedTutorials.length >= this._totalTutorialsCount) {
        return this.finish();
      }
    };

    TutorialController.prototype.checkCompleted = function(tutorial) {
      return !(this._completedTutorials.indexOf(tutorial) === -1);
    };

    TutorialController.prototype.checkStarted = function(tutorial) {
      return !(this._startedTutorials.indexOf(tutorial) === -1);
    };

    TutorialController.prototype.checkInProgress = function(tutorial) {
      return this.checkStarted(tutorial) && !this.checkCompleted(tutorial);
    };

    TutorialController.prototype.checkAvailableQuest = function(quest_cid) {
      return this._availableQuests.indexOf(quest_cid) !== -1;
    };

    TutorialController.prototype.setAvailableQuest = function(quest_cid) {
      if (this._availableQuests.indexOf(quest_cid) === -1) {
        return this._availableQuests.push(quest_cid);
      }
    };

    TutorialController.prototype.getNextTutorial = function() {
      var i, len, ref, tutorial;
      ref = this._tutorials;
      for (i = 0, len = ref.length; i < len; i++) {
        tutorial = ref[i];
        if (this._completedTutorials.indexOf(tutorial) === -1) {
          return tutorial;
        }
      }
      return false;
    };

    TutorialController.prototype.startNextTutorial = function() {
      var next;
      next = this.getNextTutorial();
      if (next && this._tutorialCallbacks.hasOwnProperty(next)) {
        this.saveStep(next, 1);
        return this._tutorialCallbacks[next]();
      }
    };

    TutorialController.prototype._startNextTutorialWhenQuestAvailable = function(cid, checkTutorial) {
      if (checkTutorial == null) {
        checkTutorial = null;
      }
      if (checkTutorial === null) {
        checkTutorial = cid;
      }
      return app.quests.whenQuestAvailable(cid).then((function(_this) {
        return function() {
          if (_this.getNextTutorial() === checkTutorial) {
            return _this.startNextTutorial();
          }
        };
      })(this));
    };

    TutorialController.prototype._startInitialTutorial = function() {
      this.saveStep(this.TUTORIAL_INITIAL, 1);
      this._startedTutorials.push(this.TUTORIAL_INITIAL);
      this.listenToOnce(app.screens, 'view:ready:tutor-blank-start', function() {
        return app.modalDialog.screen('tutor');
      });
      return this.app.screens.main('tutor-blank-start');
    };

    TutorialController.prototype._startQuestTutorial = function() {
      if (this.app.config.googleAnalyticsEnabled && this.app.ga) {
        this.app.ga('send', 'tutorpageview', {
          page: '/scr/quests'
        });
      }
      this.saveStep(this.TUTORIAL_QUEST, 1);
      this._startedTutorials.push(this.TUTORIAL_QUEST);
      this.listenToOnce(app.screens, 'view:ready:quests', function() {
        return app.modalDialog.screen('tutor/quests/quests-1');
      });
      return app.screens.main('quests');
    };

    TutorialController.prototype._startJobTutorial = function() {
      if (this.app.config.googleAnalyticsEnabled && this.app.ga) {
        this.app.ga('send', 'tutorpageview', {
          page: '/scr/job'
        });
      }
      this.saveStep(this.TUTORIAL_JOB, 1);
      this._startedTutorials.push(this.TUTORIAL_JOB);
      this.listenToOnce(app.screens, 'view:ready:quests', function() {
        return app.modalDialog.screen('tutor/job-tutor/job-1');
      });
      return app.screens.main('quests');
    };

    TutorialController.prototype._startQuestTradeCenterTutorial = function() {
      if (this.app.config.googleAnalyticsEnabled && this.app.ga) {
        this.app.ga('send', 'tutorpageview', {
          page: '/scr/trade-center'
        });
      }
      this.saveStep(this.TUTORIAL_QUEST_TRADECENTER, 1);
      this._startedTutorials.push(this.TUTORIAL_QUEST_TRADECENTER);
      this.listenToOnce(app.screens, 'view:ready:quests', function() {
        return app.modalDialog.screen('tutor/quests/quests-3');
      });
      return app.screens.main('quests');
    };

    TutorialController.prototype._startTradeCenterTutorial = function() {
      this.saveStep(this.TUTORIAL_TRADECENTER, 1);
      this._startedTutorials.push(this.TUTORIAL_TRADECENTER);
      this.listenToOnce(app.screens, 'view:ready:quests', function() {
        return app.modalDialog.screen('tutor/trade/trade-center-1');
      });
      return app.screens.main('quests');
    };

    TutorialController.prototype._startTrainingTutorial = function() {
      if (this.app.config.googleAnalyticsEnabled && this.app.ga) {
        this.app.ga('send', 'tutorpageview', {
          page: '/scr/stadium'
        });
      }
      this.saveStep(this.TUTORIAL_TRAINING, 1);
      this._startedTutorials.push(this.TUTORIAL_TRAINING);
      this.listenToOnce(app.screens, 'view:ready:quests', function() {
        return app.modalDialog.screen('tutor/sport-tutor/sport-1');
      });
      return app.screens.main('quests');
    };

    TutorialController.prototype._startFinalTutorial = function() {
      this.setSkipTutorial(false);
      this.saveStep(this.TUTORIAL_FINAL, 1);
      this._startedTutorials.push(this.TUTORIAL_FINAL);
      this.listenToOnce(app.screens, 'view:ready:news/latest', function() {
        return app.modalDialog.screen('tutor/final-tutor/final-1');
      });
      if (app.screens.current) {
        app.screens.current.lockUI();
      }
      return app.screens.main('news/latest');
    };

    TutorialController.prototype._startQuestTraumaTutorial = function() {
      this.saveStep(this.TUTORIAL_QUEST_TRAUMA, 1);
      this._startedTutorials.push(this.TUTORIAL_QUEST_TRAUMA);
      this.listenToOnce(app.screens, 'view:ready:quests', function() {
        return app.modalDialog.screen('tutor/quests/quests-5');
      });
      if (app.screens.current) {
        app.screens.current.lockUI();
      }
      return app.screens.main('quests');
    };

    TutorialController.prototype._startTraumaTutorial = function() {
      this.saveStep(this.TUTORIAL_TRAUMA, 1);
      this._startedTutorials.push(this.TUTORIAL_TRAUMA);
      this.listenToOnce(app.screens, 'view:ready:quests', function() {
        return app.modalDialog.screen('tutor/injury-5');
      });
      if (app.screens.current) {
        app.screens.current.lockUI();
      }
      return app.screens.main('quests');
    };

    TutorialController.prototype._startNewsTutorial = function() {
      this.saveStep(this.TUTORIAL_NEWS, 1);
      this._startedTutorials.push(this.TUTORIAL_NEWS);
      this.listenToOnce(app.screens, 'view:ready:quests', function() {
        return app.modalDialog.screen('tutor/news/news-1');
      });
      if (app.screens.current) {
        app.screens.current.lockUI();
      }
      return app.screens.main('quests');
    };

    TutorialController.prototype._startQuestFightTutorial = function() {
      this.saveStep(this.TUTORIAL_QUEST_GANGFIGHT, 1);
      this._startedTutorials.push(this.TUTORIAL_QUEST_GANGFIGHT);
      this.listenToOnce(app.screens, 'view:ready:quests', function() {
        return app.modalDialog.screen('tutor/fight-tutor/quests-fight');
      });
      if (app.screens.current) {
        app.screens.current.lockUI();
      }
      return app.screens.main('quests');
    };

    TutorialController.prototype._startGangFightTutorial = function() {
      if (this.app.config.googleAnalyticsEnabled && this.app.ga) {
        this.app.ga('send', 'tutorpageview', {
          page: '/scr/military-base/gangs'
        });
      }
      this.saveStep(this.TUTORIAL_GANGFIGHT, 1);
      this._startedTutorials.push(this.TUTORIAL_GANGFIGHT);
      this.listenToOnce(app.screens, 'view:ready:quests', function() {
        return app.modalDialog.screen('tutor/fight-tutor/fight-2');
      });
      if (app.screens.current) {
        app.screens.current.lockUI();
      }
      return app.screens.main('quests');
    };

    TutorialController.prototype._startUseRandom = function() {
      this.saveStep(this.TUTORIAL_USE_RANDOM, 1);
      this._startedTutorials.push(this.TUTORIAL_USE_RANDOM);
      this.listenToOnce(app.screens, 'view:ready:quests', function() {
        return app.modalDialog.screen('tutor/fight-tutor/fight-go-to-inventory');
      });
      if (app.screens.current) {
        app.screens.current.lockUI();
      }
      return app.screens.main('quests');
    };

    TutorialController.prototype._startTreatmentTutorial = function() {
      if (this.app.config.googleAnalyticsEnabled && this.app.ga) {
        this.app.ga('send', 'tutorpageview', {
          page: '/scr/hospital'
        });
      }
      this.saveStep(this.TUTORIAL_TREATMENT, 1);
      this._startedTutorials.push(this.TUTORIAL_TREATMENT);
      return this.app.modalDialog.screen('tutor/treatment-1');
    };

    TutorialController.prototype._startFishingTutorial = function() {
      this.saveStep(this.TUTORIAL_FISHING, 1);
      this._startedTutorials.push(this.TUTORIAL_FISHING);
      return this.app.modalDialog.screen('tutor/port-1');
    };

    TutorialController.prototype._startInventoryEatTutorial = function() {
      this.saveStep(this.TUTORIAL_INVENTORY_EAT, 1);
      this._startedTutorials.push(this.TUTORIAL_INVENTORY_EAT);
      return this.app.modalDialog.screen('tutor/eat-1');
    };

    TutorialController.prototype._bindEvents = function() {
      app.vent.on('job:hired', this._onJobHired);
      app.vent.on('job:fired', this._onJobFired);
      app.vent.on('job:worked', this._onJobWorked);
      app.vent.on('job:worked:error', this._onJobWorkedError);
      app.vent.on('quests:quest_taken', this._onQuestTaken);
      app.vent.on('quests:quest_completed', this._onQuestCompleted);
      app.vent.on('stadium:trained', this._onTrained);
      app.vent.on('hospital:full_healed', this._onFullHealed);
      app.vent.on('hospital:trauma_healed', this._onTraumaHealed);
      app.vent.on('trade-center:category_selected', this._onCategorySelected);
      app.vent.on('trade-center:item_purchased', this._onItemPurchased);
      app.vent.on('trade-center:item_put_on', this._onItemPutOn);
      app.vent.on('military-base:gangs_fought', this._onFight);
      app.vent.on('port:fishing_completed', this._onFishingCompleted);
      app.vent.on('inventory:item_eaten', this._onItemEaten);
      app.vent.on('levelup:popup', this._onLevelUpPopup);
      app.menu.view.on('render', this._setPulsate);
      app.shortInfo.view.on('render', this._setPulsate);
      app.screens.on('view:render', this._setPulsate);
      app.vent.on('popup:connection_error:open', this._hideTutorModal);
      app.vent.on('popup:connection_error:close', this.onConnectionErrorClose);
      app.server.on('app:locked', this._hideTutorModal);
      return app.vent.on('app:locked:reauth', this._onLockedReauth);
    };

    TutorialController.prototype._unbindEvents = function() {
      app.vent.off('job:hired', this._onJobHired);
      app.vent.off('job:fired', this._onJobFired);
      app.vent.off('job:worked', this._onJobWorked);
      app.vent.off('job:worked:error', this._onJobWorkedError);
      app.vent.off('quests:quest_taken', this._onQuestTaken);
      app.vent.off('quests:quest_completed', this._onQuestCompleted);
      app.vent.off('stadium:trained', this._onTrained);
      app.vent.off('hospital:full_healed', this._onFullHealed);
      app.vent.off('hospital:trauma_healed', this._onTraumaHealed);
      app.vent.off('trade-center:item_purchased', this._onItemPurchased);
      app.vent.off('trade-center:item_put_on', this._onItemPutOn);
      app.vent.off('military-base:gangs_fought', this._onFight);
      app.vent.off('port:fishing_completed', this._onFishingCompleted);
      app.vent.off('inventory:item_eaten', this._onItemEaten);
      app.vent.off('levelup:popup', this._onLevelUpPopup);
      app.menu.view.off('render', this._setPulsate);
      app.shortInfo.view.off('render', this._setPulsate);
      app.vent.off('popup:connection_error:open', this._hideTutorModal);
      app.vent.off('popup:connection_error:close', this._showTutorModal);
      app.server.off('app:locked', this._hideTutorModal);
      return app.vent.off('app:locked:reauth', this._onLockedReauth);
    };

    TutorialController.prototype._onQuestTaken = function(event) {
      console.log('Taken:');
      console.log(event.data);
      if (event.data.cid === 'tutorial_job' && !this.checkCompleted(this.TUTORIAL_JOB)) {
        this.completeTutorial(this.TUTORIAL_QUEST);
        this._startJobTutorial();
      }
      if (event.data.cid === 'tutorial_training' && !this.checkCompleted(this.TUTORIAL_TRAINING)) {
        this.listenToOnce(app.screens, 'view:ready:quests', function() {
          return app.modalDialog.screen('tutor/sport-tutor/sport-4');
        });
      }
      if (event.data.cid === 'tutorial_tradecenter' && !this.checkCompleted(this.TUTORIAL_QUEST_TRADECENTER)) {
        this.completeTutorial(this.TUTORIAL_QUEST_TRADECENTER);
        this._startTradeCenterTutorial();
      }
      if (event.data.cid === 'tutorial_gangfight' && !this.checkCompleted(this.TUTORIAL_GANGFIGHT)) {
        this.completeTutorial(this.TUTORIAL_QUEST_GANGFIGHT);
        this._startGangFightTutorial();
      }
      if (event.data.cid === 'tutorial_trauma' && !this.checkCompleted(this.TUTORIAL_QUEST_TRAUMA)) {
        this.completeTutorial(this.TUTORIAL_QUEST_TRAUMA);
        this._startTraumaTutorial();
      }
      if (event.data.cid === 'tutorial_fishing' && !this.checkCompleted(this.TUTORIAL_FISHING)) {
        return this._startFishingTutorial();
      }
    };

    TutorialController.prototype._onJobHired = function() {
      if (!this.checkCompleted(this.TUTORIAL_JOB)) {
        this.saveStep(this.TUTORIAL_JOB, 5);
        return this.listenToOnce(app.screens, 'view:ready:job', function() {
          return app.modalDialog.screen('tutor/job-tutor/job-6');
        });
      }
    };

    TutorialController.prototype._onJobFired = function() {
      if (!this.checkCompleted(this.TUTORIAL_JOB)) {
        app.screens.closeCurrentModals();
        this.listenToOnce(app.screens, 'view:ready:job/job-center', function() {
          return app.modalDialog.screen('tutor/job-tutor/job-resign-5');
        });
        return app.screens.main('job/job-center');
      }
    };

    TutorialController.prototype._onJobWorked = function() {
      if (!this.checkCompleted(this.TUTORIAL_JOB)) {
        return this.listenToOnce(app.screens, 'view:ready:job/job-done', function() {
          return app.modalDialog.screen('tutor/job-tutor/job-8');
        });
      }
    };

    TutorialController.prototype._onJobWorkedError = function() {
      if (!this.checkCompleted(this.TUTORIAL_JOB)) {
        return this.listenToOnce(app.screens, 'view:ready:common/info-popup', function() {
          return app.modalDialog.screen('tutor/job-tutor/job-resign-1');
        });
      }
    };

    TutorialController.prototype._onQuestCompleted = function(event) {
      if (event.data.cid === 'tutorial_job' && !this.checkCompleted(this.TUTORIAL_JOB)) {
        this.completeTutorial(this.TUTORIAL_JOB);
        this._startNextTutorialWhenQuestAvailable(this.TUTORIAL_QUEST_TRADECENTER);
      }
      if (event.data.cid === 'tutorial_tradecenter' && !this.checkCompleted(this.TUTORIAL_TRADECENTER)) {
        this.completeTutorial(this.TUTORIAL_TRADECENTER);
        this._startNextTutorialWhenQuestAvailable(this.TUTORIAL_QUEST_GANGFIGHT);
      }
      if (event.data.cid === 'tutorial_gangfight' && !this.checkCompleted(this.TUTORIAL_GANGFIGHT)) {
        this.completeTutorial(this.TUTORIAL_GANGFIGHT);
        this.startNextTutorial();
      }
      if (event.data.cid === 'tutorial_trauma' && !this.checkCompleted(this.TUTORIAL_TRAUMA)) {
        this.completeTutorial(this.TUTORIAL_TRAUMA);
        this._startNextTutorialWhenQuestAvailable(this.TUTORIAL_TRAINING);
      }
      if (event.data.cid === 'tutorial_training' && !this.checkCompleted(this.TUTORIAL_TRAINING)) {
        this.completeTutorial(this.TUTORIAL_TRAINING);
        return this.startNextTutorial();
      }
    };

    TutorialController.prototype._onTrained = function(event) {
      if (this.checkInProgress(this.TUTORIAL_TRAINING)) {
        return this.saveStep(this.TUTORIAL_TRAINING, 5);
      }
    };

    TutorialController.prototype._onTraumaHealed = function() {
      if (this.checkInProgress(this.TUTORIAL_TRAUMA)) {
        this.saveStep(this.TUTORIAL_TRAUMA, 3);
        return app.modalDialog.screen('tutor/injury-7');
      }
    };

    TutorialController.prototype._onFullHealed = function() {
      if (this.checkInProgress(this.TUTORIAL_TRAUMA)) {
        this.saveStep(this.TUTORIAL_TRAUMA, 4);
        return app.modalDialog.screen('tutor/injury-8');
      }
    };

    TutorialController.prototype._onCategorySelected = function(event) {
      if (this.checkInProgress(this.TUTORIAL_TRADECENTER) && this._tradeCenterItemTypes.indexOf(event.type) !== -1) {
        return this.listenToOnce(app.screens, 'view:ready:trade-center/items-buy-grouped', function() {
          return app.modalDialog.screen('tutor/trade/trade-center-5');
        });
      }
    };

    TutorialController.prototype._onItemPurchased = function(event) {
      var type;
      type = event.data.type_alias;
      if (this._tradeCenterItemTypes.indexOf(type) !== -1 && this.checkInProgress(this.TUTORIAL_TRADECENTER)) {
        this.saveStep(this.TUTORIAL_TRADECENTER, 7);
        return this.listenToOnce(app.screens, 'view:ready:common/info-popup', function() {
          return app.modalDialog.screen('tutor/trade/trade-center-8');
        });
      }
    };

    TutorialController.prototype._onItemPutOn = function(event) {
      var type;
      type = event.itemType;
      if (this._tradeCenterItemTypes.indexOf(type) !== -1 && this.checkInProgress(this.TUTORIAL_TRADECENTER)) {
        this.saveStep(this.TUTORIAL_TRADECENTER, 12);
        return this.listenToOnce(app.screens, 'view:ready:profile', function() {
          return app.modalDialog.screen('tutor/trade/trade-center-13');
        });
      }
    };

    TutorialController.prototype._onFight = function(event) {
      var ref, ref1, ref2, wins;
      if (this.checkInProgress(this.TUTORIAL_GANGFIGHT)) {
        wins = (ref = event.data) != null ? (ref1 = ref.progress) != null ? (ref2 = ref1[0].wins) != null ? ref2[0] : void 0 : void 0 : void 0;
        if (wins < this._fightsToCompleteTutorial) {
          return this.listenToOnce(app.screens, 'view:ready:military-base/fight-result-popup', function() {
            return app.modalDialog.screen('tutor/fight-tutor/fight-repeat', {
              wins: wins
            });
          });
        } else {
          return this.listenToOnce(app.screens, 'view:ready:military-base/fight-result-popup', function() {
            return app.modalDialog.screen('tutor/fight-tutor/fight-log', {
              wins: wins
            });
          });
        }
      }
    };

    TutorialController.prototype._onFishingCompleted = function() {
      if (this.checkInProgress(this.TUTORIAL_FISHING)) {
        this.completeTutorial(this.TUTORIAL_FISHING);
        return app.modalDialog.screen('tutor/port-4');
      }
    };

    TutorialController.prototype._onItemEaten = function() {
      if (this.checkInProgress(this.TUTORIAL_INVENTORY_EAT)) {
        return this.completeTutorial(this.TUTORIAL_INVENTORY_EAT);
      }
    };

    TutorialController.prototype._onLevelUpPopup = function() {
      if (this.checkInProgress(this.TUTORIAL_TRAINING)) {
        return this.listenToOnce(app.screens, 'view:ready:common/level-up-first-popup', function() {
          return app.modalDialog.screen('tutor/sport-tutor/sport-6');
        });
      }
    };

    TutorialController.prototype._setPulsate = function() {
      if (app.modalDialog && app.modalDialog.modalView && app.modalDialog.modalView.isDestroyed === false) {
        return app.modalDialog.modalView.render();
      }
    };

    TutorialController.prototype._hideTutorModal = function() {
      this._isTutorialVisible = false;
      return app.modalDialog.hide();
    };

    TutorialController.prototype._showTutorModal = function() {
      this._isTutorialVisible = true;
      return app.modalDialog.show();
    };

    TutorialController.prototype._checkAndSetVisibility = function() {
      if (this._isTutorialVisible === false) {
        return this._hideTutorModal();
      }
    };

    TutorialController.prototype.onConnectionErrorClose = function() {
      return this.start();
    };

    TutorialController.prototype._onLockedReauth = function() {
      return this._isTutorialVisible = true;
    };

    return TutorialController;

  })(Marionette.Controller);
  return TutorialController;
});
