var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app'], function(app) {
  var LevelAccess, LevelAccessConfig;
  LevelAccess = (function(superClass) {
    extend(LevelAccess, superClass);

    LevelAccess.prototype.defaults = function() {
      return {
        id: null,
        level: null,
        action: null
      };
    };

    function LevelAccess(options) {
      LevelAccess.__super__.constructor.call(this, options);
    }

    return LevelAccess;

  })(Backbone.Model);
  LevelAccessConfig = (function(superClass) {
    extend(LevelAccessConfig, superClass);

    function LevelAccessConfig() {
      return LevelAccessConfig.__super__.constructor.apply(this, arguments);
    }

    LevelAccessConfig.prototype.model = LevelAccess;

    LevelAccessConfig.prototype.isAvailable = function(level, action) {
      var levelAccess;
      levelAccess = this.findWhere({
        action: action
      });
      if (levelAccess != null) {
        return level >= levelAccess.get('level');
      } else {
        return true;
      }
    };

    LevelAccessConfig.prototype.availableFrom = function(action) {
      var levelAccess;
      levelAccess = this.findWhere({
        action: action
      });
      if (levelAccess != null) {
        return levelAccess.get('level');
      } else {
        return 0;
      }
    };

    return LevelAccessConfig;

  })(Backbone.Collection);
  return LevelAccessConfig;
});
