define(['services/social/fb', 'services/social/vk', 'services/social/google'], function(FBProvider, VKProvider, GoogleProvider) {
  var Social;
  Social = (function() {
    Social.prototype._configs = {};

    function Social(configs, serverUrl, serverProtocol) {
      var config, type;
      this._configs = {};
      for (type in configs) {
        config = configs[type];
        config.serverUrl = serverUrl;
        config.serverProtocol = serverProtocol;
        this._configs[type] = config;
      }
      this._providers = {
        'fb': new FBProvider('fb', this._configs['fb']),
        'vk': new VKProvider('vk', this._configs['vk']),
        'google': new GoogleProvider('google', this._configs['google'])
      };
    }

    Social.prototype.getProvider = function(name) {
      if (this._providers[name] != null) {
        return this._providers[name];
      }
    };

    return Social;

  })();
  return Social;
});
