var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['jquery', 'services/social/base'], function($, BaseProvider) {
  var GoogleProvider;
  GoogleProvider = (function(superClass) {
    extend(GoogleProvider, superClass);

    function GoogleProvider(type, config) {
      this.wallPost = bind(this.wallPost, this);
      this.share = bind(this.share, this);
      GoogleProvider.__super__.constructor.call(this, type, config);
      this._storageKey = 'social_data_google';
      this._tokenUri = 'https://accounts.google.com/o/oauth2/auth';
      this._methodUri = 'https://www.googleapis.com/';
      this._scopeMapping = {};
      this._scopeMapping[this.SCOPE_ID] = 'https://www.googleapis.com/auth/plus.login';
      this._scopeMapping[this.SCOPE_NAME] = 'https://www.googleapis.com/auth/plus.me';
      this._scopeMapping[this.SCOPE_GENDER] = 'https://www.googleapis.com/auth/plus.login';
      this._scopeMapping[this.SCOPE_EMAIL] = 'https://www.googleapis.com/auth/userinfo.email';
      this._scopeMapping[this.SCOPE_FRIENDS] = 'https://www.googleapis.com/auth/userinfo.profile';
      this._scopeMapping[this.SCOPE_WALL] = 'https://www.googleapis.com/auth/plus.stream.write';
      this._scopeMapping[this.SCOPE_MESSAGES] = 'https://www.googleapis.com/auth/plus.stream.write';
      this._scopeDelimiter = ' ';
      this._addTokenData = {
        'include_granted_scopes': 'true'
      };
      this._forceTokenData = {
        'approval_prompt': 'force'
      };
      this._init(config);
    }

    GoogleProvider.prototype.share = function(data) {
      var params, uri;
      uri = 'https://plus.google.com/share';
      params = 'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,height=600,width=600';
      return this._showPopup(uri, {
        url: data.url
      }, params);
    };

    GoogleProvider.prototype.wallPost = function() {
      throw Error("Method not supported");
    };

    GoogleProvider.prototype._loadFriendIds = function(deferred) {
      var data, self;
      data = {
        orderBy: 'best',
        maxResults: 100,
        access_token: this._session.token
      };
      self = this;
      return this._methodCall('plus/v1/people/me/people/visible', data).then(function(data) {
        var friendIds, resultData;
        resultData = {
          status: 'error'
        };
        if ((data != null) && (data != null ? data.error : void 0)) {
          self._setError(data.error.code, data.error.message);
          resultData.error = self.getError();
        } else if (data != null) {
          friendIds = [];
          if (data.totalItems > 0) {
            friendIds = data.items.map(function(n) {
              return n.id;
            });
          }
          resultData.status = 'success';
          resultData.friendIds = friendIds;
        } else {
          self._setError('FATAL_ERROR', 'Failed to load friendIds');
          resultData.error = self.getError();
        }
        if (resultData.status === 'success') {
          return deferred.resolve(resultData);
        } else {
          return deferred.reject(resultData);
        }
      }, self._getXHRErrorHandler(deferred));
    };

    GoogleProvider.prototype._loadUserData = function(deferred) {
      var data, self;
      data = {
        access_token: this._session.token
      };
      self = this;
      return this._methodCall('plus/v1/people/me', data).then(function(data) {
        var resultData, userData;
        resultData = {
          status: 'error'
        };
        if ((data != null) && (data != null ? data.error : void 0)) {
          self._setError(data.error.code, data.error.message);
          resultData.error = self.getError();
        } else if (data != null) {
          userData = {
            user_id: data.id,
            email: (data != null ? data.emails : void 0) && data.emails.length > 0 ? data.emails[0].value : null,
            first_name: data.name.givenName != null ? data.name.givenName : null,
            last_name: data.name.familyName != null ? data.name.familyName : null,
            full_name: data.displayName.trim(),
            birth_date: null,
            sex: (data != null ? data.gender : void 0) && data.gender === 'female' ? 'female' : 'male'
          };
          resultData.status = 'success';
          resultData.user = userData;
          self._storeUserData(userData);
        } else {
          self._setError('FATAL_ERROR', 'Failed to load userData');
          resultData.error = self.getError();
        }
        if (resultData.status === 'success') {
          return deferred.resolve(resultData);
        } else {
          return deferred.reject(resultData);
        }
      }, self._getXHRErrorHandler(deferred));
    };

    GoogleProvider.prototype._loadGrantedScope = function(deferred) {
      var data, self;
      data = {
        access_token: this._session.token
      };
      self = this;
      return this._methodCall('oauth2/v1/tokeninfo', data).then(function(data) {
        var bit, ref, responseScopeList, resultData, resultList, resultMask, scope;
        resultData = {
          status: 'error'
        };
        if ((data != null) && (data != null ? data.error : void 0)) {
          self._setError(data.error.code, data.error.message);
          resultData.error = self.getError();
        } else if (data != null) {
          resultList = [];
          resultMask = 0;
          responseScopeList = data.scope.split(self._scopeDelimiter);
          ref = self._scopeMapping;
          for (bit in ref) {
            scope = ref[bit];
            if (responseScopeList.indexOf(scope) !== -1) {
              resultMask = resultMask | bit;
              resultList.push(scope);
            }
          }
          self._tokenVerified = true;
          self._session.scopeMask = resultMask;
          self._saveSessionData(self._session);
          resultData.status = 'success';
          resultData.scopeList = resultList;
        }
        if (resultData.status === 'success') {
          return deferred.resolve(resultData);
        } else {
          return deferred.reject(resultData);
        }
      }, self._getXHRErrorHandler(deferred));
    };

    return GoogleProvider;

  })(BaseProvider);
  return GoogleProvider;
});
