define(['app', 'views/item-view', 'underscore', 'text!templates/airport.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    data: {
      flights: 'airport.flights'
    },
    events: {
      'click .js-select-flight': 'selectFlight'
    },
    selectFlight: function(event) {
      var cityId, fromCityId, ref;
      this.lockUI();
      cityId = event.currentTarget.getAttribute('data-city-id');
      fromCityId = (ref = this._data.flights) != null ? ref.city_id : void 0;
      return app.screens.modal('airport/popup', {
        cityId: cityId,
        fromCityId: fromCityId
      });
    },

    /*
    			Center cloud
     */
    centerCloud: function() {
      var $cloud, $container;
      if ($('.c-cloud').length > 0) {
        $cloud = $('.c-cloud');
        $container = $('.js-current-screen');
        return $cloud.css('margin-top', (($container.height() - $('.c-featured').height()) / 2 - $cloud.height() / 2) / 2);
      }
    },
    onDomRefresh: function() {
      return this.centerCloud();
    }
  });
});
