var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'underscore', 'text!templates/business.tmpl', 'views/components/currency', 'text!templates/business/blocks/company-element.tmpl', 'views/common/lazy-loading-view'], function(app, _, template, formatCurrency, listTemplate, CommonLazyView) {
  var BusinessView;
  BusinessView = (function(superClass) {
    extend(BusinessView, superClass);

    function BusinessView() {
      this._loadData = bind(this._loadData, this);
      return BusinessView.__super__.constructor.apply(this, arguments);
    }

    BusinessView.prototype.template = template;

    BusinessView.prototype.listTemplate = _.template(listTemplate);

    BusinessView.prototype.pointer = 'business';

    BusinessView.prototype.reloadOnScreensBack = false;

    BusinessView.prototype.events = {
      'click .js-goto-company': 'gotoCompany'
    };

    BusinessView.prototype.data = {
      business: {
        pointer: 'business.companyList',
        page: 1
      }
    };

    BusinessView.prototype.loadData = function(showLoader) {
      if (showLoader == null) {
        showLoader = true;
      }
      this.data.business.page = 1;
      return BusinessView.__super__.loadData.call(this, showLoader);
    };

    BusinessView.prototype.gotoCompany = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('business/common', {
        companyId: companyId
      });
    };

    BusinessView.prototype.onDomRefresh = function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    };

    BusinessView.prototype._loadData = function(page) {
      var deferred, self;
      deferred = $.Deferred();
      self = this;
      app.server.business.companyList({
        page: page || 1,
        success: (function(_this) {
          return function(data) {
            var ref, ref1, ref2, ref3, resultData;
            resultData = data;
            resultData.page = page;
            resultData.hasNext = ((ref = data.paging) != null ? (ref1 = ref.Company) != null ? ref1.nextPage : void 0 : void 0) || false;
            self.hasNext = ((ref2 = data.paging) != null ? (ref3 = ref2.Company) != null ? ref3.nextPage : void 0 : void 0) || false;
            _this.data.business.page++;
            return deferred.resolve(resultData);
          };
        })(this),
        error: function() {
          return deferred.resolve({
            companies: [],
            page: 1,
            hasNext: false
          });
        }
      });
      return deferred;
    };

    return BusinessView;

  })(CommonLazyView);
  return BusinessView;
});
