var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/common/list-view', 'underscore', 'text!templates/business/change-manager.tmpl', 'text!templates/business/blocks/change-manager-list.tmpl'], function(app, CommonListView, _, template, listTemplate) {
  var ChangeManagerView;
  ChangeManagerView = (function(superClass) {
    extend(ChangeManagerView, superClass);

    function ChangeManagerView() {
      return ChangeManagerView.__super__.constructor.apply(this, arguments);
    }

    ChangeManagerView.prototype.template = template;

    ChangeManagerView.prototype.listTemplate = _.template(listTemplate);

    ChangeManagerView.prototype.title = app.tr('Select a Player');

    ChangeManagerView.prototype.events = {
      'change .js-name': 'onNameChange',
      'click .js-set-manager': 'setManager',
      'click #js-main-list-load-more': 'onLoadMore'
    };

    ChangeManagerView.prototype._name = null;

    ChangeManagerView.prototype.initialize = function() {
      ChangeManagerView.__super__.initialize.apply(this, arguments);
      return this.options.title = this.title;
    };


    /*
    			Center cloud
     */

    ChangeManagerView.prototype.centerCloud = function() {
      var $cloud, $container;
      if ($('.c-cloud').length > 0) {
        $cloud = $('.c-cloud');
        $container = $('.js-current-screen');
        return $cloud.css('margin-top', ($container.height() / 2 - $cloud.height() / 2) / 2);
      }
    };

    ChangeManagerView.prototype.onDomRefresh = function() {
      return this.centerCloud();
    };

    ChangeManagerView.prototype.onNameChange = function(event) {
      var name;
      name = event.currentTarget.value;
      name = name.trim();
      event.currentTarget.value = name;
      if (name.length > 2 || !name) {
        this._name = name;
        return this._reloadMainList(name, 1);
      }
    };

    ChangeManagerView.prototype.onLoadMore = function(event) {
      var page;
      page = Number(event.currentTarget.getAttribute('data-page'));
      return this._appendPageToMainList(this._name, page);
    };

    ChangeManagerView.prototype._reloadMainList = function(name, page) {
      var container, self;
      container = this.el.querySelector('#js-main-list-content');
      self = this;
      self.lockUI();
      self._showListLoader(container);
      return $.when(self._clearAllLists(), self._loadManagers(name, page)).then(function(ign, data) {
        self.unlockUI();
        self._hideListLoader(container);
        return self._renderList(container, data.users, data.page, data.hasNext);
      });
    };

    ChangeManagerView.prototype._appendPageToMainList = function(name, page) {
      var container, self;
      container = this.el.querySelector('#js-main-list-content');
      self = this;
      self.lockUI();
      self._showListLoader(container);
      return self._loadManagers(name, page).then(function(data) {
        self.unlockUI();
        self._hideListLoader(container);
        return self._renderList(container, data.users, data.page, data.hasNext);
      });
    };

    ChangeManagerView.prototype._loadManagers = function(name, page) {
      var deferred, self;
      deferred = $.Deferred();
      self = this;
      app.server.business.searchManager({
        name: name,
        page: page || 1,
        success: function(data) {
          var resultData;
          resultData = {
            users: data.users || []
          };
          resultData.page = page;
          resultData.hasNext = data.has_next || false;
          return deferred.resolve(resultData);
        },
        error: function() {
          return deferred.resolve({
            users: [],
            page: 1,
            hasNext: false
          });
        }
      });
      return deferred;
    };

    ChangeManagerView.prototype.setManager = function(event) {
      var companyId, managerId;
      event.stopPropagation();
      this.lockUI();
      companyId = this.options.companyId;
      managerId = event.currentTarget.getAttribute('data-id');
      return app.screens.modal('common/confirmation-popup', {
        msg: app.tr('Are you sure you want assign a new manager?'),
        callback: (function(_this) {
          return function(count) {
            return app.server.business.setManager({
              companyId: companyId,
              managerId: managerId,
              success: function(data) {
                return app.screens.modal('common/success-popup', {
                  msg: data.setFlash[0].msg || app.tr("Appointed new manager")
                }, app.screens.back());
              },
              error: function(data) {
                return app.screens.modal('common/info-popup', {
                  msg: data.setFlash[0].msg || app.tr("Something went wrong")
                });
              }
            });
          };
        })(this)
      });
    };

    return ChangeManagerView;

  })(CommonListView);
  return ChangeManagerView;
});
