var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'underscore', 'text!templates/business/company-bots/company-bots.tmpl', 'views/item-view'], function(app, _, template, ItemView) {
  var CompanyBots;
  CompanyBots = (function(superClass) {
    extend(CompanyBots, superClass);

    function CompanyBots() {
      this.upgrade = bind(this.upgrade, this);
      this.iosSwitcher = bind(this.iosSwitcher, this);
      this.updateLogistican = bind(this.updateLogistican, this);
      this.updateAccountant = bind(this.updateAccountant, this);
      this.hireBot = bind(this.hireBot, this);
      return CompanyBots.__super__.constructor.apply(this, arguments);
    }

    CompanyBots.prototype.template = _.template(template);

    CompanyBots.prototype.render = function(containerSelector, data) {
      var $fragment, container, fragment;
      fragment = document.createElement('DIV');
      fragment.innerHTML = Marionette.Renderer.render(this.template, data);
      container = document.querySelector(containerSelector);
      if (container != null) {
        container.appendChild(fragment);
      }
      $fragment = $(fragment);
      $fragment.on('click', '.js-logistican-switcher', this.logisticanSwitch);
      $fragment.on('click', '.js-accountant-switcher', this.accounterSwitch);
      $fragment.on('click', '.js-hire', this.hireBot);
      $fragment.on('click', '.js-update-accountant', this.updateAccountant);
      $fragment.on('click', '.js-ios-switcher', this.iosSwitcher);
      $fragment.on('click', '.js-upgrade', this.upgrade);
      return $fragment.on('click', '.js-update-logistican', this.updateLogistican);
    };

    CompanyBots.prototype.logisticanSwitch = function() {
      $('.js-logistican').toggleClass('u-hide');
      $('.js-logistican').css('height', window.innerHeight - $('.js-logistican').offset().top);
      return $('.js-logistican').css('display', 'block');
    };

    CompanyBots.prototype.accounterSwitch = function() {
      $('.js-accountant').toggleClass('u-hide');
      $('.js-accountant').css('height', window.innerHeight - $('.js-accountant').offset().top);
      return $('.js-accountant').css('display', 'block');
    };

    CompanyBots.prototype.hireBot = function(event) {
      var botType, companyId, msg;
      companyId = event.currentTarget.getAttribute('data-company-id');
      botType = event.currentTarget.getAttribute('data-bot-type');
      msg = app.tr('Are you sure you want to hire?');
      return app.screens.modal('common/confirmation-popup', {
        msg: msg,
        callback: (function(_this) {
          return function() {
            var loader;
            _this.lockUI();
            loader = _this.setLoaderOnElement(event.currentTarget, app.tr('Hiring'));
            return app.server.business.hireBot({
              companyId: companyId,
              botType: botType,
              success: function(data) {
                var ref;
                loader.remove();
                _this.unlockUI();
                return app.screens.modal('common/success-popup', {
                  msg: ((ref = data.setFlash[0]) != null ? ref.msg : void 0) || app.tr("Successfully hired")
                });
              },
              error: function(data) {
                var ref;
                loader.remove();
                _this.unlockUI();
                return app.screens.modal('common/info-popup', {
                  msg: ((ref = data.setFlash[0]) != null ? ref.msg : void 0) || app.tr("Something went wrong")
                });
              }
            });
          };
        })(this)
      });
    };

    CompanyBots.prototype.updateAccountant = function(event) {
      var companyId, loader, newSum;
      companyId = event.currentTarget.getAttribute('data-company-id');
      newSum = $('.js-accountant-sum').val();
      loader = this.setLoaderOnElement(event.currentTarget, app.tr('Updating'));
      this.lockUI();
      return app.server.business.updateAccountant({
        companyId: companyId,
        sum: newSum,
        success: (function(_this) {
          return function(data) {
            var ref;
            loader.remove();
            _this.unlockUI();
            return app.screens.modal('common/success-popup', {
              msg: ((ref = data.setFlash[0]) != null ? ref.msg : void 0) || app.tr("Successfully updated")
            });
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            loader.remove();
            _this.unlockUI();
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            });
          };
        })(this)
      });
    };

    CompanyBots.prototype.updateLogistican = function(event) {
      var companyId, loader, values;
      companyId = event.currentTarget.getAttribute('data-company-id');
      values = {};
      $('.js-logistican-count').each(function(index, element) {
        var typeId, value;
        typeId = element.getAttribute('data-type-id');
        value = element.value;
        return values[typeId] = value;
      });
      loader = this.setLoaderOnElement(event.currentTarget, app.tr('Updating'));
      this.lockUI();
      return app.server.business.updateLogistican({
        companyId: companyId,
        values: values,
        success: (function(_this) {
          return function(data) {
            var ref;
            loader.remove();
            _this.unlockUI();
            return app.screens.modal('common/success-popup', {
              msg: ((ref = data.setFlash[0]) != null ? ref.msg : void 0) || app.tr("Successfully updated")
            });
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            loader.remove();
            _this.unlockUI();
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            });
          };
        })(this)
      });
    };

    CompanyBots.prototype.iosSwitcher = function(event) {
      var botType, checkBox, companyId;
      checkBox = $(event.currentTarget).prev('.js-ios-checkbox');
      checkBox.prop("checked", !checkBox.prop("checked"));
      companyId = event.currentTarget.getAttribute('data-company-id');
      botType = event.currentTarget.getAttribute('data-bot-type');
      this.lockUI();
      return app.server.business.toggleActive({
        companyId: companyId,
        botType: botType,
        error: (function(_this) {
          return function(data) {
            checkBox.prop("checked", !checkBox.prop("checked"));
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            });
          };
        })(this)
      });
    };

    CompanyBots.prototype.upgrade = function(event) {
      var botType, companyId, loader;
      companyId = event.currentTarget.getAttribute('data-company-id');
      botType = event.currentTarget.getAttribute('data-bot-type');
      loader = this.setLoaderOnElement(event.currentTarget, app.tr('Upgrading'));
      this.lockUI();
      return app.server.business.botLvlUp({
        companyId: companyId,
        botType: botType,
        success: (function(_this) {
          return function(data) {
            var ref;
            loader.remove();
            _this.unlockUI();
            return app.screens.modal('common/success-popup', {
              msg: ((ref = data.setFlash[0]) != null ? ref.msg : void 0) || app.tr("Successfully upgraded")
            });
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            loader.remove();
            _this.unlockUI();
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            });
          };
        })(this)
      });
    };

    return CompanyBots;

  })(ItemView);
  return CompanyBots;
});
