define(['app', 'views/item-view', 'underscore', 'text!templates/inventory/choose-type.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    required: ['itemId', 'callback'],
    data: {
      form: {
        pointer: 'corporation.useForm',
        itemId: function() {
          return this.options.itemId;
        }
      }
    },
    events: {
      'click .js-choose-type': 'chooseType'
    },
    chooseType: function(event) {
      var typeId, typeName;
      this.lockUI();
      typeId = event.currentTarget.getAttribute('data-type-id');
      typeName = this._data.form.options[typeId];
      this.options.callback({
        typeId: typeId,
        typeName: typeName
      });
      return app.screens.back();
    },
    onDomRefresh: function() {
      return $('.military-base-layout').css('height', document.body.clientHeight);
    }
  });
});
