var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/business/corp-storage.tmpl', 'views/components/item-type-comparator'], function(app, ItemView, _, template, itemTypeComparatorComponent) {
  var BusinessCorporationStorage;
  BusinessCorporationStorage = (function(superClass) {
    extend(BusinessCorporationStorage, superClass);

    function BusinessCorporationStorage() {
      return BusinessCorporationStorage.__super__.constructor.apply(this, arguments);
    }

    BusinessCorporationStorage.prototype.template = template;

    BusinessCorporationStorage.prototype.events = {
      'click .js-goto-capital': 'gotoCapital',
      'click .js-goto-management': 'gotoManagement',
      'click .js-goto-shareholders': 'gotoShareholders',
      'click .js-goto-buying': 'gotoBuying',
      'click .js-goto-selling': 'gotoSelling',
      'click .js-storage-item': 'useItem'
    };

    BusinessCorporationStorage.prototype.data = {
      corporationStorage: {
        pointer: 'business.corporationStorage',
        corporationId: function() {
          return this.options.corporationId;
        }
      },
      corporationInfo: {
        pointer: 'business.corporationInfo',
        corporationId: function() {
          return this.options.corporationId;
        }
      }
    };

    BusinessCorporationStorage.prototype.initialize = function() {
      BusinessCorporationStorage.__super__.initialize.apply(this, arguments);
      return this.itemTypeComparatorFactory = itemTypeComparatorComponent.itemTypeComparatorFactory;
    };

    BusinessCorporationStorage.prototype.gotoCapital = function(event) {
      var corporationId;
      this.lockUI();
      corporationId = event.currentTarget.getAttribute('data-corporation-id');
      return app.screens.tab('business/capital', {
        corporationId: corporationId
      });
    };

    BusinessCorporationStorage.prototype.gotoManagement = function(event) {
      var corporationId;
      this.lockUI();
      corporationId = event.currentTarget.getAttribute('data-corporation-id');
      return app.screens.tab('business/management', {
        corporationId: corporationId
      });
    };

    BusinessCorporationStorage.prototype.gotoShareholders = function(event) {
      var corporationId;
      this.lockUI();
      corporationId = event.currentTarget.getAttribute('data-corporation-id');
      return app.screens.tab('business/shareholders', {
        corporationId: corporationId
      });
    };

    BusinessCorporationStorage.prototype.gotoBuying = function(event) {
      var corporationId;
      this.lockUI();
      corporationId = event.currentTarget.getAttribute('data-corporation-id');
      return app.quests.doIfCompleted('social_passport', function() {
        return app.screens.dialog('trade-center/trade-center-corporation', {
          corporationId: corporationId
        });
      });
    };

    BusinessCorporationStorage.prototype.gotoSelling = function(event) {
      var corporationId;
      this.lockUI();
      corporationId = event.currentTarget.getAttribute('data-corporation-id');
      if (this._data.corporationStorage.storage.length === 0) {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("Your storage is empty")
        });
      } else {
        return app.quests.doIfCompleted('social_passport', function() {
          return app.screens.dialog('trade-center/sell-item-corporation', {
            corporationId: corporationId
          });
        });
      }
    };

    BusinessCorporationStorage.prototype.serializeData = function() {
      var data, itemTypeComparator;
      data = BusinessCorporationStorage.__super__.serializeData.apply(this, arguments);
      if (data && (data.corporationStorage != null) && data.corporationStorage.storage.length !== 0) {
        itemTypeComparator = this.itemTypeComparatorFactory(data.corporationStorage.categorySortWeight);
        data.corporationStorage.storage = data.corporationStorage.storage.sort(itemTypeComparator);
      }
      return data;
    };

    BusinessCorporationStorage.prototype.useItem = function(event) {
      var companiesItemTypesIds, corporationId, itemId;
      companiesItemTypesIds = ['1177', '1178', '1179', '1180'];
      itemId = event.currentTarget.getAttribute('data-item-id');
      corporationId = event.currentTarget.getAttribute('data-corporation-id');
      if (companiesItemTypesIds.indexOf(itemId) === -1) {
        return;
      }
      return app.screens.modal('business/corporation-use-item', {
        itemId: itemId,
        corporationId: corporationId
      });
    };

    return BusinessCorporationStorage;

  })(ItemView);
  return BusinessCorporationStorage;
});
