define(['app', 'views/item-view', 'underscore', 'text!templates/business/corporation-overview.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  return ItemView.extend({
    template: template,
    data: {
      corporationInfo: {
        pointer: 'business.corporationShortInfo',
        corporationId: function() {
          return this.options.corporationId;
        }
      }
    },
    events: {
      'click .js-goto-company': 'gotoCompany'
    },
    gotoCompany: function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('business/company-overview', {
        companyId: companyId
      });
    }
  });
});
