var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'underscore', 'text!templates/business/corporations.tmpl', 'views/components/currency', 'text!templates/business/blocks/corporation-element.tmpl', 'views/common/lazy-loading-view'], function(app, _, template, formatCurrency, listTemplate, CommonLazyView) {
  var CorporationsView;
  CorporationsView = (function(superClass) {
    extend(CorporationsView, superClass);

    function CorporationsView() {
      this._loadData = bind(this._loadData, this);
      return CorporationsView.__super__.constructor.apply(this, arguments);
    }

    CorporationsView.prototype.template = template;

    CorporationsView.prototype.listTemplate = _.template(listTemplate);

    CorporationsView.prototype.pointer = 'business';

    CorporationsView.prototype.reloadOnScreensBack = false;

    CorporationsView.prototype.data = {
      business: {
        pointer: 'business.corporationList',
        page: 1
      }
    };

    CorporationsView.prototype.events = {
      'click .js-goto-corporation': 'gotoCorporation',
      'click .js-create-corporation': 'createCorporation'
    };

    CorporationsView.prototype.loadData = function(showLoader) {
      if (showLoader == null) {
        showLoader = true;
      }
      this.data.business.page = 1;
      return CorporationsView.__super__.loadData.call(this, showLoader);
    };

    CorporationsView.prototype.gotoCorporation = function(event) {
      var corporationId;
      this.lockUI();
      corporationId = event.currentTarget.getAttribute('data-corporation-id');
      return app.screens.dialog('business/capital', {
        corporationId: corporationId
      });
    };

    CorporationsView.prototype.createCorporation = function(event) {
      this.lockUI();
      return app.quests.doIfCompleted('social_passport', function() {
        return app.screens.dialog('business/create-corporation');
      });
    };

    CorporationsView.prototype.onDomRefresh = function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    };

    CorporationsView.prototype._loadData = function(page) {
      var deferred, self;
      deferred = $.Deferred();
      self = this;
      app.server.business.corporationList({
        page: page || 1,
        success: (function(_this) {
          return function(data) {
            var ref, ref1, ref2, ref3, resultData;
            resultData = data;
            resultData.page = page;
            resultData.hasNext = ((ref = data.paging) != null ? (ref1 = ref.Corporation) != null ? ref1.nextPage : void 0 : void 0) || false;
            self.hasNext = ((ref2 = data.paging) != null ? (ref3 = ref2.Corporation) != null ? ref3.nextPage : void 0 : void 0) || false;
            _this.data.business.page++;
            return deferred.resolve(resultData);
          };
        })(this),
        error: function() {
          return deferred.resolve({
            corporations: [],
            page: 1,
            hasNext: false
          });
        }
      });
      return deferred;
    };

    return CorporationsView;

  })(CommonLazyView);
  return CorporationsView;
});
