var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/business/create-company.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  var CreateCompanyView;
  CreateCompanyView = (function(superClass) {
    extend(CreateCompanyView, superClass);

    function CreateCompanyView() {
      return CreateCompanyView.__super__.constructor.apply(this, arguments);
    }

    CreateCompanyView.prototype.template = template;

    CreateCompanyView.prototype.className = 'no-bg-image';

    CreateCompanyView.prototype.events = {
      'click .o-switcher': 'changeCurrency',
      'click .js-create-company': 'createCompany',
      'click .js-select': 'selectItem',
      'click .js-toogle-tier': 'toogleTier',
      'click .js-select-type': 'selectType'
    };

    CreateCompanyView.prototype.data = {
      business: 'business'
    };

    CreateCompanyView.prototype.initialize = function(options) {
      this.options = options;
      return CreateCompanyView.__super__.initialize.apply(this, arguments);
    };

    CreateCompanyView.prototype.onDomRefresh = function() {};

    CreateCompanyView.prototype.changeCurrency = function(event) {
      var $jsPrice, $newValue, ref, tier, tierId;
      this.options.showVd = !this.options.showVd;
      $(event.currentTarget).toggleClass('o-switcher--active');
      this.$el.find('.js-currency').toggleClass('o-icon--vdollar o-icon--vgold');
      this.$el.find('.js-create-company').toggleClass('c-btn--green c-btn--yellow');
      this.$el.find('.js-gold-only').toggleClass('hidden');
      ref = this._data.business.company_tiers;
      for (tierId in ref) {
        tier = ref[tierId];
        if (this.options.showVd && !tier.creating_price.hasOwnProperty('vd')) {
          continue;
        }
        $jsPrice = this.$el.find('[data-tier-id="' + tierId + '"]').find('.js-price');
        $newValue = formatCurrency((this.options.showVd ? tier.creating_price.vd : tier.creating_price_vg), '.', 2);
        $jsPrice.html($newValue);
      }
      if (!this.options.haveVd) {
        this.$el.find('.js-vd-only').toggleClass('hidden');
      }
      return console.log('data', this.data, this.options.showVd, this._data);
    };

    CreateCompanyView.prototype.toogleTier = function(event) {
      var tierId, wrapper_class;
      tierId = event.currentTarget.getAttribute('data-tier-id');
      wrapper_class = '.js-tier_' + tierId + '-type-wrapper';
      return $(wrapper_class).toggleClass('hidden');
    };

    CreateCompanyView.prototype.preprocessData = function(data) {
      var i, item, len, ref, ref1, tier, tierId;
      this.options.showVd = true;
      if (this.options.corporationId) {
        this.options.show_tiers = [1, 2, 3, 4];
        this.options.allowed_tiers = [1, 2, 3, 4];
        this.options.opened_tier = -1;
        this.options.show_required_level = false;
      } else {
        this.options.show_tiers = [1, 2, 3, 4];
        this.options.allowed_tiers = data.business.company_allowed_tiers;
        this.options.opened_tier = -1;
        this.options.show_required_level = true;
      }
      this.options.haveVd = false;
      ref = data.business.company_types;
      for (i = 0, len = ref.length; i < len; i++) {
        item = ref[i];
        item.title = item.name;
      }
      ref1 = data.business.company_tiers;
      for (tierId in ref1) {
        tier = ref1[tierId];
        if (tier.creating_price.hasOwnProperty('vd')) {
          this.options.haveVd = true;
        }
      }
      if (!this.options.haveVd) {
        this.options.showVd = false;
      }
      console.log('have vd', this.options);
      this.companyCatsCollection = new Backbone.Collection(data.business.company_types);
      return data;
    };

    CreateCompanyView.prototype.selectType = function(event) {
      event.stopPropagation();
      this.$el.find('.js-select-type').removeClass('u-c--green c-brd-green c-card--bordered js-selected');
      return $(event.currentTarget).addClass('u-c--green c-brd-green c-card--bordered js-selected');
    };

    CreateCompanyView.prototype.createCompany = function(event) {
      var currency, itemId, name, typeId;
      this.lockUI();
      typeId = this.$('.js-selected').attr("data-type-id");
      itemId = this.$('.js-selected').attr("data-item-id");
      typeId = parseInt(typeId);
      name = this.$el.find('.js-name').val();
      if (isNaN(typeId)) {
        app.screens.modal('common/info-popup', {
          msg: app.tr("Select company type"),
          needReload: false
        });
        return;
      }
      currency = this.options.showVd ? 'vdollars' : 'vgold';
      if (name === "") {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("Specify the company's name"),
          needReload: false
        });
      } else {
        if (this.options.corporationId != null) {
          return app.server.business.createCorporationCompany({
            corporationId: this.options.corporationId,
            type: typeId,
            name: name,
            currency: currency,
            itemId: itemId,
            success: function(data) {
              app.screens.back(null, {
                needReload: true
              });
              return app.screens.modal('common/info-popup', {
                msg: data.setFlash[0].msg || app.tr("Company was created")
              });
            },
            error: function(data) {
              return app.screens.modal('common/info-popup', {
                msg: data.setFlash[0].msg || app.tr("Something went wrong"),
                needReload: false
              });
            }
          });
        } else {
          return app.server.business.createCompany({
            type: typeId,
            name: name,
            currency: currency,
            itemId: itemId,
            success: function(data) {
              if (app.gaEnabled) {
                app.ga('send', 'event', 'business', 'create', 'company ' + data.company_id, '' + data.company_price.cost);
              }
              app.screens.back(null, {
                needReload: true
              });
              return app.screens.modal('common/info-popup', {
                msg: data.setFlash[0].msg || app.tr("Company was created")
              });
            },
            error: function(data) {
              return app.screens.modal('common/info-popup', {
                msg: data.setFlash[0].msg || app.tr("Something went wrong"),
                needReload: false
              });
            }
          });
        }
      }
    };

    return CreateCompanyView;

  })(ItemView);
  return CreateCompanyView;
});
