define(['app', 'views/item-view', 'underscore', 'text!templates/business/initiative-stocks-buyout.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    events: {
      'click .js-apply': 'saveProposal',
      'click .o-switcher': 'changeCurrency',
      'change .js-amount': 'calcSum'
    },
    changeCurrency: function(event) {
      $(event.currentTarget).toggleClass('o-switcher--active');
      return $('.js-sum-currency').toggleClass('o-icon--vgold');
    },
    calcSum: function(event) {
      var price;
      price = $(event.currentTarget).val();
      $(event.currentTarget).val(parseFloat(price).toFixed(2));
      return $('.js-sum').html(this.numberFormat(parseFloat(price).toFixed(2) * this.options.stocksCount));
    },
    saveProposal: function(event) {
      var corporationId, currency, price, shareholderId;
      this.lockUI();
      corporationId = this.options.corporationId;
      shareholderId = this.options.userId;
      price = this.$el.find('.js-amount').val();
      currency = this.$el.find('.o-switcher').hasClass('o-switcher--active') ? 'vg' : 'vd';
      console.log(shareholderId);
      if (price === "") {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("You haven't input anything")
        });
      } else {
        return app.server.business.proposeStocksBuyout({
          corporationId: corporationId,
          shareholderId: shareholderId,
          currency: currency,
          price: price,
          stockCount: this.options.stocksCount,
          success: function(data) {
            app.screens.modal('common/success-popup', {
              msg: data.setFlash[0].msg || app.tr("Action was successful")
            }, app.screens.back());
            return app.screens.main('business/management', {
              corporationId: corporationId
            });
          },
          error: function(data) {
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            });
          }
        });
      }
    }
  });
});
