define(['app', 'views/item-view', 'underscore', 'text!templates/business/initiative.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    events: {
      'click .js-goto-dividents': 'gotoDividents',
      'click .js-goto-emission': 'gotoEmission',
      'click .js-goto-corp-rename': 'gotoCorpRename',
      'click .js-goto-change-manager': 'gotoChangeManager',
      'click .js-goto-liquidation': 'gotoCompanyLiquidation',
      'click .js-goto-stocks-buyout': 'gotoStocksBuyout'
    },
    gotoDividents: function(event) {
      var corporationId;
      this.lockUI();
      corporationId = this.options.corporationId;
      return app.screens.dialog('business/initiative-dividends', {
        corporationId: corporationId
      });
    },
    gotoEmission: function(event) {
      var corporationId;
      this.lockUI();
      corporationId = this.options.corporationId;
      return app.screens.dialog('business/initiative-emission', {
        corporationId: corporationId
      });
    },
    gotoCorpRename: function(event) {
      var corporationId;
      this.lockUI();
      corporationId = this.options.corporationId;
      return app.screens.dialog('business/initiative-rename', {
        corporationId: corporationId
      });
    },
    gotoChangeManager: function(event) {
      var corporationId;
      this.lockUI();
      corporationId = this.options.corporationId;
      return app.screens.dialog('business/initiative-manager', {
        corporationId: corporationId
      });
    },
    gotoCompanyLiquidation: function(event) {
      var corporationId;
      this.lockUI();
      corporationId = this.options.corporationId;
      return app.screens.dialog('business/initiative-liquidation', {
        corporationId: corporationId
      });
    },
    gotoStocksBuyout: function(event) {
      var corporationId;
      this.lockUI();
      corporationId = this.options.corporationId;
      return app.screens.dialog('business/shareholders', {
        corporationId: corporationId,
        is_stock_buyout: true
      });
    }
  });
});
