define(['app', 'views/item-view', 'underscore', 'text!templates/business/shareholders.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    data: {
      corporationInfo: {
        pointer: 'business.corporationInfo',
        corporationId: function() {
          return this.options.corporationId;
        }
      },
      shareHolders: {
        pointer: 'business.shareHolders',
        corporationId: function() {
          return this.options.corporationId;
        }
      }
    },
    events: {
      'click .js-goto-capital': 'gotoCapital',
      'click .js-goto-management': 'gotoManagement',
      'click .js-goto-corporation-storage': 'gotocorporationStorage',
      'click .js-select-shareholder': 'gotoStocksBuyout'
    },
    gotoCapital: function(event) {
      var corporationId;
      this.lockUI();
      corporationId = event.currentTarget.getAttribute('data-corporation-id');
      return app.screens.tab('business/capital', {
        corporationId: corporationId
      });
    },
    gotoManagement: function(event) {
      var corporationId;
      this.lockUI();
      corporationId = event.currentTarget.getAttribute('data-corporation-id');
      return app.screens.tab('business/management', {
        corporationId: corporationId
      });
    },
    gotocorporationStorage: function(event) {
      var corporationId;
      this.lockUI();
      corporationId = event.currentTarget.getAttribute('data-corporation-id');
      return app.screens.tab('business/corp-storage', {
        corporationId: corporationId
      });
    },
    gotoStocksBuyout: function(event) {
      var stocksCount, userId;
      this.lockUI();
      userId = event.currentTarget.getAttribute('data-user-id');
      stocksCount = event.currentTarget.getAttribute('data-stock-quantity');
      return app.screens.dialog('business/initiative-stocks-buyout', {
        corporationId: this.options.corporationId,
        userId: userId,
        stocksCount: stocksCount
      });
    }
  });
});
