var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/business/transfer-company.tmpl'], function(app, ItemView, _, template) {
  var BusinessCommonView;
  return BusinessCommonView = (function(superClass) {
    extend(BusinessCommonView, superClass);

    function BusinessCommonView() {
      return BusinessCommonView.__super__.constructor.apply(this, arguments);
    }

    BusinessCommonView.prototype.template = template;

    BusinessCommonView.prototype.data = {
      'business': 'business.corporationList'
    };

    BusinessCommonView.prototype.required = ['companyId'];

    BusinessCommonView.prototype.events = {
      'click .js-select': 'transfer'
    };

    BusinessCommonView.prototype.transfer = function(event) {
      var corporationId;
      this.lockUI();
      corporationId = event.currentTarget.getAttribute('data-corporation-id');
      return app.screens.modal('common/confirmation-popup', {
        msg: app.tr('Do you want to transfer company?'),
        callback: (function(_this) {
          return function(count) {
            return app.server.business.company.transfer({
              companyId: _this.options.companyId,
              corporationId: corporationId,
              success: function(data) {
                return app.screens.modal('common/success-popup', {
                  msg: data.setFlash[0].msg || app.tr("Well done")
                }, app.screens.back());
              },
              error: function(data) {
                return app.screens.modal('common/info-popup', {
                  msg: data.setFlash[0].msg || app.tr("Something went wrong")
                });
              }
            });
          };
        })(this)
      });
    };

    return BusinessCommonView;

  })(ItemView);
});
