define(['app', 'views/item-view', 'underscore', 'text!templates/common/buy-popup.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  return ItemView.extend({
    template: template,
    required: ['name', 'img', 'price', 'currency', 'callback'],
    optional: ['category', 'maxCount'],
    events: {
      'click .js-buy': 'buy'
    },
    onDomRefresh: function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    },
    buy: function() {
      this.lockUI();
      return this.options.callback(1);
    }
  });
});
