var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/business/add-funds.tmpl'], function(app, ItemView, _, template) {
  var AddFunds;
  AddFunds = (function(superClass) {
    extend(AddFunds, superClass);

    function AddFunds() {
      return AddFunds.__super__.constructor.apply(this, arguments);
    }

    AddFunds.prototype.template = template;

    AddFunds.prototype.events = {
      'click .o-switcher': 'changeCurrency',
      'click .js-apply': 'addFunds',
      'change .js-amount': 'changeAmount'
    };

    AddFunds.prototype.changeCurrency = function(event) {
      $(event.currentTarget).toggleClass('o-switcher--active');
      this.$el.find('.js-currency').toggleClass('o-icon--vdollar o-icon--vgold');
      return this.$el.find('.js-apply').toggleClass('c-btn--green c-btn--yellow');
    };

    AddFunds.prototype.changeAmount = function(event) {
      var amount;
      amount = this.$el.find('.js-amount').val();
      if (isNaN(amount)) {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("The amount may consist only of digits")
        });
      } else {
        return this.$el.find('.js-saved-amount').html(amount);
      }
    };

    AddFunds.prototype.addFunds = function(event) {
      var amount, companyId, currency, loader;
      this.lockUI();
      loader = this.setLoaderOnElement(event.currentTarget, app.tr('Adding'));
      amount = this.$el.find('.js-amount').val();
      companyId = this.options.companyId;
      currency = this.$el.find('.o-switcher').hasClass('o-switcher--active') ? 'vgold' : 'vdollars';
      if (amount === "") {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("Specify the sum")
        });
      } else if (isNaN(amount)) {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("The amount can only consist of digits")
        });
      } else if (amount <= 0) {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("The amount must be greater than zero")
        });
      } else {
        if (currency === "vdollars") {
          return app.server.business.corporative_company.addFundsVd({
            companyId: companyId,
            amount: amount,
            success: (function(_this) {
              return function(data) {
                _this.unlockUI();
                return loader.remove();
              };
            })(this),
            error: (function(_this) {
              return function(data) {
                _this.unlockUI();
                loader.remove();
                return app.screens.modal('common/info-popup', {
                  msg: data.setFlash[0].msg || app.tr("Something went wrong")
                });
              };
            })(this)
          });
        } else {
          return app.server.business.corporative_company.addFundsVg({
            companyId: companyId,
            amount: amount,
            success: (function(_this) {
              return function(data) {
                _this.unlockUI();
                return loader.remove();
              };
            })(this),
            error: (function(_this) {
              return function(data) {
                _this.unlockUI();
                loader.remove();
                return app.screens.modal('common/info-popup', {
                  msg: data.setFlash[0].msg || app.tr("Something went wrong")
                });
              };
            })(this)
          });
        }
      }
    };

    return AddFunds;

  })(ItemView);
  return AddFunds;
});
