var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/business/employees.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  var Employees;
  Employees = (function(superClass) {
    extend(Employees, superClass);

    function Employees() {
      return Employees.__super__.constructor.apply(this, arguments);
    }

    Employees.prototype.template = template;

    Employees.prototype.data = {
      сompanyWorkersInfo: {
        pointer: 'business.сompanyWorkersInfo',
        companyId: function() {
          return this.options.companyId;
        }
      },
      effects: {
        pointer: 'business.company.effects',
        companyId: function() {
          return this.options.companyId;
        }
      },
      companyInfo: {
        pointer: 'business.companyInfo',
        companyId: function() {
          return this.options.companyId;
        }
      }
    };

    Employees.prototype.events = {
      'click .js-goto-employees-list': 'gotoEmployeesList',
      'click .js-goto-foreign-workers': 'gotoForeignWorkers',
      'click .js-goto-recruitment': 'gotoRecruitment',
      'click .js-goto-storage': 'gotoStorage',
      'click .js-goto-common': 'gotoCommon',
      'click .js-up-level': 'upLevel',
      'click .js-goto-change-manager': 'gotoChangeManager',
      'click .js-settings': 'settings',
      'click .js-effects': 'showEffects',
      'click .js-reports-archive': 'showReports',
      'click .js-generate-report': 'generateReport'
    };

    Employees.prototype.onDomRefresh = function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    };

    Employees.prototype.settings = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('business/settings', {
        companyId: companyId
      });
    };

    Employees.prototype.gotoCommon = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.tab('corporative_companies/common', {
        companyId: companyId
      });
    };

    Employees.prototype.gotoStorage = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.tab('corporative_companies/storage', {
        companyId: companyId
      });
    };

    Employees.prototype.gotoEmployeesList = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('business/employees-list', {
        companyId: companyId
      });
    };

    Employees.prototype.gotoForeignWorkers = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('business/hiring-migrants', {
        companyId: companyId
      });
    };

    Employees.prototype.gotoRecruitment = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('business/recruitment', {
        companyId: companyId
      });
    };

    Employees.prototype.gotoChangeManager = function(event) {
      var companyId, managerId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      managerId = event.currentTarget.getAttribute('data-manager-id');
      return app.screens.dialog('corporative_companies/change-manager', {
        companyId: companyId,
        managerId: managerId
      });
    };

    Employees.prototype.upLevel = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.modal('common/confirmation-popup', {
        msg: app.tr('Do you want to upgrade the workers limit?'),
        callback: (function(_this) {
          return function(count) {
            return app.server.business.corporative_company.upLevel({
              companyId: companyId,
              success: function(data) {
                return app.screens.modal('common/success-popup', {
                  msg: data.setFlash[0].msg || app.tr("Settings saved")
                });
              },
              error: function(data) {
                return app.screens.modal('common/info-popup', {
                  msg: data.setFlash[0].msg || app.tr("Something went wrong")
                });
              }
            });
          };
        })(this)
      });
    };

    Employees.prototype.showEffects = function(event) {
      var companyId;
      companyId = event.currentTarget.getAttribute('data-company-id');
      return app.screens.dialog('maria/city-effects', {
        companyId: companyId
      });
    };

    Employees.prototype.onRender = function() {
      this.toggleView('.js-reports-switcher', '.js-reports-buttons');
      return Employees.__super__.onRender.call(this);
    };

    return Employees;

  })(ItemView);
  return Employees;
});
