var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/events/bb.tmpl', 'views/components/currency', 'views/components/strings-helper', 'jquery.countdown'], function(app, ItemView, _, template, formatCurrency, Strings) {
  var BBView;
  BBView = (function(superClass) {
    extend(BBView, superClass);

    function BBView() {
      return BBView.__super__.constructor.apply(this, arguments);
    }

    BBView.prototype.template = template;

    BBView.prototype.className = 'events bgc-violet bb';

    BBView.prototype.data = {
      bb: {
        pointer: 'events.bb'
      }
    };

    BBView.prototype.events = {
      'click .js-kick': 'clickKick'
    };

    BBView.prototype._kickInProcess = false;

    BBView.prototype._prevKickCurrency = null;

    BBView.prototype.initialize = function(options) {
      BBView.__super__.initialize.call(this, options);
      this._kickInProcess = false;
      return this._prevKickCurrency = null;
    };

    BBView.prototype.clickKick = function(event) {
      var canFight, currentKickCurrency, currentKickPrice, message, msg;
      if (this._kickInProcess) {
        return;
      }
      canFight = app.isAvailable(this._data.bb.currentLevel, 'UserBigFight');
      if (!canFight) {
        message = app.tr('You can participate from level') + ' ' + app.availableFrom('UserBigFight');
        app.screens.modal('common/info-popup', {
          msg: message
        });
        return;
      }
      currentKickCurrency = this._getKickCurrency();
      currentKickPrice = this._getKickPrice();
      if (this._prevKickCurrency && this._prevKickCurrency !== currentKickCurrency) {
        this._prevKickCurrency = currentKickCurrency;
        msg = Strings.replace({
          ':icon:': currentKickCurrency,
          ':amount:': currentKickPrice
        }, app.tr("Next kick for :amount: :icon:. Continue?"));
        return app.screens.modal('common/confirmation-popup', {
          msg: msg,
          callback: (function(_this) {
            return function() {
              return _this._kick(event);
            };
          })(this)
        });
      } else {
        this._prevKickCurrency = currentKickCurrency;
        return this._kick(event);
      }
    };

    BBView.prototype._kick = function(event) {
      var bbId, bbType, loader, memberCity;
      this._kickInProcess = true;
      this.lockUI();
      bbType = this._data.bb.bigFight.BigFight.type;
      memberCity = this._data.bb.bigFightMember.BigFightMember.city_id;
      bbId = event.currentTarget.getAttribute('data-bb-id');
      loader = this.setLoaderOnElement('.js-kick', app.tr('Kick'));
      return app.server.events.bb.kick({
        bbId: bbId,
        success: (function(_this) {
          return function(data) {
            var options;
            _this._kickInProcess = false;
            if (data != null ? data.next_kick_cost : void 0) {
              _this._nextKickCost = data.next_kick_cost;
            }
            options = {
              data: data,
              repeat: {
                method: _this.clickKick,
                context: _this,
                event: event
              }
            };
            if (app.gaEnabled) {
              app.ga('send', 'event', 'bb', bbType, '' + memberCity, parseInt(data.kick_report.full_damage));
            }
            return _this.listenToOnce(app.vent, 'short-info:dataLoaded', function() {
              loader.remove();
              return app.screens.modal('events/bb-popup', options);
            });
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            loader.remove();
            _this.unlockUI();
            _this._kickInProcess = false;
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg
            });
          };
        })(this)
      });
    };

    BBView.prototype._getKickCurrency = function() {
      var ref, ref1;
      if (this._nextKickCost != null) {
        return this._nextKickCost.currency;
      } else if (((ref = this._data.bb) != null ? (ref1 = ref.price) != null ? ref1.currency : void 0 : void 0) != null) {
        return this._data.bb.price.currency;
      } else {
        return null;
      }
    };

    BBView.prototype._getKickPrice = function() {
      var ref, ref1, ref2;
      if (this._nextKickCost != null) {
        return this._nextKickCost.cost;
      } else if (((ref = this._data.ot) != null ? (ref1 = ref.PrestigeWar) != null ? (ref2 = ref1.prestige_war_kick_cost) != null ? ref2.cost : void 0 : void 0 : void 0) != null) {
        return this._data.ot.PrestigeWar.prestige_war_kick_cost.cost;
      } else {
        return 0;
      }
    };

    BBView.prototype.onDataLoadError = function(data) {
      return this.app.screens.modal('events/low-level-popup', {
        msg: app.tr("You have insufficient level")
      });
    };


    /*
    			Center cloud
     */

    BBView.prototype.centerCloud = function() {
      var $cloud, $container;
      if ($('.c-cloud').length > 0) {
        $cloud = $('.c-cloud');
        $container = $('.js-current-screen');
        return $cloud.css('margin-top', ($container.height() / 2 - $cloud.height() / 2) / 2);
      }
    };

    BBView.prototype.onDomRefresh = function() {
      var date, ref, showedTime, time;
      this.centerCloud();
      [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
      if (((ref = this._data) != null ? ref.bb : void 0) != null) {
        time = (new Date()).getTime();
        if (this._data.bb.bigFight.BigFight.is_announce) {
          showedTime = this._data.bb.bigFight.BigFight.time_to_start;
        } else {
          showedTime = this._data.bb.bigFight.BigFight.time_to_end;
        }
        date = new Date(time + showedTime * 1000);
        return $('div#bb-countdown').countdown(date, function(event) {
          return $(this).text(event.strftime('%D %H:%M:%S'));
        });
      } else {
        return $('div#bb-countdown').text('');
      }
    };

    return BBView;

  })(ItemView);
  return BBView;
});
