var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/feed.tmpl', 'views/components/clusterize-helper', 'chosen'], function(app, ItemView, _, template, ClusterizeHelper, chosen) {
  var NewsFeedView;
  NewsFeedView = (function(superClass) {
    extend(NewsFeedView, superClass);

    function NewsFeedView() {
      this.onFeedTabClick = bind(this.onFeedTabClick, this);
      this.filterChange = bind(this.filterChange, this);
      this.triggerUpdateMessagesNewCount = bind(this.triggerUpdateMessagesNewCount, this);
      this.updateMessagesNewCount = bind(this.updateMessagesNewCount, this);
      return NewsFeedView.__super__.constructor.apply(this, arguments);
    }

    NewsFeedView.prototype.template = template;

    NewsFeedView.prototype.defaultGroup = 'politics';

    NewsFeedView.prototype.defaultSubgroup = null;

    NewsFeedView.prototype.data = {
      feed: {
        pointer: 'groupFeed',
        group: function() {
          return this.options.group || this.defaultGroup;
        },
        subgroup: function() {
          return this.options.subgroup || this.defaultSubgroup;
        }
      }
    };

    NewsFeedView.prototype.events = {
      'click .js-feed': 'feedClick',
      'click .js-feed-tab': 'onFeedTabClick'
    };

    NewsFeedView.prototype.tabs = [
      {
        group: 'politics',
        subgroups: [
          {
            id: 'city',
            title: 'City'
          }, {
            id: 'parties',
            title: 'Parties'
          }, {
            id: 'parliament',
            title: 'Parliament'
          }
        ],
        title: app.tr('Politics')
      }, {
        group: 'economics',
        subgroups: [
          {
            id: 'work',
            title: 'Job'
          }, {
            id: 'companies',
            title: 'Companies'
          }, {
            id: 'corporations',
            title: 'Corporations'
          }, {
            id: 'stocks',
            title: 'Stocks'
          }, {
            id: 'trade-center',
            title: 'Trade center'
          }, {
            id: 'licenses',
            title: 'Licenses'
          }
        ],
        title: app.tr('Economics')
      }, {
        group: 'war',
        subgroups: [
          {
            id: 'stadium',
            title: 'Stadium'
          }, {
            id: 'hospital',
            title: 'Hospital'
          }, {
            id: 'military-base',
            title: 'Military base'
          }
        ],
        title: app.tr('War')
      }, {
        group: 'communication',
        subgroups: [
          {
            id: 'friends',
            title: 'Friends'
          }, {
            id: 'referrals',
            title: 'Referrals'
          }, {
            id: 'news',
            title: 'News'
          }
        ],
        title: app.tr('Communication')
      }, {
        group: 'personal',
        subgroups: [
          {
            id: 'quests',
            title: 'Quests'
          }, {
            id: 'progress',
            title: 'Progress'
          }, {
            id: 'havings',
            title: 'Havings'
          }, {
            id: 'suggestions',
            title: 'Suggestions'
          }
        ],
        title: app.tr('Personal')
      }
    ];

    NewsFeedView.prototype._currentSubgroup = null;

    NewsFeedView.prototype.feedGroupToScreens = {
      'sold_goods': 'trade-center',
      'item_breaking_military': 'profile',
      'item_breaking_havings': 'profile',
      'low_ammunition': 'profile',
      'no_ammunition': 'profile',
      'profession_level_up': 'profile/attributes',
      'doctor_licence_expired': 'hospital/licenses',
      'doctor_licence_points_left': 'profile/attributes',
      'coach_licence_expired': 'stadium/licenses',
      'coach_licence_points_left': 'profile/attributes',
      'medal': 'profile/awards',
      'personal_medal_earned': 'profile/awards',
      'level_up': 'profile',
      'level_up_bonus': 'profile',
      'level_up_bonus_money': 'profile',
      'level_up_bonus_items': 'profile',
      'level_up_bonus_referral_money': 'profile',
      'level_up_bonus_referral_items': 'profile',
      'pve_result': 'military-base/gangs',
      'pve_result_money': 'profile',
      'pve_result_items': 'profile',
      'pvp_result': 'military-base/pvp',
      'suggestion': 'suggestions',
      'personal_suggestions_daily': 'suggestions',
      'personal_suggestion_commented': 'suggestions',
      'personal_suggestion_approved': 'suggestions',
      'personal_sports_level': 'profile/attributes',
      'personal_sports_trauma': 'hospital',
      'personal_became_friends': 'friends',
      'personal_get_job_in_company': 'job',
      'friend_add_friend': 'friends',
      'friend_level_up': 'friends',
      'friend_opened_company': 'friends',
      'friend_became_shareholder': 'friends',
      'friend_moved_to_city': 'friends',
      'friend_became_parliamentary': 'friends',
      'friend_run_for_mayor': 'friends',
      'friend_became_mayor': 'friends',
      'friend_joined_party': 'friends',
      'friend_became_deputy': 'friends',
      'friend_left_party': 'friends',
      'friend_created_party': 'friends',
      'friend_wrote_post': 'friends',
      'friend_started_newspaper': 'friends',
      'politics': 'parties',
      'area_takeover': 'military-base/areas-takeover',
      'party_user_joined': 'parties',
      'party_user_left': 'parties',
      'party_user_donated': 'parties',
      'newspaper_subscription': 'news',
      'newspaper_global': 'news',
      'newspaper_city': 'news',
      'business': 'business',
      'production': 'business',
      'company_lot_sale': 'business',
      'company_lot_sale_all': 'business',
      'company_manager_add_lot': 'business',
      'company_manager_bought_lot': 'business',
      'company_hired_user': 'business',
      'company_fired_user': 'business',
      'company_user_brought_pp': 'business',
      'company_manager_changed_salary': 'business',
      'company_daily_stats': 'business',
      'company_not_enough_money_to_pay_salary': 'business',
      'company_not_enough_resources': 'business',
      'corporation_dividends_payed': 'business/corporations',
      'corporation_solution_voting_ended': 'business/corporations',
      'corporation_solution_voting_started': 'business/corporations',
      'city': 'maria',
      'city_got_cup': 'maria/cups',
      'city_win_title': 'maria/titles',
      'city_lost_title': 'maria/cups',
      'city_became_city_of_day': 'maria/titles',
      'city_bill_added': 'maria/bills',
      'city_bill_approved': 'maria/bills',
      'city_bill_rejected': 'maria/bills',
      'city_snap_election_started': 'maria',
      'city_corporation_stock_sold': 'trade-center',
      'city_parliamentary_elections_started': 'maria/government',
      'city_parliamentary_elections_ended': 'maria/government',
      'city_mayor_elections_started': 'maria/government',
      'city_mayor_elections_ended': 'maria/government',
      'city_area_takeovers_started': 'maria/districts',
      'city_area_takeovers_ended': 'maria/districts',
      'city_big_fight_started': '',
      'city_prestige_war_started': '',
      'quest_available': 'quests',
      'quest_completed': 'quests'
    };

    NewsFeedView.prototype.addListeners = function() {
      NewsFeedView.__super__.addListeners.apply(this, arguments);
      return this.listenTo(app, 'User.Feed.newMessageCount.update', this.updateMessagesNewCount);
    };

    NewsFeedView.prototype.updateMessagesNewCount = function(args) {
      if (!this._data.feed) {
        return;
      }
      this._data.feed.feedNewMessagesCount = args.data.body.value;
      if (args.data.body.value > 0) {
        this.$el.find('.message_count').show();
      } else {
        this.$el.find('.message_count').hide();
      }
      this.$el.find('.message_count').html(args.data.body.value);
      return true;
    };

    NewsFeedView.prototype.triggerUpdateMessagesNewCount = function(data) {
      var newFeedCount;
      if (data && data.feed && data.feed.feedNewMessagesCount) {
        newFeedCount = data.feed.feedNewMessagesCount;
        app.trigger('User.Feed.newMessageCount.update', {
          data: {
            body: {
              value: newFeedCount
            }
          }
        });
      }
      return true;
    };

    NewsFeedView.prototype.feedClick = function(event) {
      var feedGroup, postId, screen;
      feedGroup = event.currentTarget.getAttribute('data-group');
      if (feedGroup === 'newspaper_city' || feedGroup === 'newspaper_global' || feedGroup === 'newspaper_subscription') {
        postId = event.currentTarget.getAttribute('data-info');
        if (postId !== "") {
          this.lockUI();
          app.screens.dialog('news/article', {
            postId: postId
          }, (function(_this) {
            return function() {
              return _this.unlockUI;
            };
          })(this));
        }
      }
      screen = this.feedGroupToScreens[feedGroup];
      if (screen) {
        this.lockUI();
        return app.screens.main(screen);
      }
    };

    NewsFeedView.prototype.serializeData = function() {
      var data, i, len, tab, tabs;
      data = NewsFeedView.__super__.serializeData.apply(this, arguments);
      tabs = this.tabs;
      if (data.feed && data.feed.counters) {
        for (i = 0, len = tabs.length; i < len; i++) {
          tab = tabs[i];
          tab.eventsCount = data.feed.counters[tab.group] || 0;
        }
      }
      data.tabs = tabs;
      data.activeGroup = this.options.group || this.defaultGroup;
      data.activeSubgroup = this.options.subgroup || this.defaultSubgroup;
      return data;
    };

    NewsFeedView.prototype.onRender = function() {
      $('.custom-select').chosen({
        disable_search: true
      });
      return $('.custom-select').on('change', this.filterChange);
    };

    NewsFeedView.prototype.filterChange = function(event) {
      var group, subgroup;
      group = event.currentTarget[event.currentTarget.selectedIndex].dataset.group;
      subgroup = event.currentTarget[event.currentTarget.selectedIndex].dataset.subgroup;
      this.options.group = group;
      this.options.subgroup = subgroup;
      return this.reload();
    };

    NewsFeedView.prototype.onFeedTabClick = function(event) {
      var group, subgroup;
      group = event.currentTarget.dataset.group;
      subgroup = null;
      this.options.group = group;
      this.options.subgroup = subgroup;
      return this.reload();
    };

    return NewsFeedView;

  })(ItemView);
  return NewsFeedView;
});
