var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/friends/base', 'text!templates/friends.tmpl', 'text!templates/friends/blocks/friends-list.tmpl'], function(app, FriendsBaseView, template, listTemplate) {
  var FriendsView;
  FriendsView = (function(superClass) {
    extend(FriendsView, superClass);

    function FriendsView() {
      return FriendsView.__super__.constructor.apply(this, arguments);
    }

    FriendsView.prototype.className = 'friends-layout';

    FriendsView.prototype.template = template;

    FriendsView.prototype.listTemplate = listTemplate;

    FriendsView.prototype.data = {
      list: 'friends.list'
    };

    FriendsView.prototype.events = {
      'change .js-name': 'onNameChange',
      'click .js-remove': 'onRemoveClick'
    };

    FriendsView.prototype._groups = [
      {
        name: app.tr('Online'),
        fn: function(n) {
          return n && n.User.online;
        }
      }, {
        name: app.tr('Offline'),
        fn: function(n) {
          return n && !n.User.online;
        }
      }
    ];

    FriendsView.prototype.onRemoveClick = function(event) {
      var friendId, self;
      event.stopPropagation();
      self = this;
      app.showLoader();
      self.lockUI();
      friendId = event.currentTarget.getAttribute('data-id');
      return app.server.friends.remove_friend({
        friendId: friendId,
        success: function(data) {
          var ref;
          self.unlockUI();
          app.hideLoader();
          if (!data.error) {
            self._removeFriend(friendId);
            self._renderList();
          }
          return app.screens.modal('common/info-popup', {
            msg: (data != null ? (ref = data.setFlash[0]) != null ? ref.msg : void 0 : void 0) || app.tr('Server error')
          });
        },
        error: function(data) {
          var ref;
          self.unlockUI();
          app.hideLoader();
          return app.screens.modal('common/info-popup', {
            msg: (data != null ? (ref = data.setFlash[0]) != null ? ref.msg : void 0 : void 0) || app.tr('Server error')
          });
        }
      });
    };

    FriendsView.prototype._removeFriend = function(id) {
      var friend, i, j, len, ref;
      id = Number(id);
      ref = this._data.list.friends;
      for (i = j = 0, len = ref.length; j < len; i = ++j) {
        friend = ref[i];
        if (friend.User.id === id) {
          this._data.list.friends.splice(i, 1);
          return;
        }
      }
    };

    FriendsView.prototype.preprocessData = function(data) {
      if (!data.list) {
        return data;
      }
      data.requests_count = data.list.requests_count;
      data.totalCount = data.list.friends.length;
      data.groups = this._groupList(this._filterList(data.list.friends));
      return data;
    };

    return FriendsView;

  })(FriendsBaseView);
  return FriendsView;
});
