var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/friends/base', 'text!templates/friends/requests.tmpl', 'text!templates/friends/blocks/requests-list.tmpl'], function(app, FriendsBaseView, template, listTemplate) {
  var RequestsView;
  RequestsView = (function(superClass) {
    extend(RequestsView, superClass);

    function RequestsView() {
      return RequestsView.__super__.constructor.apply(this, arguments);
    }

    RequestsView.prototype.className = 'requests-layout';

    RequestsView.prototype.template = template;

    RequestsView.prototype.listTemplate = listTemplate;

    RequestsView.prototype.data = {
      list: 'friends.requests'
    };

    RequestsView.prototype.events = {
      'change .js-name': 'onNameChange',
      'click .js-accept': 'onAcceptClick',
      'click .js-reject': 'onRejectClick',
      'click .js-revoke': 'onRevokeClick',
      'click .js-profile': 'onProfileClick'
    };

    RequestsView.prototype._groups = [
      {
        name: app.tr('From me'),
        fn: function(n) {
          return n && n.UserFriend.user_id === app.userId;
        }
      }, {
        name: app.tr('To me'),
        fn: function(n) {
          return n && n.UserFriend.user_id !== app.userId;
        }
      }
    ];

    RequestsView.prototype.preprocessData = function(data) {
      if (!data.list) {
        return data;
      }
      data.totalCount = data.list.requests.length;
      data.groups = this._groupList(this._filterList(data.list.requests));
      return data;
    };

    RequestsView.prototype.onProfileClick = function(event) {
      var hasProfile, userId;
      event.stopPropagation();
      this.lockUI();
      userId = event.currentTarget.getAttribute('data-id');
      hasProfile = event.currentTarget.getAttribute('data-has-profile') === 'true';
      if (hasProfile) {
        return app.screens.dialog('users/profile', {
          userId: userId
        });
      }
    };

    RequestsView.prototype.onAcceptClick = function(event) {
      var friendId;
      event.stopPropagation();
      friendId = parseInt(event.currentTarget.getAttribute('data-id'), 10);
      if (!friendId) {
        return;
      }
      return this._changeRequestState(friendId, app.server.friends.accept_request);
    };

    RequestsView.prototype.onRejectClick = function(event) {
      var friendId;
      event.stopPropagation();
      friendId = parseInt(event.currentTarget.getAttribute('data-id'), 10);
      if (!friendId) {
        return;
      }
      return this._changeRequestState(friendId, app.server.friends.reject_request);
    };

    RequestsView.prototype.onRevokeClick = function(event) {
      var friendId;
      event.stopPropagation();
      friendId = parseInt(event.currentTarget.getAttribute('data-id'), 10);
      if (!friendId) {
        return;
      }
      return this._changeRequestState(friendId, app.server.friends.revoke_request);
    };

    RequestsView.prototype._removeRequest = function(id) {
      var i, j, len, ref, user;
      id = Number(id);
      ref = this._data.list.requests;
      for (i = j = 0, len = ref.length; j < len; i = ++j) {
        user = ref[i];
        if (user.User.id === id) {
          this._data.list.requests.splice(i, 1);
          return;
        }
      }
    };

    RequestsView.prototype._changeRequestState = function(friendId, serverfn) {
      var self;
      self = this;
      app.showLoader();
      self.lockUI();
      return serverfn({
        friendId: friendId,
        success: function(data) {
          var ref;
          self.unlockUI();
          app.hideLoader();
          if (!data.error) {
            self._removeRequest(friendId);
            self._renderList();
          }
          return app.screens.modal('common/info-popup', {
            msg: (data != null ? (ref = data.setFlash[0]) != null ? ref.msg : void 0 : void 0) || app.tr('Server error')
          });
        },
        error: function(data) {
          var ref;
          self.unlockUI();
          app.hideLoader();
          return app.screens.modal('common/info-popup', {
            msg: (data != null ? (ref = data.setFlash[0]) != null ? ref.msg : void 0 : void 0) || app.tr('Server error')
          });
        }
      });
    };

    return RequestsView;

  })(FriendsBaseView);
  return RequestsView;
});
