var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/inventory/energy-popup.tmpl', 'moment'], function(app, ItemView, _, template, moment) {
  var EnergyPopupView;
  EnergyPopupView = (function(superClass) {
    extend(EnergyPopupView, superClass);

    function EnergyPopupView() {
      return EnergyPopupView.__super__.constructor.apply(this, arguments);
    }

    EnergyPopupView.prototype.template = template;

    EnergyPopupView.prototype.required = ['itemTypeId'];

    EnergyPopupView.prototype.data = {
      item: {
        pointer: 'inventory.itemTypeInfo',
        itemTypeId: function() {
          return this.options.itemTypeId;
        }
      }
    };

    EnergyPopupView.prototype.events = {
      'click .js-use': 'useItem'
    };

    EnergyPopupView.prototype.useItem = function(event) {
      var loader, number, numberHelper;
      this.lockUI();
      number = this.$('.js-items-number').val();
      numberHelper = this.templateHelpers().numberHelper;
      if (numberHelper.isInteger(parseFloat(number))) {
        loader = this.setLoaderOnElement('.js-use', app.tr('Using'));
        return app.server.inventory.useEnergyDrink({
          itemId: this.options.itemId,
          itemTypeId: this.options.itemTypeId,
          count: number,
          success: (function(_this) {
            return function(data) {
              loader.remove();
              app.userEvents.trigger('energy:updated');
              return app.screens.close();
            };
          })(this),
          error: function(data) {
            loader.remove();
            app.screens.back();
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong!")
            });
          }
        });
      } else {
        this.unlockUI();
        return $('.js-int-error').removeClass('u-hide');
      }
    };

    return EnergyPopupView;

  })(ItemView);
  return EnergyPopupView;
});
