define(['app', 'views/item-view', 'underscore', 'text!templates/job/license-settings.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    className: 'no-bg-image',
    data: {
      licensesInfo: 'work.licenses.info'
    },
    events: {
      'click .o-switcher': 'changeCurrency',
      'click .js-save-changes': 'saveChanges'
    },
    preprocessData: function(data) {
      var ref, ref1, ref2;
      if (((ref = data.licensesInfo.doctor) != null ? ref.id : void 0) === parseInt(this.options.licenseId)) {
        data.license = data.licensesInfo.doctor;
        data.license.type = 'doctor';
      }
      if (((ref1 = data.licensesInfo.coach) != null ? ref1.id : void 0) === parseInt(this.options.licenseId)) {
        data.license = data.licensesInfo.coach;
        data.license.type = 'coach';
      }
      this.currency = ((ref2 = data.license) != null ? ref2.currency : void 0) != null ? data.license.currency : 'vg';
      return data;
    },
    changeCurrency: function(event) {
      $(event.currentTarget).toggleClass('o-switcher--active');
      if (this.$el.find('.o-switcher').hasClass('o-switcher--active')) {
        return this.currency = 'vg';
      } else {
        return this.currency = 'vd';
      }
    },
    saveChanges: function(event) {
      var licenseId, price;
      this.lockUI();
      price = parseFloat(this.$('.js-price').val()).toFixed(2);
      licenseId = event.currentTarget.getAttribute('data-license-id');
      if (licenseId != null) {
        return this.app.server.work.licenses.updateSettings({
          licenseId: licenseId,
          currency: this.currency,
          price: price,
          success: function(data) {
            if (data.error === 0) {
              return app.screens.back();
            }
          }
        });
      }
    },
    onRender: function() {
      return this.$('.js-price').change((function(_this) {
        return function(event) {
          var price;
          price = parseFloat($(event.currentTarget).val());
          if (!isNaN(price)) {
            return $(event.currentTarget).val(price.toFixed(2));
          } else {
            return $(event.currentTarget).val(_this._data.license.price);
          }
        };
      })(this));
    }
  });
});
