var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['underscore', 'views/item-view', 'text!templates/login/login-with-social.tmpl'], function(_, ItemView, template) {
  var LoginView;
  LoginView = (function(superClass) {
    extend(LoginView, superClass);

    function LoginView() {
      return LoginView.__super__.constructor.apply(this, arguments);
    }

    LoginView.prototype.className = 'sign-in-layout';

    LoginView.prototype.template = template;

    LoginView.prototype.events = {
      'click #js-show-form-btn': 'onShowFormBtnClick',
      'click #js-login-btn': 'onLoginBtnClick',
      'click #js-register-btn': 'onRegisterBtnClick'
    };

    LoginView.prototype.onDomRefresh = function(options) {
      return this.$el.closest('body').addClass('hide-short-info no-swipe');
    };

    LoginView.prototype.onRegisterBtnClick = function(event) {
      this.lockUI();
      return self.app.screens.dialog('login/sign-up-social', {
        user: this.options.user,
        provider: this.options.provider,
        token: this.options.token
      });
    };

    LoginView.prototype.onShowFormBtnClick = function(event) {
      event.preventDefault();
      this.$(event.currentTarget).addClass('u-hide');
      return this.$('#js-login-form-fields').removeClass('u-hide');
    };

    LoginView.prototype.onLoginBtnClick = function(event) {
      var form;
      this.lockUI();
      form = this.el.querySelector('#js-login-form');
      event.preventDefault();
      return this.app.server.auth({
        login: form.elements.login.value,
        password: form.elements.password.value,
        success: (function(_this) {
          return function() {
            return _this._linkAccount();
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            var ref;
            delete localStorage.auth;
            delete localStorage.auth_token;
            localStorage.removeItem("auth");
            localStorage.removeItem("auth_token");
            return _this.app.screens.modal('common/info-popup', {
              msg: ((ref = data.setFlash) != null ? ref[0].msg : void 0) || app.tr("Incorrect login or password")
            });
          };
        })(this)
      });
    };

    LoginView.prototype._linkAccount = function() {
      return this.app.server.social.linkAccount({
        provider: this.options.provider,
        socialUser: this.options.user,
        token: this.options.token,
        success: (function(_this) {
          return function(data) {
            var tutorialCb;
            if (data && (data != null ? data.user_id : void 0)) {
              tutorialCb = function() {
                if ((data.trigger_tutorial != null) && data.trigger_tutorial) {
                  return _this.app.tutorial.start();
                }
              };
              if ((data.registration_bonus != null) && data.registration_bonus) {
                app.vent.listenToOnce(app.screens, 'view:ready:quests', function() {
                  return app.screens.modal('common/registration-bonus', {
                    backCallback: tutorialCb
                  });
                });
              } else {
                app.vent.listenToOnce(app.screens, 'view:ready:quests', tutorialCb);
              }
              _this.app.setUserId(data.userId);
              _this.app.vent.trigger('auth:login', {
                user_id: data.userId
              });
              _this.app.screens.main('quests');
              _this.app.menu.init();
              _this.app.shortInfo.init();
              return _this.app.pushNotifications.init();
            } else {
              return _this.app.screens.modal('common/info-popup', {
                msg: app.tr('Authentication failed')
              });
            }
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            if (data && data.error_code === 'ACCOUNT_LINKED') {
              _this.app.screens.modal('common/info-popup', {
                msg: data.error_message
              });
              return;
            }
            return _this.app.screens.modal('common/info-popup', {
              msg: app.tr('Authentication failed')
            });
          };
        })(this)
      });
    };

    return LoginView;

  })(ItemView);
  return LoginView;
});
