var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/login/rules.tmpl'], function(app, ItemView, _, template) {
  var RulesView;
  RulesView = (function(superClass) {
    extend(RulesView, superClass);

    function RulesView() {
      return RulesView.__super__.constructor.apply(this, arguments);
    }

    RulesView.prototype.template = template;

    RulesView.prototype.events = {
      'click .js-policy-language': 'changeLanguage'
    };

    RulesView.prototype.initialize = function(options) {
      RulesView.__super__.initialize.call(this, options);
      this.ln = app.translations.getLocale();
      this._preloaded = {};
      return this._preloaded[this.ln] = {
        title: app.tr('GAME_RULES_PAGE_TITLE', this.ln),
        content: app.tr('GAME_RULES_PAGE_TEXT', this.ln)
      };
    };

    RulesView.prototype.changeLanguage = function(event) {
      var ln, self;
      self = this;
      ln = event.currentTarget.getAttribute('data-language');
      if (!self._preloaded[ln]) {
        app.showLoader();
        return app.server.translations.rules({
          locale: ln,
          success: function(data) {
            app.hideLoader();
            if (data) {
              self._preloaded[ln] = {
                title: data.title,
                content: data.content
              };
              self.ln = ln;
              return self.render();
            }
          },
          error: function() {
            return app.hideLoader();
          }
        });
      } else {
        self.ln = ln;
        return self.render();
      }
    };

    RulesView.prototype.serializeData = function() {
      return {
        title: this._preloaded[this.ln].title,
        content: this._preloaded[this.ln].content,
        selectedLn: this.ln,
        langs: {
          'rus': 'Russian',
          'eng': 'English',
          'pol': 'Polski'
        }
      };
    };

    return RulesView;

  })(ItemView);
  return RulesView;
});
