var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/business/create-company', 'underscore', 'text!templates/business/create-company.tmpl'], function(app, CreateCompanyView, _, template) {
  var MariaCreateCompanyView;
  MariaCreateCompanyView = (function(superClass) {
    extend(MariaCreateCompanyView, superClass);

    function MariaCreateCompanyView() {
      return MariaCreateCompanyView.__super__.constructor.apply(this, arguments);
    }

    MariaCreateCompanyView.prototype.template = template;

    MariaCreateCompanyView.prototype.preprocessData = function(data) {
      data = MariaCreateCompanyView.__super__.preprocessData.call(this, data);
      this.options.show_tiers = [1, 2, 3, 4];
      this.options.allowed_tiers = [1, 2, 3, 4];
      this.options.opened_tier = -1;
      this.options.show_required_level = false;
      return data;
    };

    MariaCreateCompanyView.prototype.createCompany = function(event) {
      var currency, itemId, name, typeId;
      this.lockUI();
      typeId = this.$('.js-selected').attr("data-type-id");
      itemId = this.$('.js-selected').attr("data-item-id");
      typeId = parseInt(typeId);
      name = this.$el.find('.js-name').val();
      if (isNaN(typeId)) {
        app.screens.modal('common/info-popup', {
          msg: app.tr("Select company type"),
          needReload: false
        });
        return;
      }
      currency = this.options.showVd ? 'vdollars' : 'vgold';
      if (name === "") {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("Specify the company's name"),
          needReload: false
        });
      } else {
        return app.server.cityHall.createCompany({
          type: typeId,
          name: name,
          currency: currency,
          itemId: itemId,
          success: function(data) {
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Company was created")
            }, app.screens.back());
          },
          error: function(data) {
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong"),
              needReload: false
            });
          }
        });
      }
    };

    return MariaCreateCompanyView;

  })(CreateCompanyView);
  return MariaCreateCompanyView;
});
