var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/maria/rebel-war.tmpl'], function(app, ItemView, _, template) {
  var RebelWar;
  RebelWar = (function(superClass) {
    extend(RebelWar, superClass);

    function RebelWar() {
      return RebelWar.__super__.constructor.apply(this, arguments);
    }

    RebelWar.prototype.template = template;

    RebelWar.prototype.data = {
      userStatus: 'user.status',
      rebelWar: {
        pointer: 'military.rebelWar.getInfo',
        rebelWarId: function() {
          return this.options.rebelWarId;
        }
      }
    };

    RebelWar.prototype.stats = {};

    RebelWar.prototype.currentStats = {};

    RebelWar.prototype.currency = 'vd';

    RebelWar.prototype.preprocessData = function(data) {
      if (data != null) {
        this.options.userSocialStatus = app.shortInfo.view._data.info.user.User.social_status;
        data.rebelWar.info.vd_balance = this.templateHelpers().numberHelper.numberFormat(data.rebelWar.info.vd_balance);
        data.rebels_percent = 0;
        _.forEach(data.rebelWar.info.data.clones_stats, (function(_this) {
          return function(stats) {
            var name, results, value;
            results = [];
            for (name in stats) {
              value = stats[name];
              _this.stats[name] = 0;
              results.push(_this.currentStats[name] = value);
            }
            return results;
          };
        })(this));
        if (data.rebelWar.info.data.rebels_count > 0) {
          data.rebels_percent = ((data.rebelWar.info.data.rebels_count / data.rebelWar.info.data.max_rebels_count) * 100).toFixed(1);
        }
      }
      return data;
    };

    RebelWar.prototype.events = {
      'click .js-agitation-switch': 'agitationSwitch',
      'click .js-training-switch': 'trainingSwitch',
      'click .js-donate': 'donate',
      'click .js-add-item': 'addItem',
      'click .js-start-arming': 'startArming',
      'click .js-start-combat': 'startCombat',
      'click .js-skill-up': 'skillUp',
      'click .js-train-rebels': 'trainRebels',
      'click .o-switcher': 'changeCurrency'
    };

    RebelWar.prototype.donate = function(event) {
      var STATUS_AGITATION, STATUS_PREPARE_FOR_COMBAT, loader, rebelWarId, rebelWarStatus, vdAmount, vgAmount;
      STATUS_AGITATION = "1";
      STATUS_PREPARE_FOR_COMBAT = "2";
      rebelWarId = this.options.rebelWarId;
      rebelWarStatus = this.$('input[name=status]').val();
      vdAmount = this.$('.js-amount-vd').val();
      vgAmount = this.$('.js-amount-vg').val();
      if (vdAmount === "") {
        vdAmount = 0;
      } else {
        vdAmount = parseFloat(vdAmount);
        if (isNaN(vdAmount)) {
          return app.screens.modal('common/info-popup', {
            msg: app.tr("The amount can only consist of digits")
          });
        } else if (vdAmount < 0) {
          return app.screens.modal('common/info-popup', {
            msg: app.tr("The amount must be greater than zero")
          });
        }
      }
      if (vgAmount === "") {
        vgAmount = 0;
      } else {
        vgAmount = parseFloat(vgAmount);
        if (isNaN(vgAmount)) {
          return app.screens.modal('common/info-popup', {
            msg: app.tr("The amount can only consist of digits")
          });
        } else if (vgAmount < 0) {
          return app.screens.modal('common/info-popup', {
            msg: app.tr("The amount must be greater than zero")
          });
        }
      }
      if (vdAmount + vgAmount > 0) {
        this.lockUI();
        if (rebelWarStatus === STATUS_AGITATION) {
          loader = this.setLoaderOnElement(event.currentTarget, app.tr('Agitating'));
          app.server.military.rebelWar.agitation_donate({
            rebelWarId: rebelWarId,
            vdAmount: vdAmount,
            vgAmount: vgAmount,
            success: function(data) {
              loader.remove();
              data.vdAmount = vdAmount;
              data.vgAmount = vgAmount;
              return app.screens.modal('maria/rebel_wars/agitation-popup', data);
            },
            error: function(data) {
              loader.remove();
              return app.screens.modal('common/info-popup', {
                msg: data.setFlash[0].msg || app.tr("Something went wrong")
              });
            }
          });
        }
        if (rebelWarStatus === STATUS_PREPARE_FOR_COMBAT) {
          loader = this.setLoaderOnElement(event.currentTarget, app.tr('Donating'));
          return app.server.military.rebelWar.donate({
            rebelWarId: rebelWarId,
            vdAmount: vdAmount,
            vgAmount: vgAmount,
            success: function(data) {
              loader.remove();
              data.vdAmount = vdAmount;
              data.vgAmount = vgAmount;
              return app.screens.modal('maria/rebel_wars/donate-popup', data);
            },
            error: function(data) {
              loader.remove();
              return app.screens.modal('common/info-popup', {
                msg: data.setFlash[0].msg || app.tr("Something went wrong")
              });
            }
          });
        }
      } else {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("Specify the sum")
        });
      }
    };

    RebelWar.prototype.startArming = function(event) {
      var loader;
      this.lockUI();
      loader = this.setLoaderOnElement(event.currentTarget, app.tr('Begin Arming'));
      return app.server.military.rebelWar.beginArming({
        rebelWarId: this.options.rebelWarId,
        success: function(data) {
          loader.remove();
          return app.screens.current.reload();
        },
        error: function(data) {
          loader.remove();
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Something went wrong")
          });
        }
      });
    };

    RebelWar.prototype.startCombat = function(event) {
      this.lockUI();
      return app.screens.modal('common/confirmation-popup', {
        msg: 'REBEL_WARS_START_COMBAT',
        callback: (function(_this) {
          return function() {
            var loader;
            loader = _this.setLoaderOnElement(event.currentTarget, app.tr('Begin Combat'));
            return app.server.military.rebelWar.beginCombat({
              rebelWarId: _this.options.rebelWarId,
              success: function(data) {
                loader.remove();
                return app.screens.main('military-base/areas-takeover');
              },
              error: function(data) {
                loader.remove();
                return app.screens.modal('common/info-popup', {
                  msg: data.setFlash[0].msg || app.tr("Something went wrong")
                });
              }
            });
          };
        })(this)
      });
    };

    RebelWar.prototype.skillUp = function(event) {
      var isFirstUpdate, name, ref, statName, statsCount, sum, value;
      sum = 0;
      statName = event.currentTarget.getAttribute('data-name');
      this.stats[statName]++;
      ref = this.currentStats;
      for (name in ref) {
        value = ref[name];
        statsCount = this.stats[name] + parseInt(value);
        isFirstUpdate = false;
        if (statsCount > 1 && this.stats[name] > 0) {
          if (parseInt(this.currentStats[name]) === 1) {
            isFirstUpdate = true;
          }
          sum = sum + this.calcUpdateStatsSum(statsCount, this.currency, isFirstUpdate);
        }
      }
      $('.js-skill-' + statName).html(parseInt(this.currentStats[statName]) + this.stats[statName]);
      return $('.js-stats-update-val').html(this.templateHelpers().numberHelper.numberFormat(sum.toFixed(2)));
    };

    RebelWar.prototype.trainRebels = function(event) {
      var loader, rebelWarId;
      this.lockUI();
      rebelWarId = event.currentTarget.getAttribute('data-rebel-war-id');
      loader = this.setLoaderOnElement(event.currentTarget, app.tr('Updating'));
      return app.server.military.rebelWar.trainRebels({
        rebelWarId: this.options.rebelWarId,
        stats: this.stats,
        currency: this.currency,
        success: (function(_this) {
          return function(data) {
            loader.remove();
            _this.stats = {
              rush: 0,
              hunter: 0,
              stealth: 0,
              preciseStrike: 0,
              strength: 0,
              agility: 0,
              stamina: 0
            };
            _this.currency = 'vd';
            return app.screens.current.reload();
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            loader.remove();
            _this.stats = {
              rush: 0,
              hunter: 0,
              stealth: 0,
              preciseStrike: 0,
              strength: 0,
              agility: 0,
              stamina: 0
            };
            _this.currency = 'vd';
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            }, app.screens.current.reload());
          };
        })(this)
      });
    };

    RebelWar.prototype.calcUpdateStatsSum = function(statsCount, currency, isFirstUpdate) {
      var i, j, price, ref, tmp;
      price = this._data.rebelWar.updateStatsCost['REBEL_WAR_STATS_UPDATE_START_PRICE_' + currency.toUpperCase()];
      tmp = 0;
      if (statsCount <= 2) {
        return price;
      }
      if (isFirstUpdate) {
        tmp = price;
      }
      for (i = j = 2, ref = statsCount - 1; 2 <= ref ? j <= ref : j >= ref; i = 2 <= ref ? ++j : --j) {
        price = price * 2;
      }
      return price + tmp;
    };

    RebelWar.prototype.agitationSwitch = function() {
      return $('.js-agitation').toggleClass('u-hide');
    };

    RebelWar.prototype.trainingSwitch = function() {
      return $('.js-training').toggleClass('u-hide');
    };

    RebelWar.prototype.changeCurrency = function(event) {
      $(event.currentTarget).toggleClass('o-switcher--active');
      this.currency = $(event.currentTarget).hasClass('o-switcher--active') ? 'vg' : 'vd';
      _.forEach(this._data.rebelWar.info.data.clones_stats, (function(_this) {
        return function(stats) {
          var name, results, value;
          results = [];
          for (name in stats) {
            value = stats[name];
            _this.stats[name] = 0;
            _this.currentStats[name] = value;
            results.push($('.js-skill-' + name).html(value));
          }
          return results;
        };
      })(this));
      return $('.js-stats-update-val').html(0);
    };

    RebelWar.prototype.addItem = function() {
      return app.screens.dialog('trade-center/rebel/category', {
        rebelWarId: this.options.rebelWarId
      }, function() {});
    };

    return RebelWar;

  })(ItemView);
  return RebelWar;
});
