define(['underscore', 'views/item-view', 'text!templates/mayor-election.tmpl'], function(_, ItemView, template) {
  return ItemView.extend({
    template: template,
    className: 'election-layout',
    data: {
      candidates: 'cityHall.mayorElection.candidates',
      info: 'cityHall.mayorElection.info'
    },
    events: {
      'click .js-vote': 'vote'
    },
    vote: function(event) {
      var candidateId;
      this.lockUI();
      candidateId = event.currentTarget.getAttribute('data-candidate-id');
      return app.server.cityHall.mayorElection.vote({
        candidateId: candidateId,
        success: function(data) {
          var ref;
          return app.screens.modal('common/success-popup', {
            msg: ((ref = data.setFlash) != null ? ref[0].msg : void 0) || ""
          });
        }
      });
    }
  });
});
