var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['underscore', 'views/item-view', 'text!templates/menu.tmpl'], function(_, ItemView, template) {
  var MenuView;
  MenuView = (function(superClass) {
    extend(MenuView, superClass);

    function MenuView() {
      return MenuView.__super__.constructor.apply(this, arguments);
    }

    MenuView.prototype.template = template;

    MenuView.prototype.events = {
      'click .js-goto-parties': 'showPartyInfo',
      'click .js-nested-menu': 'toggleGroup',
      'click .js-goto-url-wiki': 'openWikiUrl',
      'click .js-goto-url-vk': 'openVKUrl',
      'click .js-goto-url-fb': 'openFBUrl'
    };

    MenuView.prototype.data = {
      badges: 'user.notification_badges',
      info: 'user.info.short',
      bb: 'events.bb.silent',
      election: 'events.election.silent',
      ot: 'events.ot.silent',
      at: 'military.at.areas',
      at_result: 'military.at.areasArchive',
      parties: 'party.list'
    };

    MenuView.prototype._groupsOpened = {};

    MenuView.prototype.initialize = function() {
      this._groupsOpened = {};
      return MenuView.__super__.initialize.apply(this, arguments);
    };

    MenuView.prototype.serializeData = function() {
      var data;
      data = MenuView.__super__.serializeData.apply(this, arguments);
      if (data) {
        data.groupsOpened = this._groupsOpened;
      }
      if (data && data.badges) {
        data.badges.informationGroupCount = 0;
        if (data.badges.feedCount) {
          data.badges.informationGroupCount += data.badges.feedCount;
        }
        if (data.badges.completedQuests) {
          data.badges.informationGroupCount += data.badges.completedQuests.completed;
        }
        data.badges.communicationGroupCount = 0;
        if (data.badges.postsCount) {
          data.badges.communicationGroupCount += data.badges.postsCount;
        }
        if (data.badges.messagesCount) {
          data.badges.communicationGroupCount += data.badges.messagesCount;
        }
        if (data.badges.friendshipRequestsCount) {
          data.badges.communicationGroupCount += data.badges.friendshipRequestsCount;
        }
      }
      return data;
    };

    MenuView.prototype.closeAllGroups = function() {
      var group, groupEl, groups, i, len;
      groups = this.el.querySelectorAll('.js-nested-menu');
      if (groups) {
        for (i = 0, len = groups.length; i < len; i++) {
          groupEl = groups[i];
          groupEl.parentNode.classList.add('nested-menu--collapsed');
          groupEl.parentNode.classList.remove('nested-menu--expanded');
          group = event.currentTarget.getAttribute('data-group');
          this._groupsOpened[group] = false;
        }
      }
    };

    MenuView.prototype.openGroup = function(group) {
      var groupEl;
      groupEl = this.el.querySelector('#menu-group-' + group);
      if (groupEl) {
        this._groupsOpened[group] = true;
        groupEl.classList.add('nested-menu--expanded');
        return groupEl.classList.remove('nested-menu--collapsed');
      }
    };

    MenuView.prototype.closeGroup = function(group) {
      var groupEl;
      groupEl = this.el.querySelector('#menu-group-' + group);
      if (groupEl) {
        this._groupsOpened[group] = false;
        groupEl.classList.remove('nested-menu--expanded');
        return groupEl.classList.add('nested-menu--collapsed');
      }
    };

    MenuView.prototype.toggleGroup = function(event) {
      var group;
      group = event.currentTarget.getAttribute('data-group');
      if (this._groupsOpened[group] && !!this._groupsOpened[group]) {
        this._groupsOpened[group] = false;
      } else {
        this._groupsOpened[group] = true;
      }
      event.currentTarget.parentNode.classList.toggle('nested-menu--expanded');
      event.currentTarget.parentNode.classList.toggle('nested-menu--collapsed');
      return 1;
    };

    MenuView.prototype.openWikiUrl = function() {
      var url;
      url = app.config.wikiURL;
      url = url + (url.indexOf('?') === -1 ? '?' : '&') + 'setlang=' + app.translations.getLn();
      return window.open(url, '_system');
    };

    MenuView.prototype.openVKUrl = function() {
      return window.open(app.config.vkGroupURL, '_system');
    };

    MenuView.prototype.openFBUrl = function() {
      return window.open(app.config.fbGroupURL, '_system');
    };

    MenuView.prototype.addListeners = function() {
      MenuView.__super__.addListeners.apply(this, arguments);
      this.listenTo(app, 'User.messages.UnreadCount.update', this.updateMessagesUnreadCount);
      this.listenTo(app, 'User.Friends.RequestCount.update', this.updateFriendsRequestCount);
      this.listenTo(app, 'User.Feed.newMessageCount.update', this.updateFeedNewMessageCount);
      return this.listenTo(app, 'quest_finished', this.updateFinishedQuests);
    };

    MenuView.prototype.updateFinishedQuests = function(args) {
      var exists, i, len, quest, ref;
      if (!this._data || !this._data.badges || !this._data.badges.completedQuests) {
        return;
      }
      exists = false;
      ref = this._data.badges.completedQuests.list;
      for (i = 0, len = ref.length; i < len; i++) {
        quest = ref[i];
        if (quest.id === args.data.quest.id) {
          exists = true;
          break;
        }
      }
      if (!exists) {
        this._data.badges.completedQuests.list.push(args.data.quest);
        this._data.badges.completedQuests.completed = this._data.badges.completedQuests.list.length;
        return this.render();
      }
    };

    MenuView.prototype.updateMessagesUnreadCount = function(args) {
      if (!this._data || !this._data.badges) {
        return;
      }
      this._data.badges.messagesCount = args.data.body.value;
      return this.render();
    };

    MenuView.prototype.updateFriendsRequestCount = function(args) {
      if (!this._data || !this._data.badges) {
        return;
      }
      this._data.badges.friendshipRequestsCount = args.data.body.value;
      return this.render();
    };

    MenuView.prototype.updateFeedNewMessageCount = function(args) {
      if (!this._data || !this._data.badges) {
        return;
      }
      this._data.badges.feedCount = args.data.body.value;
      return this.render();
    };

    MenuView.prototype.showPartyInfo = function(event) {
      var partyId;
      this.lockUI();
      partyId = event.currentTarget.getAttribute('data-party-id');
      return app.screens.dialog('parties/common', {
        screen_options: partyId,
        partyId: partyId
      });
    };

    return MenuView;

  })(ItemView);
  return MenuView;
});
