define(['app', 'views/users/search', 'velocity-ui'], function(app, UserSearchView) {
  return UserSearchView.extend({
    events: {
      'click #js-main-list-load-more': 'onLoadMore',
      'click .js-online-switch': 'onOnlineSwitchChange',
      'change .js-name': 'onNameChange',
      'click .js-profile': 'onProfileClick',
      'click .js-list-element': 'onListElementClick'
    },
    onListElementClick: function(event) {
      var el, profileEl, userId;
      el = event.currentTarget;
      profileEl = el.querySelector('.js-profile');
      if (!profileEl) {
        return;
      }
      userId = parseInt(profileEl.getAttribute('data-id'), 10);
      if (userId && userId !== app.userId) {
        return app.screens.dialog('messages/conversations', {
          userId: userId
        });
      }
    }
  });
});
