var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/military-base/areas-takeover.tmpl', 'jquery.countdown'], function(app, ItemView, _, template, countdown) {
  var AreasTakeoverView;
  AreasTakeoverView = (function(superClass) {
    extend(AreasTakeoverView, superClass);

    function AreasTakeoverView() {
      return AreasTakeoverView.__super__.constructor.apply(this, arguments);
    }

    AreasTakeoverView.prototype.template = template;

    AreasTakeoverView.prototype.className = 'military-layout';

    AreasTakeoverView.prototype.data = {
      user: 'user.info.short',
      info: 'military.info',
      areas: 'military.at.areas',
      areasArchive: 'military.at.areasArchive'
    };

    AreasTakeoverView.prototype.events = {
      'click .js-goto-tacticel-map': 'gotoTacticalMap',
      'click .js-toggle-info': 'toggleInfo'
    };

    AreasTakeoverView.prototype.rebelWarTypeId = 2;

    AreasTakeoverView.prototype.preprocessData = function(data) {
      var a, area, i, len, mobilizationAreas, ref;
      if (!data || !data.areas) {
        return data;
      }
      mobilizationAreas = [];
      ref = data.areas;
      for (i = 0, len = ref.length; i < len; i++) {
        area = ref[i];
        if (area.areaType === this.rebelWarTypeId) {
          area.isRebelWar = true;
        } else {
          area.isRebelWar = false;
        }
        if (data.user.user.User.city_id === area.defendersCityId && area.preparation) {
          mobilizationAreas.push(area);
          a = 1;
        }
      }
      data.mobilizationAreas = mobilizationAreas;
      return data;
    };

    AreasTakeoverView.prototype.pvpRequest = function() {
      this.lockUI();
      return app.server.military.pvp.request();
    };

    AreasTakeoverView.prototype.gotoTacticalMap = function(event) {
      var areaId, isRebelWar, isRebelWarStrVal, rebelWarId;
      this.lockUI();
      areaId = event.currentTarget.getAttribute('data-area-id');
      isRebelWarStrVal = event.currentTarget.getAttribute('data-rebel-war');
      isRebelWar = isRebelWarStrVal === 'true';
      rebelWarId = event.currentTarget.getAttribute('data-rebel-war-id');
      return app.screens.dialog('military-base/tactical-map', {
        areaId: areaId,
        isRebelWar: isRebelWar,
        rebelWarId: rebelWarId
      });
    };


    /*
    			Center cloud
     */

    AreasTakeoverView.prototype.centerCloud = function() {
      var height;
      if ($('.c-cloud').length > 0) {
        height = $('.js-current-screen').outerHeight() - $('.c-header-wrapper').outerHeight() - $('.c-cloud').outerHeight();
        return $('.c-cloud').css('margin-top', height / 2);
      }
    };

    AreasTakeoverView.prototype.onDomRefresh = function() {
      var area, i, j, len, len1, ref, ref1, results;
      this.centerCloud();
      if (this._data.areas != null) {
        ref = this._data.areas;
        for (i = 0, len = ref.length; i < len; i++) {
          area = ref[i];
          this.$(".js-militarization-countdown#" + area.areaTakeoverId).countdown(Date.now() + area.preparationLeft * 1000, (function(_this) {
            return function(event) {
              return $(event.currentTarget).text(event.strftime('%-H:%M:%S'));
            };
          })(this)).on('finish.countdown', (function(_this) {
            return function(ev) {
              return _this.reload();
            };
          })(this));
        }
      }
      if (this._data.mobilizationAreas != null) {
        ref1 = this._data.mobilizationAreas;
        results = [];
        for (j = 0, len1 = ref1.length; j < len1; j++) {
          area = ref1[j];
          results.push(this.$(".js-mobilization-countdown#mobilization" + area.areaTakeoverId).countdown(Date.now() + area.preparationLeft * 1000, (function(_this) {
            return function(event) {
              return $(event.currentTarget).text(event.strftime('%-H:%M:%S'));
            };
          })(this)).on('finish.countdown', (function(_this) {
            return function(ev) {
              return $(event.currentTarget).parent('.js-mobilization-warning').remove();
            };
          })(this)));
        }
        return results;
      }
    };

    AreasTakeoverView.prototype.toggleInfo = function(event) {
      return this.$el.find('.js-hidden-info').toggleClass('u-hide');
    };

    return AreasTakeoverView;

  })(ItemView);
  return AreasTakeoverView;
});
