var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/military-base/combat-skills-popup.tmpl'], function(app, ItemView, _, template) {
  var CombatSkillsPopup;
  CombatSkillsPopup = (function(superClass) {
    extend(CombatSkillsPopup, superClass);

    function CombatSkillsPopup() {
      return CombatSkillsPopup.__super__.constructor.apply(this, arguments);
    }

    CombatSkillsPopup.prototype.template = template;

    CombatSkillsPopup.prototype.data = {
      info: 'fightPoints.info'
    };

    CombatSkillsPopup.prototype.events = {
      'click .js-skill-up': 'fightSkillUp',
      'click .js-apply': 'apply'
    };

    CombatSkillsPopup.prototype.initialSkillPoints = {};

    CombatSkillsPopup.prototype.skillPoints = {};

    CombatSkillsPopup.prototype.pointsLeft = 0;

    CombatSkillsPopup.prototype.pointsUsed = 0;

    CombatSkillsPopup.prototype.initialize = function(options) {
      this.skillPoints = {};
      this.pointsLeft = 0;
      this.pointsUsed = 0;
      return CombatSkillsPopup.__super__.initialize.apply(this, arguments);
    };

    CombatSkillsPopup.prototype.preprocessData = function(data) {
      var i, len, ref, skill;
      if (data && data.info.userId) {
        this.pointsLeft = Number(data.info.profile.User.fight_points);
        ref = data.info.fight_skills;
        for (i = 0, len = ref.length; i < len; i++) {
          skill = ref[i];
          this.initialSkillPoints[skill.UserFightSkill.fight_skill_type_id] = skill.UserFightSkill.level;
        }
        console.log(this.pointsLeft, this.initialSkillPoints);
      }
      return data;
    };

    CombatSkillsPopup.prototype.fightSkillUp = function(event) {
      var fightSkillTypeId;
      if (this.pointsLeft < 1) {
        return;
      }
      fightSkillTypeId = Number(event.currentTarget.getAttribute('data-skillType-id'));
      this.pointsLeft--;
      this.pointsUsed++;
      if (this.skillPoints[fightSkillTypeId] != null) {
        this.skillPoints[fightSkillTypeId] += 1;
      } else {
        this.skillPoints[fightSkillTypeId] = 1;
      }
      this.updateCounter(fightSkillTypeId);
      this.setPointsLeft(this.pointsLeft);
      this.trigger("points:left", this.pointsLeft);
      return this.enableApplyBtn();
    };

    CombatSkillsPopup.prototype.updateCounter = function(fightSkillTypeId) {
      var el;
      el = this.el.querySelector('#js-level-' + fightSkillTypeId);
      el.innerHTML = this.skillPoints[fightSkillTypeId] + this.initialSkillPoints[fightSkillTypeId];
      return el.classList.add('u-c--blue');
    };

    CombatSkillsPopup.prototype.setPointsLeft = function(points) {
      if (!this._pointsLeftEl) {
        this._pointsLeftEl = this.el.querySelector('#js-fight-points');
      }
      return this._pointsLeftEl.innerHTML = points;
    };

    CombatSkillsPopup.prototype.enableApplyBtn = function() {
      if (!this._applyBtnShown) {
        this._applyBtnShown = true;
        return this.el.querySelector('#js-apply').removeAttribute('disabled');
      }
    };

    CombatSkillsPopup.prototype.disableApplyBtn = function() {
      if (this._applyBtnShown) {
        this._applyBtnShown = false;
        return this.el.querySelector('#js-apply').setAttribute('disabled', 'disabled');
      }
    };

    CombatSkillsPopup.prototype.resetCountersHightLights = function() {
      var element, elements, i, len, results;
      elements = this.el.querySelectorAll('.js-skill-level');
      results = [];
      for (i = 0, len = elements.length; i < len; i++) {
        element = elements[i];
        results.push(element.classList.remove('u-c--blue'));
      }
      return results;
    };

    CombatSkillsPopup.prototype.apply = function(event) {
      this.lockUI();
      if (this.pointsUsed < 1) {
        return;
      }
      return app.server.fightPoints.upLevelBulk({
        skillPoints: this.skillPoints,
        success: (function(_this) {
          return function(data) {
            var i, len, ref, skill;
            _this.unlockUI();
            _this.skillPoints = {};
            _this.pointsUsed = 0;
            _this.disableApplyBtn();
            _this.resetCountersHightLights();
            ref = data.fight_skills;
            for (i = 0, len = ref.length; i < len; i++) {
              skill = ref[i];
              _this.initialSkillPoints[skill.UserFightSkill.fight_skill_type_id] = skill.UserFightSkill.level;
            }
            if (_this.pointsLeft < 1) {
              _this.jsBack();
            }
            if (!_this.onBack) {
              return app.screens.modal('common/info-popup', {
                msg: data.setFlash[0].msg || app.tr("Skills updated")
              });
            }
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            _this.unlockUI();
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            });
          };
        })(this)
      });
    };

    return CombatSkillsPopup;

  })(ItemView);
  return CombatSkillsPopup;
});
