var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/military-base/fight-result-popup.tmpl'], function(app, ItemView, _, template) {
  var FightResultPopup;
  FightResultPopup = (function(superClass) {
    extend(FightResultPopup, superClass);

    function FightResultPopup() {
      return FightResultPopup.__super__.constructor.apply(this, arguments);
    }

    FightResultPopup.prototype.template = template;

    FightResultPopup.prototype.events = {
      'click .js-goto-pve-log': 'gotoPvELog',
      'click .js-toggle-accordeon': 'toggleAccordeon'
    };

    FightResultPopup.prototype.initialize = function(options) {
      this.processClones();
      return FightResultPopup.__super__.initialize.apply(this, arguments);
    };

    FightResultPopup.prototype.processClones = function() {
      var clone, enemy, helpers;
      helpers = this.mixinTemplateHelpers();
      clone = {
        name: this.options.clone.name,
        avatar: helpers.minAvatar(this.options.clone.avatar)
      };
      if (this.options.fightType === 'pve') {
        enemy = {
          avatar: "http://" + app.config.serverURL + "/img/bands/" + this.options.enemies[0].avatar
        };
        if (this.options.enemies.length === 1) {
          enemy.name = this.options.enemies[0].name;
        } else {
          enemy.name = app.tr('Group of bandits');
        }
      } else {
        enemy = {
          name: this.options.enemy.name,
          avatar: "./images/avatars/" + (this.options.enemy.avatar.replace('.png', '')) + "_avatar.png"
        };
      }
      if (this.options.userWin) {
        this.options.winner = clone;
        return this.options.looser = enemy;
      } else {
        this.options.winner = enemy;
        return this.options.looser = clone;
      }
    };

    FightResultPopup.prototype.toggleAccordeon = function(event) {
      var arrowEl, blockEl, blockId, expanded;
      arrowEl = event.currentTarget;
      blockId = arrowEl.getAttribute('data-block-id');
      blockEl = this.el.querySelector(".js-block[data-block-id=\"" + blockId + "\"]");
      expanded = arrowEl.getAttribute('data-expanded') === 'true';
      if (expanded) {
        arrowEl.setAttribute('data-expanded', 'false');
        arrowEl.classList.add('c-icon-arrow-up-4');
        arrowEl.classList.remove('c-icon-arrow-down-4');
        return blockEl.classList.add('hidden');
      } else {
        arrowEl.setAttribute('data-expanded', 'true');
        arrowEl.classList.remove('c-icon-arrow-up-4');
        arrowEl.classList.add('c-icon-arrow-down-4');
        return blockEl.classList.remove('hidden');
      }
    };

    FightResultPopup.prototype.gotoPvELog = function() {
      this.lockUI();
      return app.screens.tab('military-base/fight-log-popup', this.options);
    };

    FightResultPopup.prototype.onDomRefresh = function() {
      return this.$el.find('.c-popup__height').css('max-height', $(window).height() - 300);
    };

    return FightResultPopup;

  })(ItemView);
  return FightResultPopup;
});
