define(['app', 'views/item-view', 'underscore', 'text!templates/military-base/tactical-map.tmpl', 'jquery.countdown'], function(app, ItemView, _, template, countdown) {
  return ItemView.extend({
    template: template,
    className: 'o-tactical-map dont-reload',
    data: {
      userStatus: 'user.status',
      cities: 'cities',
      map: {
        pointer: 'military.at.areas.map',
        areaId: function() {
          return this.options.areaId;
        }
      },
      ignore: function() {
        return this.options.map != null;
      }
    },
    blankMap: {
      cellSize: 97 / 2,
      cellsPerTileSide: 4,
      id: 1,
      widthInTiles: 5,
      heightInTiles: 5,
      tiles_folder: 'map-1',
      posts: [],
      connections: []
    },
    testMap1: {
      "cellSize": 48.5,
      "cellsPerTileSide": 4,
      "id": 1,
      "widthInTiles": 5,
      "heightInTiles": 5,
      "tiles_folder": 'map-1',
      "posts": [
        {
          "x": 3,
          "y": 3,
          "side": "assailants"
        }, {
          "x": 3,
          "y": 5,
          "side": "neutral"
        }, {
          "x": 3,
          "y": 7,
          "side": "defenders"
        }, {
          "x": 2,
          "y": 2,
          "side": "assailants"
        }, {
          "x": 4,
          "y": 2,
          "side": "assailants"
        }, {
          "x": 2,
          "y": 8,
          "side": "defenders"
        }, {
          "x": 4,
          "y": 8,
          "side": "defenders"
        }
      ],
      "connections": [
        {
          "x1": 3,
          "y1": 5,
          "x2": 3,
          "y2": 7
        }, {
          "x1": 3,
          "y1": 5,
          "x2": 3,
          "y2": 3
        }, {
          "x1": 3,
          "y1": 7,
          "x2": 4,
          "y2": 8
        }, {
          "x1": 3,
          "y1": 7,
          "x2": 2,
          "y2": 8
        }, {
          "x1": 3,
          "y1": 3,
          "x2": 2,
          "y2": 2
        }, {
          "x1": 3,
          "y1": 3,
          "x2": 4,
          "y2": 2
        }
      ]
    },
    testMap2: {
      cellSize: 97 / 2,
      cellsPerTileSide: 4,
      id: 1,
      widthInTiles: 5,
      heightInTiles: 5,
      tiles_folder: 'map-1',
      posts: [
        {
          x: 0,
          y: 0,
          side: 'assailants'
        }, {
          x: 2,
          y: 0,
          side: 'assailants'
        }, {
          x: 0,
          y: 2,
          side: 'defenders'
        }, {
          x: 2,
          y: 2,
          side: 'defenders'
        }, {
          x: 0,
          y: 4,
          side: 'assailants'
        }, {
          x: 2,
          y: 4,
          side: 'neutral'
        }, {
          x: 0,
          y: 6,
          side: 'neutral'
        }, {
          x: 2,
          y: 6,
          side: 'assailants'
        }, {
          x: 0,
          y: 8,
          side: 'defenders'
        }, {
          x: 2,
          y: 8,
          side: 'neutral'
        }, {
          x: 0,
          y: 10,
          side: 'neutral'
        }, {
          x: 2,
          y: 10,
          side: 'defenders'
        }, {
          x: 4,
          y: 0,
          side: 'assailants'
        }, {
          x: 4,
          y: 2,
          side: 'assailants'
        }, {
          x: 6,
          y: 0,
          side: 'defenders'
        }, {
          x: 6,
          y: 2,
          side: 'defenders'
        }, {
          x: 4,
          y: 4,
          side: 'assailants'
        }, {
          x: 4,
          y: 6,
          side: 'neutral'
        }, {
          x: 6,
          y: 4,
          side: 'neutral'
        }, {
          x: 6,
          y: 6,
          side: 'assailants'
        }, {
          x: 4,
          y: 8,
          side: 'defenders'
        }, {
          x: 4,
          y: 10,
          side: 'neutral'
        }, {
          x: 6,
          y: 8,
          side: 'neutral'
        }, {
          x: 6,
          y: 10,
          side: 'defenders'
        }, {
          x: 8,
          y: 0,
          side: 'assailants'
        }, {
          x: 9,
          y: 1,
          side: 'assailants'
        }, {
          x: 10,
          y: 0,
          side: 'defenders'
        }, {
          x: 11,
          y: 1,
          side: 'defenders'
        }, {
          x: 8,
          y: 3,
          side: 'assailants'
        }, {
          x: 9,
          y: 4,
          side: 'neutral'
        }, {
          x: 10,
          y: 3,
          side: 'neutral'
        }, {
          x: 11,
          y: 4,
          side: 'assailants'
        }, {
          x: 8,
          y: 6,
          side: 'defenders'
        }, {
          x: 9,
          y: 7,
          side: 'neutral'
        }, {
          x: 10,
          y: 6,
          side: 'neutral'
        }, {
          x: 11,
          y: 7,
          side: 'defenders'
        }, {
          x: 14,
          y: 0,
          side: 'assailants'
        }, {
          x: 13,
          y: 1,
          side: 'assailants'
        }, {
          x: 16,
          y: 0,
          side: 'defenders'
        }, {
          x: 15,
          y: 1,
          side: 'defenders'
        }, {
          x: 14,
          y: 3,
          side: 'assailants'
        }, {
          x: 13,
          y: 4,
          side: 'neutral'
        }, {
          x: 16,
          y: 3,
          side: 'neutral'
        }, {
          x: 15,
          y: 4,
          side: 'assailants'
        }, {
          x: 14,
          y: 6,
          side: 'defenders'
        }, {
          x: 13,
          y: 7,
          side: 'neutral'
        }, {
          x: 16,
          y: 6,
          side: 'neutral'
        }, {
          x: 15,
          y: 7,
          side: 'defenders'
        }
      ],
      connections: [
        {
          x1: 0,
          y1: 0,
          x2: 2,
          y2: 0
        }, {
          x1: 0,
          y1: 2,
          x2: 2,
          y2: 2
        }, {
          x1: 0,
          y1: 4,
          x2: 2,
          y2: 4
        }, {
          x1: 0,
          y1: 6,
          x2: 2,
          y2: 6
        }, {
          x1: 0,
          y1: 8,
          x2: 2,
          y2: 8
        }, {
          x1: 0,
          y1: 10,
          x2: 2,
          y2: 10
        }, {
          x1: 4,
          y1: 0,
          x2: 4,
          y2: 2
        }, {
          x1: 6,
          y1: 0,
          x2: 6,
          y2: 2
        }, {
          x1: 4,
          y1: 4,
          x2: 4,
          y2: 6
        }, {
          x1: 6,
          y1: 4,
          x2: 6,
          y2: 6
        }, {
          x1: 4,
          y1: 8,
          x2: 4,
          y2: 10
        }, {
          x1: 6,
          y1: 8,
          x2: 6,
          y2: 10
        }, {
          x1: 8,
          y1: 0,
          x2: 9,
          y2: 1
        }, {
          x1: 10,
          y1: 0,
          x2: 11,
          y2: 1
        }, {
          x1: 8,
          y1: 3,
          x2: 9,
          y2: 4
        }, {
          x1: 10,
          y1: 3,
          x2: 11,
          y2: 4
        }, {
          x1: 8,
          y1: 6,
          x2: 9,
          y2: 7
        }, {
          x1: 10,
          y1: 6,
          x2: 11,
          y2: 7
        }, {
          x1: 14,
          y1: 0,
          x2: 13,
          y2: 1
        }, {
          x1: 16,
          y1: 0,
          x2: 15,
          y2: 1
        }, {
          x1: 14,
          y1: 3,
          x2: 13,
          y2: 4
        }, {
          x1: 16,
          y1: 3,
          x2: 15,
          y2: 4
        }, {
          x1: 14,
          y1: 6,
          x2: 13,
          y2: 7
        }, {
          x1: 16,
          y1: 6,
          x2: 15,
          y2: 7
        }
      ]
    },
    preprocessData: function(data) {
      data.indexToLetters = this.indexToLetters;
      if (this.options.isRebelWar == null) {
        this.options.isRebelWar = false;
      }
      return data;
    },
    onDataLoadError: function(err) {
      this.app.server.cache[app.server.cachePointerToUrl['military.at.areasArchive']].invalidate();
      return this.app.screens.back();
    },
    onPost: function(event) {
      var postId, postSide;
      this.lockUI();
      postId = event.currentTarget.getAttribute('data-id');
      postSide = event.currentTarget.getAttribute('data-side');
      if (postSide === 'neutral') {
        return app.screens.modal('military-base/blockpost-popup', {
          areaId: this.options.areaId,
          rebelWarId: this.options.rebelWarId,
          roundId: this._data.map.roundId,
          postId: postId,
          userStatus: this._data.userStatus.userStatus,
          isRebelWar: this.options.isRebelWar,
          tacticalMap: this
        });
      } else {
        return app.screens.modal('military-base/blockpost-error-popup', {
          areaId: this.options.areaId,
          roundId: this._data.map.roundId,
          postId: postId
        });
      }
    },
    onDomRefresh: function() {
      var j, k, postsOverlaysEl, ref, ref1, ref2, windowHeight, windowWidth, x, y;
      if ((((ref = this._data) != null ? ref.map : void 0) != null) || (this.options.map != null)) {
        if (this.options.map != null) {
          this._data.map = this[this.options.map];
        }
        this.paddingTop = 0;
        this.paddingLeft = 0;
        this.cellSize = 97 / 2;
        this.cellsPerTileSide = 4;
        this.tilesFolder = this._data.map.tiles_folder;
        this.mapWidthInTiles = this._data.map.widthInTiles;
        this.mapHeightInTiles = this._data.map.heightInTiles;
        this.tileSize = this.cellSize * this.cellsPerTileSide;
        this.tilesLoaded = [];
        windowWidth = window.innerWidth;
        windowHeight = window.innerHeight;
        this.horizontalLoadDelta = Math.ceil(windowWidth / this.tileSize);
        this.verticalLoadDelta = Math.ceil(windowHeight / this.tileSize);
        this.outerEl = this.el.querySelector('.js-outer');
        this.outerEl.style.width = windowWidth + 'px';
        this.outerEl.style.height = windowHeight + 'px';
        this.outerEl.onscroll = this.onScroll.bind(this);
        $(window).resize((function(_this) {
          return function() {
            _this.outerEl.style.width = window.innerWidth + 'px';
            return _this.outerEl.style.height = window.innerHeight + 'px';
          };
        })(this));
        this.mapEl = this.el.querySelector('.js-map');
        this.tilesEl = this.mapEl.querySelector('.js-tiles');
        this.tilesEl.style.width = this.tileSize * this.mapWidthInTiles + 'px';
        this.tilesEl.style.height = this.tileSize * this.mapHeightInTiles + 'px';
        this.lettersEl = this.mapEl.querySelector('.js-letters');
        this.lettersEl.style.width = this.tileSize * this.mapWidthInTiles + 'px';
        this.numbersEl = this.mapEl.querySelector('.js-numbers');
        for (y = j = 0, ref1 = this.verticalLoadDelta; 0 <= ref1 ? j <= ref1 : j >= ref1; y = 0 <= ref1 ? ++j : --j) {
          for (x = k = 0, ref2 = this.horizontalLoadDelta; 0 <= ref2 ? k <= ref2 : k >= ref2; x = 0 <= ref2 ? ++k : --k) {
            this.loadTile(x, y);
          }
        }
        this.drawPosts();
        this.drawConnections();
        if (this.options.map) {
          this.tilesEl.onclick = this.onClickMapBlank.bind(this);
          postsOverlaysEl = this.el.querySelector('.js-posts-overlays');
          postsOverlaysEl.addEventListener('click', this.onClickMapBlank.bind(this));
        } else {
          [].forEach.call(this.el.querySelectorAll('.js-post-overlay'), (function(_this) {
            return function(el) {
              return el.addEventListener('click', _this.onPost.bind(_this));
            };
          })(this));
        }
        this.drawScoutNumbers(0, 1, 2);
        return this.$('.js-round-countdown').countdown(Date.now() + this._data.map.roundStartsIn * 1000, (function(_this) {
          return function(event) {
            return $(event.currentTarget).text(event.strftime('%M:%S'));
          };
        })(this)).on('finish.countdown', (function(_this) {
          return function(ev) {
            return setTimeout(function() {
              return app.screens.current.reload();
            }, 60000);
          };
        })(this));
      }
    },
    setScoutNumbers: function(postIndex, assailantsClonesNumber, defendersClonesNumber) {
      this.scoutingResult = {
        postIndex: postIndex,
        assailantsClonesNumber: assailantsClonesNumber,
        defendersClonesNumber: defendersClonesNumber
      };
      return this.drawScoutNumbers();
    },
    drawScoutNumbers: function() {
      var assailantsClonesNumber, defendersClonesNumber, numberEl, numberInnerEl, post, postIndex, postsNumbersEl, ref;
      postsNumbersEl = this.el.querySelector('.js-posts-numbers');
      postsNumbersEl.innerHTML = '';
      if (this.scoutingResult == null) {
        return;
      }
      ref = this.scoutingResult, postIndex = ref.postIndex, assailantsClonesNumber = ref.assailantsClonesNumber, defendersClonesNumber = ref.defendersClonesNumber;
      post = this._data.map.posts[postIndex];
      numberEl = document.createElement('div');
      numberEl.setAttribute('class', "u-fz-28 c-tactical-map__post-number c-tactical-map__post-number-defenders");
      numberEl.style.top = this.cellSize * post.y - this.cellSize / 4 + 'px';
      numberEl.style.left = this.cellSize * post.x + 'px';
      numberEl.style.width = this.cellSize + 'px';
      numberInnerEl = document.createElement('span');
      numberInnerEl.setAttribute('class', "c-tactical-map__post-number-inner");
      numberInnerEl.innerHTML = defendersClonesNumber;
      numberEl.appendChild(numberInnerEl);
      postsNumbersEl.appendChild(numberEl);
      numberEl = document.createElement('div');
      numberEl.setAttribute('class', "u-fz-28 c-tactical-map__post-number c-tactical-map__post-number-assailants");
      numberEl.style.top = this.cellSize * post.y + this.cellSize + 'px';
      numberEl.style.left = this.cellSize * post.x + 'px';
      numberEl.style.width = this.cellSize + 'px';
      numberInnerEl = document.createElement('span');
      numberInnerEl.setAttribute('class', "c-tactical-map__post-number-inner");
      numberInnerEl.innerHTML = assailantsClonesNumber;
      numberEl.appendChild(numberInnerEl);
      return postsNumbersEl.appendChild(numberEl);
    },
    onClickMapBlank: function(event) {
      if (event.shiftKey) {
        return this.onSelectPost(event);
      } else {
        return this.onTogglePost(event);
      }
    },
    onTogglePost: function(event) {
      var cellSize, i, index, j, len, map, offsetX, offsetY, post, rect, ref, x, y;
      rect = this.tilesEl.getBoundingClientRect();
      offsetX = rect.left;
      offsetY = rect.top;
      cellSize = this.cellSize;
      map = this._data.map;
      x = Math.floor((event.clientX - offsetX) / cellSize);
      y = Math.floor((event.clientY - offsetY) / cellSize);
      index = -1;
      ref = map.posts;
      for (i = j = 0, len = ref.length; j < len; i = ++j) {
        post = ref[i];
        if (post.x === x && post.y === y) {
          index = i;
          break;
        }
      }
      if (index === -1) {
        map.posts.push({
          x: x,
          y: y,
          side: 'assailants'
        });
      } else {
        post = map.posts[index];
        if (post.side === 'assailants') {
          post.side = 'defenders';
        } else if (post.side === 'defenders') {
          post.side = 'neutral';
        } else {
          map.posts.splice(index, 1);
        }
      }
      this.drawPosts();
      return this.drawConnections();
    },
    onSelectPost: function(event) {
      var cellSize, found, i, index, j, len, map, offsetX, offsetY, post, rect, ref, x, y;
      rect = this.tilesEl.getBoundingClientRect();
      offsetX = rect.left;
      offsetY = rect.top;
      cellSize = this.cellSize;
      map = this._data.map;
      x = Math.floor((event.clientX - offsetX) / cellSize);
      y = Math.floor((event.clientY - offsetY) / cellSize);
      index = -1;
      ref = map.posts;
      for (i = j = 0, len = ref.length; j < len; i = ++j) {
        post = ref[i];
        if (post.x === x && post.y === y) {
          index = i;
          break;
        }
      }
      if (index !== -1) {
        post = map.posts[index];
        if (this.selectedPost && this.selectedPost !== post) {
          found = false;
          map.connections = map.connections.filter((function(_this) {
            return function(c) {
              if ((c.x1 === post.x && c.y1 === post.y && c.x2 === _this.selectedPost.x && c.y2 === _this.selectedPost.y) || (c.x2 === post.x && c.y2 === post.y && c.x1 === _this.selectedPost.x && c.y1 === _this.selectedPost.y)) {
                found = true;
                return false;
              } else {
                return true;
              }
            };
          })(this));
          if (!found) {
            map.connections.push({
              x1: post.x,
              y1: post.y,
              x2: this.selectedPost.x,
              y2: this.selectedPost.y
            });
          }
          this.drawConnections();
          return this.selectedPost = null;
        } else {
          return this.selectedPost = post;
        }
      }
    },
    onScroll: function() {
      var j, ref, ref1, results, tileIndex, tileX, tileY, x, y;
      this.lettersEl.style.left = -this.outerEl.scrollLeft + 'px';
      this.numbersEl.style.top = -this.outerEl.scrollTop + this.paddingTop + 'px';
      tileY = Math.round(this.outerEl.scrollTop / this.tileSize);
      tileX = Math.round(this.outerEl.scrollLeft / this.tileSize);
      results = [];
      for (y = j = ref = tileY - this.verticalLoadDelta, ref1 = tileY + this.verticalLoadDelta; ref <= ref1 ? j <= ref1 : j >= ref1; y = ref <= ref1 ? ++j : --j) {
        results.push((function() {
          var k, ref2, ref3, results1;
          results1 = [];
          for (x = k = ref2 = tileX - this.horizontalLoadDelta, ref3 = tileX + this.horizontalLoadDelta; ref2 <= ref3 ? k <= ref3 : k >= ref3; x = ref2 <= ref3 ? ++k : --k) {
            if (x >= 0 && y >= 0 && x < this.mapWidthInTiles && y < this.mapHeightInTiles) {
              tileIndex = y * this.mapWidthInTiles + x + 1;
              if (!this.tilesLoaded[tileIndex]) {
                results1.push(this.loadTile(x, y));
              } else {
                results1.push(void 0);
              }
            } else {
              results1.push(void 0);
            }
          }
          return results1;
        }).call(this));
      }
      return results;
    },
    drawPosts: function() {
      var map, postsEl, postsOverlaysEl;
      map = this._data.map;
      postsEl = this.el.querySelector('.js-posts');
      postsEl.innerHTML = '';
      postsOverlaysEl = this.el.querySelector('.js-posts-overlays');
      postsOverlaysEl.innerHTML = '';
      return map.posts.forEach((function(_this) {
        return function(post, index) {
          var postEl, postOverlayEl, ref, ref1;
          postEl = document.createElement('div');
          postEl.setAttribute('class', "c-tactical-map__post " + ((ref = post.side) != null ? ref : 'neutral'));
          postEl.style.height = _this.cellSize + 'px';
          postEl.style.width = _this.cellSize + 'px';
          postEl.style.top = _this.cellSize * post.y + 'px';
          postEl.style.left = _this.cellSize * post.x + 'px';
          postOverlayEl = document.createElement('div');
          postOverlayEl.style.height = _this.cellSize + 'px';
          postOverlayEl.style.width = _this.cellSize + 'px';
          postOverlayEl.style.top = _this.cellSize * post.y + 'px';
          postOverlayEl.style.left = _this.cellSize * post.x + 'px';
          postOverlayEl.setAttribute('class', "c-tactical-map__post-overlay js-post-overlay");
          postOverlayEl.setAttribute('data-id', index);
          postOverlayEl.setAttribute('data-side', (ref1 = post.side) != null ? ref1 : 'neutral');
          postsEl.appendChild(postEl);
          return postsOverlaysEl.appendChild(postOverlayEl);
        };
      })(this));
    },
    drawConnections: function() {
      var connectionsEl, map, postsByXY;
      map = this._data.map;
      postsByXY = {};
      map.posts.forEach(function(post) {
        if (!postsByXY[post.x]) {
          postsByXY[post.x] = {};
        }
        return postsByXY[post.x][post.y] = post;
      });
      connectionsEl = this.el.querySelector('.js-connections');
      connectionsEl.innerHTML = '';
      return map.connections.forEach((function(_this) {
        return function(connection) {
          var connectionEl, firstPost, firstSide, postA, postB, ref, ref1, secondPost, secondSide, type;
          connectionEl = document.createElement('div');
          postA = postsByXY[connection.x1][connection.y1];
          postB = postsByXY[connection.x2][connection.y2];
          if (postA.y < postB.y) {
            firstPost = postA;
            secondPost = postB;
          } else if (postA.y > postB.y) {
            firstPost = postB;
            secondPost = postA;
          } else if (postA.x < postB.x) {
            firstPost = postA;
            secondPost = postB;
          } else {
            firstPost = postB;
            secondPost = postA;
          }
          firstSide = (ref = firstPost.side) != null ? ref : 'neutral';
          secondSide = (ref1 = secondPost.side) != null ? ref1 : 'neutral';
          if (firstPost.y === secondPost.y) {
            type = 'horizontal';
          } else if (firstPost.x === secondPost.x) {
            type = 'vertical';
          } else if (firstPost.x < secondPost.x) {
            type = 'diagonal-down';
          } else {
            type = 'diagonal-up';
          }
          connectionEl.setAttribute('class', "c-tactical-map__connection c-tactical-map__connection--" + firstSide + "-" + secondSide + "--" + type + " c-tactical-map__connection--" + type);
          connectionEl.setAttribute('x1', connection.x1);
          connectionEl.setAttribute('y1', connection.y1);
          connectionEl.setAttribute('x2', connection.x2);
          connectionEl.setAttribute('y2', connection.y2);
          connectionEl.style.top = _this.cellSize * firstPost.y + 'px';
          connectionEl.style.left = _this.cellSize * firstPost.x + 'px';
          return connectionsEl.appendChild(connectionEl);
        };
      })(this));
    },
    loadTile: function(x, y) {
      var imgEl, tileIndex;
      tileIndex = y * this.mapWidthInTiles + x + 1;
      imgEl = document.createElement('img');
      imgEl.src = "./images/military-base/tactical-map/" + this.tilesFolder + "/tile-" + tileIndex + ".jpg";
      imgEl.setAttribute('class', 'c-tactical-map__tile');
      imgEl.style.top = y * this.tileSize + this.paddingTop + 'px';
      imgEl.style.left = x * this.tileSize + this.paddingLeft + 'px';
      this.tilesEl.appendChild(imgEl);
      return this.tilesLoaded[tileIndex] = true;
    },
    indexToLetters: function(index) {
      var first, letters, second;
      letters = ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'];
      first = '';
      if (index >= letters.length) {
        first = letters[Math.floor(index / letters.length) - 1];
      }
      second = letters[index % letters.length];
      return first + second;
    }
  });
});
