var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/news.tmpl', 'text!templates/news/blocks/newspapers-list.tmpl', 'views/components/lazy-loading', 'views/common/list-view'], function(app, ItemView, _, template, listTemplate, LazyLoading, CommonListView) {
  var MyNews;
  MyNews = (function(superClass) {
    extend(MyNews, superClass);

    function MyNews() {
      this._loadNews = bind(this._loadNews, this);
      this._appendPageToMainList = bind(this._appendPageToMainList, this);
      this.onDataLoaded = bind(this.onDataLoaded, this);
      this.loadData = bind(this.loadData, this);
      return MyNews.__super__.constructor.apply(this, arguments);
    }

    MyNews.prototype.template = template;

    MyNews.prototype.listTemplate = _.template(listTemplate);

    MyNews.prototype.data = {
      subscriptions: {
        pointer: 'news.userSubscriptions',
        page: 1
      }
    };

    MyNews.prototype.events = {
      'click .js-newspaper': 'goToNewspaper',
      'click .js-post': 'goToPost'
    };

    MyNews.prototype.goToNewspaper = function(event) {
      var newspaperSlug;
      this.lockUI();
      newspaperSlug = event.currentTarget.getAttribute('data-newspaper-slug');
      return app.screens.dialog('news/newspaper', {
        newspaperSlug: newspaperSlug
      }, (function(_this) {
        return function() {
          return _this.unlockUI();
        };
      })(this));
    };

    MyNews.prototype.goToPost = function(event) {
      var newspaperSlug, postId;
      this.lockUI();
      postId = event.currentTarget.getAttribute('data-post-id');
      newspaperSlug = event.currentTarget.getAttribute('data-newspaper-slug');
      return app.screens.dialog('news/article', {
        newspaperSlug: newspaperSlug,
        postId: postId
      }, (function(_this) {
        return function() {
          return _this.unlockUI();
        };
      })(this));
    };

    MyNews.prototype.loadData = function() {
      this.data.subscriptions.page = 1;
      return MyNews.__super__.loadData.call(this);
    };

    MyNews.prototype.onDataLoaded = function(data) {
      var container;
      MyNews.__super__.onDataLoaded.call(this, data);
      container = this.el.querySelector('#js-main-list-content');
      this._renderList(container, data.subscriptions, data.page, data.hasNext);
      this.tabletLayout();
      this.canvasInnerLayout();
      this.data.subscriptions.page++;
      return LazyLoading((function(_this) {
        return function() {
          return _this._appendPageToMainList(_this.data.subscriptions.page);
        };
      })(this));
    };

    MyNews.prototype._appendPageToMainList = function(page) {
      var container, self;
      if (this.hasNext === false) {
        return;
      }
      container = this.el.querySelector('#js-main-list-content');
      self = this;
      self.lockUI();
      self._showListLoader(container);
      return self._loadNews(page).then(function(data) {
        self.unlockUI();
        self._hideListLoader(container);
        return self._renderList(container, data, data.page, data.hasNext);
      });
    };

    MyNews.prototype._loadNews = function(page) {
      var deferred, self;
      deferred = $.Deferred();
      self = this;
      app.server.news.userSubscriptions({
        page: page || 1,
        success: (function(_this) {
          return function(data) {
            var resultData;
            resultData = data;
            resultData.page = page;
            resultData.hasNext = data.has_next || false;
            _this.hasNext = data.paging.NewspaperPost.nextPage || false;
            _this.data.subscriptions.page++;
            return deferred.resolve(resultData);
          };
        })(this),
        error: function() {
          return deferred.resolve({
            users: [],
            page: 1,
            hasNext: false
          });
        }
      });
      return deferred;
    };


    /*
    			Center cloud
     */

    MyNews.prototype.centerCloud = function() {
      var $cloud, $container;
      if ($('.c-cloud').length > 0) {
        $cloud = $('.c-cloud');
        $container = $('.js-current-screen');
        return $cloud.css('margin-top', ($container.height() / 2 - $cloud.height() / 2) / 2);
      }
    };

    MyNews.prototype.onDomRefresh = function() {
      return this.centerCloud();
    };

    return MyNews;

  })(CommonListView);
  return MyNews;
});
