var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/news/manage-newspaper.tmpl'], function(app, ItemView, _, template) {
  var ManageNewspaper;
  ManageNewspaper = (function(superClass) {
    extend(ManageNewspaper, superClass);

    function ManageNewspaper() {
      return ManageNewspaper.__super__.constructor.apply(this, arguments);
    }

    ManageNewspaper.prototype.template = template;

    ManageNewspaper.prototype.className = 'no-bg-image';

    ManageNewspaper.prototype.data = {
      newspaper: {
        pointer: 'news.userNewspaper',
        page: 1
      }
    };

    ManageNewspaper.prototype.events = {
      'click .js-edit-newspaper': 'editNewspaper',
      'click .js-delete-newspaper': 'deleteNewspaper'
    };

    ManageNewspaper.prototype.editNewspaper = function(event) {
      var name;
      this.lockUI();
      name = this.$el.find('.js-title').val();
      return app.server.news.editNewspaper({
        name: name,
        success: function(data) {
          if (!data.error) {
            app.screens.back();
            return app.screens.modal('common/success-popup', {
              msg: data.setFlash[0].msg || app.tr("Newspaper was changed")
            });
          }
        },
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Something went wrong")
          });
        }
      });
    };

    ManageNewspaper.prototype.deleteNewspaper = function(event) {
      this.lockUI();
      return app.screens.modal('common/confirmation-popup', {
        msg: app.tr('Do you want to delete the newspaper?'),
        callback: (function(_this) {
          return function() {
            return app.server.news.deleteNewspaper({
              success: function(data) {
                app.screens.back();
                return app.screens.modal('common/success-popup', {
                  msg: data.setFlash[0].msg || app.tr("Newspaper has been deleted")
                });
              },
              error: function(data) {
                return app.screens.modal('common/info-popup', {
                  msg: data.setFlash[0].msg || app.tr("Something went wrong")
                });
              }
            });
          };
        })(this)
      });
    };

    return ManageNewspaper;

  })(ItemView);
  return ManageNewspaper;
});
