var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/news/newspaper.tmpl'], function(app, ItemView, _, template) {
  var NewspaperView;
  NewspaperView = (function(superClass) {
    extend(NewspaperView, superClass);

    function NewspaperView() {
      return NewspaperView.__super__.constructor.apply(this, arguments);
    }

    NewspaperView.prototype.template = template;

    NewspaperView.prototype.data = {
      newspaper: {
        pointer: 'news.newspaper',
        newspaperSlug: function() {
          return this.options.newspaperSlug;
        }
      }
    };

    NewspaperView.prototype.events = {
      'click .js-post': 'goToPost',
      'click .js-subscribe': 'subscribe',
      'click .js-unsubscribe': 'unsubscribe'
    };

    NewspaperView.prototype.goToPost = function(event) {
      var postId;
      this.lockUI();
      postId = event.currentTarget.getAttribute('data-post-id');
      return app.screens.dialog('news/article', {
        postId: postId
      });
    };

    NewspaperView.prototype.subscribe = function(event) {
      var newspaperId;
      this.lockUI();
      newspaperId = event.currentTarget.getAttribute('data-newspaper-id');
      return app.server.news.subscribe({
        newspaperId: newspaperId,
        success: (function(_this) {
          return function(data) {
            return _this.reload();
          };
        })(this),
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Something went wrong")
          });
        }
      });
    };

    NewspaperView.prototype.unsubscribe = function(event) {
      var subscriptionId;
      this.lockUI();
      subscriptionId = event.currentTarget.getAttribute('data-subscription-id');
      return app.server.news.unsubscribe({
        subscriptionId: subscriptionId,
        success: (function(_this) {
          return function(data) {
            return _this.reload();
          };
        })(this),
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Something went wrong")
          });
        }
      });
    };

    return NewspaperView;

  })(ItemView);
  return NewspaperView;
});
