define(['app', 'views/item-view', 'underscore', 'text!templates/parlament-election.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    data: {
      candidates: 'parliament.election.candidates'
    },
    events: {
      'click .js-vote': 'vote',
      'click .js-party-name': 'openParty'
    },
    openParty: function(event) {
      var partyId;
      partyId = event.currentTarget.getAttribute('data-party-id');
      return app.screens.dialog('parties/common', {
        partyId: partyId
      });
    },
    vote: function(event) {
      var partyId;
      this.lockUI();
      partyId = event.currentTarget.getAttribute('data-party-id');
      return app.server.parliament.election.vote({
        partyId: partyId,
        success: (function(_this) {
          return function(data) {
            return app.screens.modal('common/success-popup', {
              msg: data.setFlash[0].msg
            });
          };
        })(this)
      });
    }
  });
});
