define(['app', 'views/item-view', 'underscore', 'text!templates/parties/budget.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  return ItemView.extend({
    template: template,
    data: {
      treasure: 'party.treasure',
      request_count: 'party.requests.count'
    },
    events: {
      'click .js-donate': 'donate'
    },
    donate: function(event) {
      var partyId;
      this.lockUI();
      partyId = event.currentTarget.getAttribute('data-party-id');
      return app.screens.dialog('parties/donate', {
        partyId: partyId,
        currency: 'vd'
      });
    },
    onDomRefresh: function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    }
  });
});
