define(['app', 'views/item-view', 'underscore', 'text!templates/parties/change-permissions.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    require: ['memberId'],
    data: {
      rights: {
        pointer: 'party.rights.get',
        memberId: function() {
          return this.options.memberId;
        }
      }
    },
    events: {
      'click .js-push-state': 'changePermission'
    },
    changePermission: function(event) {
      var action, permission, state;
      this.lockUI();
      $(event.currentTarget).toggleClass('o-switcher-small--active');
      permission = event.currentTarget.getAttribute('data-permission-type');
      state = event.currentTarget.getAttribute('data-state');
      action = state === 'yes' ? 'remove' : 'add';
      return app.server.party.rights.change({
        memberId: this.options.memberId,
        permission: permission,
        action: action,
        success: (function(_this) {
          return function(data) {
            return app.screens.modal('common/success-popup', {
              msg: data.setFlash[0].msg
            });
          };
        })(this)
      });
    }
  });
});
