var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/maria/donate.tmpl', 'jquery'], function(app, ItemView, _, template, $) {
  var PartyDonateView;
  PartyDonateView = (function(superClass) {
    extend(PartyDonateView, superClass);

    function PartyDonateView() {
      return PartyDonateView.__super__.constructor.apply(this, arguments);
    }

    PartyDonateView.prototype.template = template;

    PartyDonateView.prototype.events = {
      'click .js-apply': 'addFunds',
      'change .js-amount': 'changeAmount',
      'click .o-switcher': 'changeCurrency'
    };

    PartyDonateView.prototype.changeCurrency = function(event) {
      $(event.currentTarget).toggleClass('o-switcher--active');
      this.$el.find('.js-currency').toggleClass('o-icon--vdollar o-icon--vgold');
      return this.$el.find('.js-apply').toggleClass('c-btn--green c-btn--yellow');
    };

    PartyDonateView.prototype.changeAmount = function(event) {
      var amount;
      amount = parseFloat(this.$el.find('.js-amount').val());
      if (isNaN(amount) || amount < 0) {
        $(event.currentTarget).val("0.00");
        return this.$el.find('.saved-amount').html("0.00");
      } else {
        $(event.currentTarget).val(amount.toFixed(2));
        return this.$el.find('.saved-amount').html(amount.toFixed(2));
      }
    };

    PartyDonateView.prototype.addFunds = function(event) {
      var amount, currency, partyId;
      this.lockUI();
      partyId = this.options.partyId;
      amount = parseFloat(this.$el.find('.js-amount').val());
      currency = this.$el.find('.o-switcher').hasClass('o-switcher--active') ? 'vg' : 'vd';
      if (amount === "") {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("Specify the sum")
        });
      } else if (isNaN(amount)) {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("The amount may consist only of digits")
        });
      } else if (amount < 0) {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("Amount must be greater than 0")
        });
      } else {
        app.server.party.treasure.donate({
          partyId: partyId,
          amount: amount.toFixed(2),
          currency: currency,
          success: (function(_this) {
            return function(data) {
              return app.screens.modal('common/success-popup', {
                msg: data.setFlash[0].msg || app.tr("Account refilled")
              });
            };
          })(this)
        });
        return app.screens.back();
      }
    };

    return PartyDonateView;

  })(ItemView);
  return PartyDonateView;
});
