define(['app', 'views/item-view', 'underscore', 'text!templates/parties/requests.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    data: {
      requests: 'party.requests',
      request_count: 'party.requests.count'
    },
    events: {
      'click .js-accept': 'acceptRequest',
      'click .js-decline': 'declineRequest'
    },
    acceptRequest: function(event) {
      var requestId;
      this.lockUI();
      requestId = event.currentTarget.getAttribute('data-request-id');
      return app.server.party.request.accept({
        requestId: requestId,
        success: (function(_this) {
          return function(data) {
            return app.screens.modal('common/success-popup', {
              msg: data.setFlash[0].msg
            });
          };
        })(this)
      });
    },
    declineRequest: function(event) {
      var requestId;
      this.lockUI();
      requestId = event.currentTarget.getAttribute('data-request-id');
      return app.server.party.request.decline({
        requestId: requestId,
        success: (function(_this) {
          return function(data) {
            return app.screens.modal('common/success-popup', {
              msg: data.setFlash[0].msg
            });
          };
        })(this)
      });
    }
  });
});
