var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/quests.tmpl', 'views/components/clusterize-helper'], function(app, ItemView, _, template, ClusterizeHelper) {
  var QuestsView;
  QuestsView = (function(superClass) {
    extend(QuestsView, superClass);

    function QuestsView() {
      this.preprocessData = bind(this.preprocessData, this);
      return QuestsView.__super__.constructor.apply(this, arguments);
    }

    QuestsView.prototype.template = template;

    QuestsView.prototype.className = 'quests-layout';

    QuestsView.prototype.required = ['isNew'];

    QuestsView.prototype.data = {
      quests: 'quests'
    };

    QuestsView.prototype.events = {
      'click .js-quest-info': 'questInfo'
    };

    QuestsView.prototype.periods = [null, app.tr('daily'), app.tr('weekly'), app.tr('monthly')];

    QuestsView.prototype.callPopup = function() {
      return app.screens.modal('quests/quests-popup', {
        overlay: false,
        msg: app.tr('VirCities honored worker'),
        info: app.tr('Spend 500 energy for work'),
        energyInfo: '25 / 500'
      });
    };

    QuestsView.prototype.questInfo = function(event) {
      var questId;
      questId = event.currentTarget.getAttribute('data-quest-id');
      return app.screens.dialog('quests/quest', {
        questId: questId
      });
    };

    QuestsView.prototype.onRender = function(event) {
      QuestsView.__super__.onRender.call(this);
      if (this.options.openMenu != null) {
        return app.menu.open();
      }
    };

    QuestsView.prototype.onDomRefresh = function() {
      this.$el.closest('body').removeClass('hide-short-info no-swipe');
      return ClusterizeHelper(this.$el);
    };

    QuestsView.prototype.preprocessData = function(data) {
      var availableQuest, completedQuest, i, j, k, len, len1, len2, ref, ref1, ref2, takenQuest;
      if ((data != null ? data.quests : void 0) != null) {
        data.quests_new_count = data.quests.newQuests != null ? Object.keys(data.quests.newQuests).length : 0;
        data.quests_active_count = data.quests.npcQuestsInProgress != null ? Object.keys(data.quests.npcQuestsInProgress).length : 0;
        data.quests_completed_count = data.quests.completedQuests != null ? Object.keys(data.quests.completedQuests).length : 0;
        ref = data.quests.newQuests;
        for (i = 0, len = ref.length; i < len; i++) {
          availableQuest = ref[i];
          app.vent.trigger('quests:quest_available', availableQuest.Quest, true);
        }
        ref1 = data.quests.completedQuests;
        for (j = 0, len1 = ref1.length; j < len1; j++) {
          completedQuest = ref1[j];
          app.vent.trigger('quests:quest_finished', completedQuest.Quest, true);
        }
        ref2 = data.quests.npcQuestsInProgress;
        for (k = 0, len2 = ref2.length; k < len2; k++) {
          takenQuest = ref2[k];
          app.vent.trigger('quests:quest_finished', takenQuest.Quest, true);
        }
      }
      data.periodNames = this.periods;
      return data;
    };

    QuestsView.prototype.initialize = function() {
      if (app.launch) {
        app.launch = false;
        app.server['user.payments_count']({
          success: function(data) {
            var payments_change, payments_count, prev_payments_count;
            payments_count = data.payments_count;
            prev_payments_count = window.localStorage.getItem('payments_count') || 0;
            payments_change = payments_count - prev_payments_count;
            if (payments_change > 0) {
              app.ga('set', 'metric2', payments_change);
              return window.localStorage.setItem('payments_count', payments_change);
            }
          },
          error: function() {
            return console.log('ERROR LOAD payments_count');
          }
        });
      }
      this.listenTo(app.vent, 'quests:quest_available', (function(_this) {
        return function(quest, fromQuestsLoad) {
          if (fromQuestsLoad) {
            return;
          }
          return _this.reload();
        };
      })(this));
      return QuestsView.__super__.initialize.apply(this, arguments);
    };

    return QuestsView;

  })(ItemView);
  return QuestsView;
});
