var bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/ratings/players.tmpl'], function(app, ItemView, _, template, EnergySlider) {
  var RatingView;
  RatingView = (function(superClass) {
    extend(RatingView, superClass);

    function RatingView() {
      this.initialize = bind(this.initialize, this);
      return RatingView.__super__.constructor.apply(this, arguments);
    }

    RatingView.prototype.template = template;

    RatingView.prototype.data = {
      ratings: {
        pointer: 'ratings.companies',
        timeFilter: function() {
          return JSON.parse(this.options.screen_options).timeFilter;
        },
        cityFilter: function() {
          return JSON.parse(this.options.screen_options).cityFilter;
        },
        productionType: function() {
          return JSON.parse(this.options.screen_options).productionFilter;
        }
      }
    };

    RatingView.prototype.events = {
      'click .js-open-full-rating': 'openFullRating',
      'click .js-close-full-rating': 'closeFullRating',
      'click .js-overview': 'companyOverview'
    };

    RatingView.prototype.initialize = function(options) {
      this.options = options;
      this.options.activeTab = 1;
      if ((this.options.screen_options != null) === false) {
        this.options.screen_options_obj = {
          timeFilter: 0,
          cityFilter: -1,
          activeTab: 1,
          productionFilter: 0
        };
        this.options.screen_options = JSON.stringify(this.options.screen_options_obj);
      } else {
        this.options.screen_options_obj = JSON.parse(this.options.screen_options);
        this.options.screen_options_obj.activeTab = 1;
        this.options.screen_options = JSON.stringify(this.options.screen_options_obj);
      }
      return RatingView.__super__.initialize.call(this, this.options);
    };

    RatingView.prototype.openFullRating = function(event) {
      var card, fullRating, target;
      target = $(event.target);
      card = target.closest(".c-card-wrapper__col");
      fullRating = card.find(".full-rating");
      fullRating.css("display", "block");
      target.removeClass('js-open-full-rating');
      target.addClass('js-close-full-rating');
      return target.text(app.tr('Close'));
    };

    RatingView.prototype.closeFullRating = function(event) {
      var card, fullRating, target;
      target = $(event.target);
      card = target.closest(".c-card-wrapper__col");
      fullRating = card.find(".full-rating");
      fullRating.css("display", "none");
      target.removeClass('js-close-full-rating');
      target.addClass('js-open-full-rating');
      return target.text(app.tr('Open'));
    };

    RatingView.prototype.companyOverview = function(event) {
      var companyId;
      this.lockUI();
      companyId = event.currentTarget.getAttribute('data-id');
      return app.screens.dialog('business/company-overview', {
        companyId: companyId
      });
    };

    return RatingView;

  })(ItemView);
  return RatingView;
});
