var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/stadium/licenses.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  var licensesView;
  licensesView = (function(superClass) {
    extend(licensesView, superClass);

    function licensesView() {
      return licensesView.__super__.constructor.apply(this, arguments);
    }

    licensesView.prototype.template = template;

    licensesView.prototype.data = {
      licenses: 'work.licenses'
    };

    licensesView.prototype.events = {
      'click .js-buy-license': 'buyLicense'
    };

    licensesView.prototype.onDomRefresh = function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    };

    licensesView.prototype.buyLicense = function(event) {
      var currency, img, licenseId, name, price;
      this.lockUI();
      licenseId = event.currentTarget.getAttribute('data-license-id');
      name = event.currentTarget.getAttribute('data-name');
      price = event.currentTarget.getAttribute('data-price');
      currency = event.currentTarget.getAttribute('data-currency');
      img = event.currentTarget.getAttribute('data-img');
      return app.screens.modal('common/buy-popup', {
        name: name,
        maxCount: 1,
        price: price,
        currency: currency,
        img: img,
        callback: (function(_this) {
          return function(count) {
            return app.server.work.licenses.buyTrainerLicense({
              licenseId: licenseId,
              confirm: false,
              success: function(data) {
                var ref;
                app.screens.back();
                if ((data.better_licence != null) && data.better_licence === true) {
                  return app.screens.modal('common/confirmation-popup', {
                    msg: app.tr('YOU HAVE A BETTER LICENSE'),
                    callback: (function(_this) {
                      return function(count) {
                        return app.server.work.licenses.buyTrainerLicense({
                          licenseId: licenseId,
                          confirm: true,
                          success: function(data) {
                            var ref;
                            if (app.gaEnabled) {
                              app.ga('send', 'event', 'stadium', 'training licence', name, Number(price));
                            }
                            return app.screens.modal('common/info-popup', {
                              msg: ((ref = data.setFlash) != null ? ref[0].msg : void 0) || app.tr("Insufficient level to purchase a license")
                            });
                          }
                        });
                      };
                    })(this)
                  });
                } else {
                  return app.screens.modal('common/info-popup', {
                    msg: ((ref = data.setFlash) != null ? ref[0].msg : void 0) || app.tr("Insufficient level to purchase a license")
                  });
                }
              },
              error: function(data) {
                app.screens.back();
                return app.screens.modal('common/info-popup', {
                  msg: data.setFlash[0].msg || app.tr("Something went wrong")
                });
              }
            });
          };
        })(this)
      });
    };

    return licensesView;

  })(ItemView);
  return licensesView;
});
