var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/stadium/trainers-coefficients.tmpl'], function(app, ItemView, _, template) {
  var TrainersCoefficientsView;
  TrainersCoefficientsView = (function(superClass) {
    extend(TrainersCoefficientsView, superClass);

    function TrainersCoefficientsView() {
      return TrainersCoefficientsView.__super__.constructor.apply(this, arguments);
    }

    TrainersCoefficientsView.prototype.template = template;

    TrainersCoefficientsView.prototype.data = {
      coefficients: 'stadium.coefficientsAndMinPrice'
    };

    TrainersCoefficientsView.prototype.events = {
      'click .js-choose-program': 'chooseProgram',
      'click .js-next-page': 'nextPage',
      'click .js-prev-page': 'prevPage',
      'click .js-select-coef': 'selectCoef',
      'change .js-name': 'onNameChange'
    };

    TrainersCoefficientsView.prototype.onNameChange = function(event) {
      var name;
      name = event.currentTarget.value;
      name = name.trim();
      event.currentTarget.value = name;
      if (name.length > 2 || !name) {
        return this.app.screens.dialog('stadium/choose-trainer', {
          name: name
        });
      }
    };

    TrainersCoefficientsView.prototype.selectCoef = function(event) {
      var coefficient;
      coefficient = event.currentTarget.getAttribute('coefficient');
      return this.app.screens.dialog('stadium/choose-trainer', {
        coefficient: coefficient
      });
    };

    TrainersCoefficientsView.prototype.chooseProgram = function() {
      var coefficient, currency, licenseId, price, programId;
      programId = this._data.coefficients.user_coefficient.CoachProgram.id;
      licenseId = this._data.coefficients.user_coefficient.CoachProgram.licence_id;
      price = this._data.coefficients.user_coefficient.CoachProgram.price;
      currency = this._data.coefficients.user_coefficient.CoachProgram.currency;
      coefficient = this._data.coefficients.user_coefficient.CoachProgram.coefficient;
      return app.vent.trigger('stadium:trainer_chosen', {
        programId: programId,
        licenseId: licenseId,
        price: price,
        currency: currency,
        coefficient: coefficient
      });
    };

    return TrainersCoefficientsView;

  })(ItemView);
  return TrainersCoefficientsView;
});
