define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    data: {
      items: 'tradeCenter.itemGroups',
      business: 'tradeCenter.businessGroups'
    },
    events: {
      'click .js-items-category': 'gotoCategory'
    },
    gotoCategory: function(event) {
      var category;
      this.lockUI();
      category = event.currentTarget.getAttribute('data-category-id');
      app.vent.trigger('trade-center:category_selected', {
        type: category
      });
      return app.screens.dialog('trade-center/items-buy-grouped', {
        category: category
      });
    }
  });
});
