define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/currencies-by-type.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  return ItemView.extend({
    template: template,
    data: {
      'lots': {
        pointer: 'tradeCenter.currencyLotsByType',
        type: function() {
          return this.options.currencyType;
        }
      }
    },
    events: {
      'click .js-buy-lot': 'buyLot'
    },
    buyLot: function(event) {
      var data, lotId, lotInfo, offersCollection;
      this.lockUI();
      data = this.serializeData();
      lotId = event.currentTarget.getAttribute('data-lot-id');
      offersCollection = new Backbone.Collection(data.lots.offers);
      lotInfo = offersCollection.get(lotId);
      return app.screens.modal('trade-center/purchase-currency', {
        model: lotInfo
      });
    },
    onDomRefresh: function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        if (el.dataset.precision) {
          return el.innerHTML = formatCurrency(el.innerHTML, void 0, el.dataset.precision);
        } else {
          return el.innerHTML = formatCurrency(el.innerHTML);
        }
      });
    }
  });
});
