var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/currencies-sell-grouped.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  var CurrenciesSellGroupedView;
  CurrenciesSellGroupedView = (function(superClass) {
    extend(CurrenciesSellGroupedView, superClass);

    function CurrenciesSellGroupedView() {
      return CurrenciesSellGroupedView.__super__.constructor.apply(this, arguments);
    }

    CurrenciesSellGroupedView.prototype.template = template;

    CurrenciesSellGroupedView.prototype.data = {
      'currency': {
        pointer: 'tradeCenter.availableCurrency'
      }
    };

    CurrenciesSellGroupedView.prototype.events = {
      'click .js-items-lot': 'sell',
      'change .js-items-amount': 'amountChangeHandler',
      'change .js-items-price': 'priceChangeHandler'
    };

    CurrenciesSellGroupedView.prototype.sell = function(event) {
      var amount, currency;
      this.lockUI();
      amount = parseFloat(event.currentTarget.getAttribute('data-amount'));
      currency = event.currentTarget.getAttribute('data-currency');
      return app.screens.dialog('trade-center/sell-currency', {
        currency: currency,
        available: amount
      });
    };

    CurrenciesSellGroupedView.prototype.onDomRefresh = function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        if (el.dataset.precision) {
          return el.innerHTML = formatCurrency(el.innerHTML, void 0, el.dataset.precision);
        } else {
          return el.innerHTML = formatCurrency(el.innerHTML);
        }
      });
    };

    return CurrenciesSellGroupedView;

  })(ItemView);
  return CurrenciesSellGroupedView;
});
