var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/items-buy-grouped.tmpl', 'views/components/currency', 'views/components/strings-helper'], function(app, ItemView, _, template, formatCurrency, Strings) {
  var ItemsBuyView;
  ItemsBuyView = (function(superClass) {
    var _name;

    extend(ItemsBuyView, superClass);

    function ItemsBuyView() {
      return ItemsBuyView.__super__.constructor.apply(this, arguments);
    }

    ItemsBuyView.prototype.template = template;

    _name = null;

    ItemsBuyView.prototype.minPriceForLots = 0;

    ItemsBuyView.prototype.data = {
      'items': {
        pointer: 'tradeCenter.lotsList',
        category: function() {
          return this.options.category;
        },
        itemName: function() {
          if (this.options.itemName != null) {
            return this.options.itemName;
          } else {
            return null;
          }
        }
      }
    };

    ItemsBuyView.prototype.events = {
      'click .js-items-lot': 'showLots',
      'change .c-input': 'itemSearch'
    };

    ItemsBuyView.prototype.initialize = function() {
      ItemsBuyView.__super__.initialize.apply(this, arguments);
      return this.on('render', function() {
        return this._renderList();
      });
    };

    ItemsBuyView.prototype.preprocessData = function(data) {
      var hasVdollars, id, item, minPrice, minPriceLot, ref, ref1, ref2;
      minPriceLot = 0;
      minPrice = Number.MAX_VALUE;
      data.items.filteredData = {};
      hasVdollars = false;
      ref = data.items.exchanges;
      for (id in ref) {
        item = ref[id];
        if (this._name && this._name.length > 2) {
          if (!Strings.matchName(item.name, this._name, 1)) {
            continue;
          }
        }
        data.items.filteredData[id] = item;
      }
      ref1 = data.items.filteredData;
      for (id in ref1) {
        item = ref1[id];
        if (item.lots.vdollars != null) {
          hasVdollars = true;
          break;
        }
      }
      ref2 = data.items.filteredData;
      for (id in ref2) {
        item = ref2[id];
        if (item.lots.vdollars) {
          if (item.lots.vdollars.min_price < minPrice) {
            minPrice = item.lots.vdollars.min_price;
            minPriceLot = id;
          }
        }
        if (item.lots.vgold && !hasVdollars) {
          if (item.lots.vgold.min_price < minPrice) {
            minPrice = item.lots.vgold.min_price;
            minPriceLot = id;
          }
        }
      }
      this.minPriceForLots = minPrice;
      if (minPriceLot) {
        data.items.filteredData[minPriceLot].lowestPrice = 1;
      }
      return data;
    };

    ItemsBuyView.prototype.showLots = function(event) {
      var corporationId, currency, itemTypeId;
      this.lockUI();
      currency = event.currentTarget.getAttribute('data-currency');
      itemTypeId = event.currentTarget.getAttribute('data-item-id');
      corporationId = this.options.corporationId;
      return app.screens.dialog('trade-center/lots', {
        currency: currency,
        itemTypeId: itemTypeId,
        corporationId: corporationId,
        minPrice: this.minPriceForLots
      });
    };

    ItemsBuyView.prototype.onDomRefresh = function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        if (el.dataset.precision) {
          return el.innerHTML = formatCurrency(el.innerHTML, void 0, el.dataset.precision);
        } else {
          return el.innerHTML = formatCurrency(el.innerHTML);
        }
      });
    };

    ItemsBuyView.prototype.itemSearch = function(event) {
      var name;
      name = event.currentTarget.value;
      event.currentTarget.value = name;
      this._name = name;
      this.options._name = name;
      return this._renderList();
    };

    ItemsBuyView.prototype._renderList = function() {
      var data, listContainer;
      listContainer = this.el;
      if (!listContainer) {
        return;
      }
      data = this.mixinTemplateHelpers(this.serializeData({}));
      return listContainer.innerHTML = Marionette.Renderer.render(this.template, data);
    };

    ItemsBuyView.prototype.sendGAView = function() {
      if (this.app.config.googleAnalyticsEnabled && this.app.ga) {
        return this.app.ga('send', 'pageview', {
          page: '/scr/' + this.options.id + '/' + this.options.category,
          title: ''
        });
      }
    };

    return ItemsBuyView;

  })(ItemView);
  return ItemsBuyView;
});
