define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/items-sell-grouped.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  return ItemView.extend({
    template: template,
    data: {
      items: {
        pointer: 'tradeCenter.availableItems',
        category: function() {
          return this.options.category;
        }
      }
    },
    events: {
      'click .js-items-lot': 'sell'
    },
    sell: function(event) {
      var itemAmount, itemName, itemTypeId, options;
      this.lockUI();
      itemTypeId = event.currentTarget.getAttribute('data-item-type-id');
      itemName = event.currentTarget.getAttribute('data-item-name');
      itemAmount = event.currentTarget.getAttribute('data-item-amount');
      options = {
        itemTypeId: itemTypeId,
        itemName: itemName,
        itemAmount: itemAmount,
        lotCommission: this._data.items.commission,
        itemCategoryId: this.options.category
      };
      if (this._data.items.items[itemTypeId].lots) {
        options.lots = this._data.items.items[itemTypeId].lots;
      }
      return app.screens.dialog('trade-center/sell-item', options);
    },
    onDomRefresh: function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        if (el.dataset.precision) {
          return el.innerHTML = formatCurrency(el.innerHTML, void 0, el.dataset.precision);
        } else {
          return el.innerHTML = formatCurrency(el.innerHTML);
        }
      });
    }
  });
});
