define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/lots-cityHall.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  return ItemView.extend({
    template: template,
    data: {
      'items': 'tradeCenter.lotsListCityHall'
    },
    events: {
      'click .js-lot-sell': 'buyLot'
    },
    buyLot: function(event) {
      var data, lotId, lotInfo, offersCollection;
      this.lockUI();
      data = this.serializeData();
      lotId = event.currentTarget.getAttribute('data-lot-id');
      offersCollection = new Backbone.Collection(data.items.exchanges);
      lotInfo = offersCollection.get(lotId);
      lotInfo.set('seller', data.items.seller);
      if (lotInfo.get('user_count') < 1) {
        return app.screens.modal('common/info-popup', {
          msg: app.tr("You do not have") + ("" + (lotInfo.get('name'))) + app.tr(" for sale")
        });
      } else {
        return app.screens.modal('trade-center/sell-item-maria', {
          model: lotInfo
        });
      }
    },
    onDomRefresh: function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        if (el.dataset.precision) {
          return el.innerHTML = formatCurrency(el.innerHTML, void 0, el.dataset.precision);
        } else {
          return el.innerHTML = formatCurrency(el.innerHTML);
        }
      });
    }
  });
});
