var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/purchase-currency.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  var PurchaseCurrencyPopup;
  PurchaseCurrencyPopup = (function(superClass) {
    extend(PurchaseCurrencyPopup, superClass);

    function PurchaseCurrencyPopup() {
      return PurchaseCurrencyPopup.__super__.constructor.apply(this, arguments);
    }

    PurchaseCurrencyPopup.prototype.template = template;

    PurchaseCurrencyPopup.prototype.events = {
      'click .js-confirm': 'purchaseItem',
      'change .js-items-number': 'handleAmountChange'
    };

    PurchaseCurrencyPopup.prototype.currencyBuyingTypes = {
      VG: 1,
      VD: 2
    };

    PurchaseCurrencyPopup.prototype.onDomRefresh = function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    };

    PurchaseCurrencyPopup.prototype.handleAmountChange = function(event) {
      return this.changeHandler($(event.currentTarget));
    };

    PurchaseCurrencyPopup.prototype.changeHandler = function(amountField) {
      var itemsAmount, modelPrice, price, spendMoney;
      itemsAmount = parseFloat(amountField.val());
      if (itemsAmount <= 0) {
        itemsAmount = 0.01;
      }
      amountField.val(itemsAmount);
      modelPrice = parseFloat(this.model.get('price'));
      price = this.model.get('currency_type') === this.currencyBuyingTypes.VG ? modelPrice : 1 / modelPrice;
      if (itemsAmount > this.model.get('number')) {
        itemsAmount = parseFloat(this.model.get('number'));
        amountField.val(itemsAmount.toFixed(2));
      }
      spendMoney = (itemsAmount * price).toFixed(2) >= 0.01 ? (itemsAmount * price).toFixed(2) : 0.01;
      this.$('.js-payment-amount').html(spendMoney);
      return amountField.val((spendMoney / price).toFixed(2));
    };

    PurchaseCurrencyPopup.prototype.onRender = function() {
      return this.changeHandler(this.$('.js-items-number'));
    };

    PurchaseCurrencyPopup.prototype.purchaseItem = function() {
      var number;
      this.lockUI();
      number = this.$('.js-items-number').val();
      return app.server.tradeCenter.buyCurrencyLot({
        exchangeId: this.model.get('id'),
        number: number,
        success: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Items purchased")
          });
        },
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Something went wrong")
          });
        }
      });
    };

    PurchaseCurrencyPopup.prototype.serializeData = function() {
      var serializedData;
      serializedData = PurchaseCurrencyPopup.__super__.serializeData.call(this);
      serializedData.model.price = this.model.get('currency_type') === this.currencyBuyingTypes.VG ? this.model.get('price') : 1 / this.model.get('price');
      return serializedData;
    };

    return PurchaseCurrencyPopup;

  })(ItemView);
  return PurchaseCurrencyPopup;
});
