define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/purchase-item.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    events: {
      'click .js-confirm': 'purchaseItem'
    },
    onRender: function() {
      return this.$('.js-items-number').change((function(_this) {
        return function(event) {
          var itemsAmount;
          itemsAmount = parseInt($(event.currentTarget).val());
          if (itemsAmount <= 0) {
            itemsAmount = 1;
          }
          $(event.currentTarget).val(itemsAmount);
          if (itemsAmount > _this.model.get('number')) {
            $(event.currentTarget).val(_this.model.get('number'));
            itemsAmount = _this.model.get('number');
          }
          return _this.$('.js-payment-amount').html((itemsAmount * _this.model.get('price')).toFixed(2));
        };
      })(this));
    },
    purchaseItem: function() {
      var number, self;
      this.jsBack();
      this.lockUI();
      self = this;
      number = this.$('.js-items-number').val();
      return app.server.tradeCenter.buyLotCompany({
        exchangeId: this.model.get('id'),
        number: number,
        companyId: this.options.companyId,
        success: function(data) {
          app.vent.trigger('trade-center:company_item_purchased', {
            data: self.model.get('item_info')
          });
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Items purchased")
          });
        },
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Something went wrong")
          });
        }
      });
    }
  });
});
