define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/purchase-item-maria.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    events: {
      'click .o-switcher': 'changeCurrency',
      'click .js-create-lot': 'purchaseItem'
    },
    purchaseItem: function() {
      var amount, currency, itemTypeId, price;
      this.lockUI();
      itemTypeId = this._data.model.id;
      amount = this.$('.js-items-amount').val();
      price = this.$('.js-items-price').val();
      currency = this.$el.find('.o-switcher').hasClass('o-switcher--active') ? 'vgold' : 'vdollars';
      return app.server.cityHall.buyout({
        itemTypeId: itemTypeId,
        amount: amount,
        price: price,
        currency: currency,
        success: (function(_this) {
          return function(data) {
            _this.unlockUI();
            return app.screens.modal('common/double-back-popup', {
              msg: data.setFlash[0].msg || app.tr("Purchase is set on voting")
            }, app.screens.back());
          };
        })(this),
        error: (function(_this) {
          return function(data) {
            _this.unlockUI();
            return app.screens.modal('common/info-popup', {
              msg: data.setFlash[0].msg || app.tr("Something went wrong")
            });
          };
        })(this)
      });
    },
    changeCurrency: function(event) {
      return $(event.currentTarget).toggleClass('o-switcher--active');
    },
    onRender: function() {
      this.$('.js-items-price').change((function(_this) {
        return function(event) {
          var price;
          price = parseFloat($(event.currentTarget).val());
          if (!isNaN(price)) {
            return $(event.currentTarget).val(price.toFixed(2));
          } else {
            return $(event.currentTarget).val("0.00");
          }
        };
      })(this));
      return this.$('.js-items-amount').change((function(_this) {
        return function(event) {
          var itemsAmount;
          itemsAmount = parseInt($(event.currentTarget).val());
          if (itemsAmount <= 0) {
            itemsAmount = 1;
          }
          return $(event.currentTarget).val(itemsAmount);
        };
      })(this));
    }
  });
});
