define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/shares-corporation.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    data: {
      lots: {
        pointer: 'tradeCenter.lotsOfferShares',
        currency: function() {
          return this.options.currency;
        },
        corporationId: function() {
          return this.options.corporationId;
        }
      }
    },
    events: {
      'click .js-buy-lot': 'buyLot'
    },
    buyLot: function(event) {
      var data, lotId, lotInfo, offersCollection;
      this.lockUI();
      data = this.serializeData();
      lotId = event.currentTarget.getAttribute('data-lot-id');
      offersCollection = new Backbone.Collection(data.lots.offers);
      lotInfo = offersCollection.get(lotId);
      lotInfo.set('item_info', data.lots.corporation_info);
      lotInfo.set('buyer', data.lots.buyer);
      return app.screens.modal('trade-center/purchase-share', {
        model: lotInfo
      });
    },
    onDomRefresh: function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        return el.innerHTML = formatCurrency(el.innerHTML);
      });
    }
  });
});
