define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/lot-settings.tmpl'], function(app, ItemView, _, template) {
  return ItemView.extend({
    template: template,
    events: {
      'click .o-switcher': 'changeCurrency',
      'click .js-change-lot': 'changeLot'
    },
    changeCurrency: function(event) {
      return $(event.currentTarget).toggleClass('o-switcher--active');
    },
    changeLot: function(event) {
      var currency, exchangeId, price;
      this.lockUI();
      exchangeId = this._data.model['id'];
      price = this.$('.js-items-price').val();
      currency = this.$el.find('.o-switcher').hasClass('o-switcher--active') ? 'vgold' : 'vdollars';
      return app.server.tradeCenter.editStockLot({
        exchangeId: exchangeId,
        price: price,
        currency: currency,
        success: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Lot edited")
          }, app.screens.back());
        },
        error: function(data) {
          return app.screens.modal('common/info-popup', {
            msg: data.setFlash[0].msg || app.tr("Something went wrong")
          }, app.screens.back());
        }
      });
    },
    onRender: function() {
      return this.$('.js-items-price').change((function(_this) {
        return function(event) {
          var price;
          price = parseFloat($(event.currentTarget).val());
          if (!isNaN(price)) {
            return $(event.currentTarget).val(price.toFixed(2));
          } else {
            return $(event.currentTarget).val(parseFloat(_this.model.get("price")).toFixed(2));
          }
        };
      })(this));
    }
  });
});
