var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/trade-center/trade-center-business-sell.tmpl', 'views/components/currency'], function(app, ItemView, _, template, formatCurrency) {
  var SellSection;
  SellSection = (function(superClass) {
    extend(SellSection, superClass);

    function SellSection() {
      return SellSection.__super__.constructor.apply(this, arguments);
    }

    SellSection.prototype.template = template;

    SellSection.prototype.data = {
      items: {
        pointer: 'tradeCenter.lotsCompany',
        companyId: function() {
          return this.options.companyId;
        }
      }
    };

    SellSection.prototype.events = {
      'click .js-lot-settings': 'lotSettings',
      'click .js-create-lot': 'createLot'
    };

    SellSection.prototype.lotSettings = function(event) {
      var lotId, lotInfo, lotsCollection;
      this.lockUI();
      lotId = event.currentTarget.getAttribute('data-lot-id');
      lotsCollection = new Backbone.Collection(this._data.items.exchanges);
      lotInfo = lotsCollection.get(lotId);
      return app.screens.dialog('trade-center/lot-settings', {
        model: lotInfo,
        companyId: this.options.companyId,
        commission: this._data.items.commission
      });
    };

    SellSection.prototype.createLot = function(event) {
      return app.screens.dialog('trade-center/sell-item-company', {
        companyId: this.options.companyId
      });
    };

    SellSection.prototype.onDomRefresh = function() {
      return [].forEach.call(this.el.querySelectorAll('.js-currency'), function(el) {
        if (el.dataset.precision) {
          return el.innerHTML = formatCurrency(el.innerHTML, void 0, el.dataset.precision);
        } else {
          return el.innerHTML = formatCurrency(el.innerHTML);
        }
      });
    };

    return SellSection;

  })(ItemView);
  return SellSection;
});
