var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['app', 'views/item-view', 'underscore', 'text!templates/tutor.tmpl', 'text!templates/tutor/tutor-blank.tmpl'], function(app, ItemView, _, template, template_blank) {
  var BasePulsate;
  BasePulsate = (function(superClass) {
    extend(BasePulsate, superClass);

    function BasePulsate() {
      return BasePulsate.__super__.constructor.apply(this, arguments);
    }

    BasePulsate.prototype.template = template_blank;

    BasePulsate.prototype.template_with_message = template;

    BasePulsate.prototype.events = {
      'click .js-next-screen': 'nextScreen',
      'click .o-click-area': 'somethingWrong',
      'click .js-skip-tutor': 'skipTutorial',
      'click .c-skip-tutor': 'skipTutorial',
      'click.hideComicBox .o-click-area': 'hideComicBox'
    };

    BasePulsate.prototype._controlSelector = null;

    BasePulsate.prototype._wrapperSelector = '.js-tutor-content-wrapper';

    BasePulsate.prototype._menuGroup = null;

    BasePulsate.prototype._hasPulsate = true;

    BasePulsate.prototype._rageClicks = 0;

    BasePulsate.prototype._rageClicksToSkip = 7;

    BasePulsate.prototype.initialize = function(options) {
      this.options = options;
      if (this.allow_html) {
        this.options.allow_html = true;
      }
      if (this.tutor_message) {
        this.template = this.template_with_message;
        this.options.message = app.tr(this.tutor_message);
      }
      if (this.tutor_message2) {
        this.template = this.template_with_message;
        this.options.message2 = app.tr(this.tutor_message2);
      }
      BasePulsate.__super__.initialize.call(this, this.options);
      this.listenTo(app.vent, 'modalDialog:show', function() {
        app.tutorial._checkAndSetVisibility;
        this.updateSkipTutorBtn();
        if (this.tutor_css) {
          this.setTutorCSS(this.tutor_css);
        }
        if (this.tutor_girl_css) {
          this.setTutorGirlCSS(this.tutor_girl_css);
        }
        if (this.tutor_show_quest) {
          return this.hideQuests(this.tutor_show_quest);
        }
      });
      return this._hasPulsate = true;
    };

    BasePulsate.prototype.somethingWrong = function(event) {
      if (!(event.currentTarget && event.currentTarget === event.target)) {
        return;
      }
      this._rageClicks++;
      if (this._rageClicks > this._rageClicksToSkip) {
        return this.skipTutorial(event);
      }
    };

    BasePulsate.prototype.nextScreen = function(event) {
      if (app.config.debug) {
        return console.log('next screen not specified!');
      }
    };

    BasePulsate.prototype.setTutorCSS = function(css) {
      return $('.o-click-area .c-tutor').css(css);
    };

    BasePulsate.prototype.setTutorGirlCSS = function(css) {
      return $('.o-click-area .c-tutor__girl').css(css);
    };

    BasePulsate.prototype.skipTutorial = function(event) {
      var msg;
      this.hideTutor();
      msg = app.tr('skip tutorial confirmation');
      return app.screens.modal('common/confirmation-popup', {
        needReload: false,
        msg: msg,
        callback: (function(_this) {
          return function() {
            _this.showTutor();
            app.tutorial.skipTutorial();
            return app.modalDialog.screen('tutor/skip');
          };
        })(this),
        backCallback: (function(_this) {
          return function() {
            app.screens.unlockUIAll();
            return _this.showTutor();
          };
        })(this)
      });
    };

    BasePulsate.prototype.onDomRefresh = function() {
      var $rect, css, cssObj, i, id, left, rect, ref, ref1, sel, top, wrapper;
      if (this.before_tutor_transforms) {
        ref = this.before_tutor_transforms;
        for (sel in ref) {
          css = ref[sel];
          ($(sel)).css(css);
        }
      }
      if (this._wrapperSelector === '.js-menu') {
        app.menu.open();
      }
      if (this._menuGroup != null) {
        app.menu.openGroup(this._menuGroup);
      }
      if (this._controlSelector != null) {
        $rect = $(this._controlSelector);
        if ($rect.length < 1) {
          return;
        }
        if (this._hasPulsate) {
          $rect.addClass('c-pulsate');
        }
        wrapper = document.querySelector(this._wrapperSelector);
        if (wrapper) {
          app.scrollElToCenter(wrapper, $rect.get(0));
        }
        if (this.tutor_show_quest) {
          this.hideQuests(this.tutor_show_quest);
        }
        for (id = i = 0, ref1 = $rect.length; 0 <= ref1 ? i < ref1 : i > ref1; id = 0 <= ref1 ? ++i : --i) {
          rect = $rect.get(id);
          left = rect.getBoundingClientRect().left;
          top = rect.getBoundingClientRect().top;
          cssObj = {
            width: $rect.outerWidth(),
            height: $rect.outerHeight(),
            top: top,
            left: left
          };
          $('.o-click-area').append($('<div />', {
            "class": 'js-next-screen',
            css: cssObj,
            attr: {
              'data-tutor-selector-id': rect.getAttribute('data-tutor-selector-id')
            }
          }));
        }
      }
      return this.updateSkipTutorBtn();
    };

    BasePulsate.prototype.updateSkipTutorBtn = function() {
      var $rectSkip, cssSkipObj, leftSkip, rectSkip, topSkip;
      $rectSkip = $('.c-skip-tutor-btn:visible');
      rectSkip = $rectSkip.get(0);
      if ($rectSkip.length < 1) {
        return;
      }
      leftSkip = rectSkip.getBoundingClientRect().left;
      topSkip = rectSkip.getBoundingClientRect().top;
      cssSkipObj = {
        width: $rectSkip.outerWidth() * 2,
        height: $rectSkip.outerHeight() * 2,
        top: topSkip - $rectSkip.outerHeight() / 2,
        left: leftSkip - $rectSkip.outerWidth() / 2
      };
      return $('.js-skip-tutor').css(cssSkipObj);
    };

    BasePulsate.prototype.hideTutor = function() {
      return app.modalDialog.hide();
    };

    BasePulsate.prototype.showTutor = function() {
      return app.modalDialog.show();
    };

    BasePulsate.prototype.hideComicBox = function() {
      return $('.c-tutor, .c-tutor__girl').css('display', 'none');
    };

    BasePulsate.prototype.setPulsate = function() {
      return $(this._controlSelector).addClass('c-pulsate');
    };

    BasePulsate.prototype.removePulsate = function() {
      this._hasPulsate = false;
      return $(this._controlSelector).removeClass('c-pulsate');
    };

    BasePulsate.prototype.hideQuests = function(exclude) {
      var card, el, qs, title;
      qs = $('#quests');
      el = qs.find('.js-quest-info[data-quest-cid=' + exclude + ']');
      card = el.parent();
      title = card.prev('.c-title');
      return qs.find('.c-title, .c-card, .c-panel, .c-separator').not(el).not(card).not(title).css('display', 'none');
    };

    return BasePulsate;

  })(ItemView);
  return BasePulsate;
});
