var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

define(['jquery', 'app', 'views/common/list-view', 'underscore', 'text!templates/users/search.tmpl', 'text!templates/users/blocks/search-list.tmpl', 'text!templates/users/blocks/search-element.tmpl', 'velocity-ui'], function($, app, CommonListView, _, template, listTemplate, elementTemplate) {
  var UserSearchView;
  UserSearchView = (function(superClass) {
    extend(UserSearchView, superClass);

    function UserSearchView() {
      return UserSearchView.__super__.constructor.apply(this, arguments);
    }

    UserSearchView.prototype.template = template;

    UserSearchView.prototype.listTemplate = _.template(listTemplate);

    UserSearchView.prototype.elementTemplate = _.template(elementTemplate);

    UserSearchView.prototype.events = {
      'click #js-main-list-load-more': 'onLoadMore',
      'click .js-online-switch': 'onOnlineSwitchChange',
      'change .js-name': 'onNameChange'
    };

    UserSearchView.prototype._usersList = [];

    UserSearchView.prototype._name = '';

    UserSearchView.prototype._onlineOnly = false;

    UserSearchView.prototype.initialize = function() {
      UserSearchView.__super__.initialize.apply(this, arguments);
      return this._renderElement = (function(template, helpers) {
        return function(user) {
          user.min_avatar = helpers.minAvatar(user.User.avatar);
          return template({
            user: user
          });
        };
      })(_.template(elementTemplate), this.mixinTemplateHelpers());
    };

    UserSearchView.prototype.serializeData = function() {
      var data;
      data = UserSearchView.__super__.serializeData.apply(this, arguments);
      data.renderElement = this._renderElement;
      return data;
    };

    UserSearchView.prototype.onProfileClick = function(event) {
      var hasProfile, userId;
      event.stopPropagation();
      this.lockUI();
      userId = event.currentTarget.getAttribute('data-id');
      hasProfile = event.currentTarget.getAttribute('data-has-profile') === 'true';
      if (hasProfile) {
        return app.screens.dialog('users/profile', {
          userId: userId
        });
      }
    };

    UserSearchView.prototype.onNameChange = function(event) {
      var name;
      name = event.currentTarget.value;
      name = name.trim();
      event.currentTarget.value = name;
      this._name = name;
      return this._reloadMainList(1);
    };

    UserSearchView.prototype.onOnlineSwitchChange = function(event) {
      var switcher;
      switcher = event.currentTarget;
      switcher.classList.toggle('o-switcher-small--active');
      this._onlineOnly = switcher.classList.contains('o-switcher-small--active');
      return this._reloadMainList(1);
    };

    UserSearchView.prototype.onLoadMore = function(event) {
      var page;
      page = Number(event.currentTarget.getAttribute('data-page'));
      return this._appendPageToMainList(page);
    };

    UserSearchView.prototype._getUserById = function(id) {
      var i, len, ref, resultUser, user;
      resultUser = null;
      ref = this._usersList;
      for (i = 0, len = ref.length; i < len; i++) {
        user = ref[i];
        if (user.User.id === id) {
          resultUser = user;
          break;
        }
      }
      return resultUser;
    };

    UserSearchView.prototype._reloadMainList = function(page) {
      var container, self;
      self = this;
      if (this._name.length < 3) {
        self.lockUI();
        self._clearAllLists().then(function() {
          return self.unlockUI();
        });
        return;
      }
      container = this.el.querySelector('#js-main-list-content');
      self.lockUI();
      self._showListLoader(container);
      return $.when(self._clearAllLists(), self._loadUsers(self._name, page, self._onlineOnly)).then(function(ign, data) {
        self.unlockUI();
        self._hideListLoader(container);
        self._usersList = data.users;
        return self._renderList(container, data.users, data.page, data.hasNext);
      });
    };

    UserSearchView.prototype._appendPageToMainList = function(page) {
      var container, self;
      container = this.el.querySelector('#js-main-list-content');
      self = this;
      self.lockUI();
      self._showListLoader(container);
      return self._loadUsers(self._name, page, self._onlineOnly).then(function(data) {
        self.unlockUI();
        self._hideListLoader(container);
        self._usersList = self._usersList.concat(data.users);
        return self._renderList(container, data.users, data.page, data.hasNext);
      });
    };

    UserSearchView.prototype._loadUsers = function(name, page, onlineOnly) {
      var deferred, self;
      deferred = $.Deferred();
      self = this;
      app.server.user.search({
        name: name,
        page: page,
        onlineOnly: !!onlineOnly,
        success: function(data) {
          var resultData;
          resultData = {
            users: data.users || []
          };
          resultData.page = page;
          resultData.hasNext = data.has_next || false;
          return deferred.resolve(resultData);
        },
        error: function() {
          return deferred.resolve({
            users: [],
            page: 1,
            hasNext: false
          });
        }
      });
      return deferred;
    };

    return UserSearchView;

  })(CommonListView);
  return UserSearchView;
});
